/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: blas2test.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

import java.lang.*;
import org.netlib.util.*;



public class Dblat2 {

// *
// *  Test program for the DOUBLE PRECISION Level 2 Blas.
// *
// *  The program must be driven by a short data file. The first 18 records
// *  of the file are read using list-directed input, the last 16 records
// *  are read using the format ( A6, L2 ). An annotated example of a data
// *  file can be obtained by deleting the first 3 characters from the
// *  following 34 lines:
// *  'DBLAT2.SUMM'     NAME OF SUMMARY OUTPUT FILE
// *  6                 UNIT NUMBER OF SUMMARY FILE
// *  'DBLAT2.SNAP'     NAME OF SNAPSHOT OUTPUT FILE
// *  -1                UNIT NUMBER OF SNAPSHOT FILE (NOT USED IF .LT. 0)
// *  F        LOGICAL FLAG, T TO REWIND SNAPSHOT FILE AFTER EACH RECORD.
// *  F        LOGICAL FLAG, T TO STOP ON FAILURES.
// *  T        LOGICAL FLAG, T TO TEST ERROR EXITS.
// *  16.0     THRESHOLD VALUE OF TEST RATIO
// *  6                 NUMBER OF VALUES OF N
// *  0 1 2 3 5 9       VALUES OF N
// *  4                 NUMBER OF VALUES OF K
// *  0 1 2 4           VALUES OF K
// *  4                 NUMBER OF VALUES OF INCX AND INCY
// *  1 2 -1 -2         VALUES OF INCX AND INCY
// *  3                 NUMBER OF VALUES OF ALPHA
// *  0.0 1.0 0.7       VALUES OF ALPHA
// *  3                 NUMBER OF VALUES OF BETA
// *  0.0 1.0 0.9       VALUES OF BETAC
// *  DGEMV  T PUT F FOR NO TEST. SAME COLUMNS.
// *  DGBMV  T PUT F FOR NO TEST. SAME COLUMNS.
// *  DSYMV  T PUT F FOR NO TEST. SAME COLUMNS.
// *  DSBMV  T PUT F FOR NO TEST. SAME COLUMNS.
// *  DSPMV  T PUT F FOR NO TEST. SAME COLUMNS.
// *  DTRMV  T PUT F FOR NO TEST. SAME COLUMNS.
// *  DTBMV  T PUT F FOR NO TEST. SAME COLUMNS.
// *  DTPMV  T PUT F FOR NO TEST. SAME COLUMNS.
// *  DTRSV  T PUT F FOR NO TEST. SAME COLUMNS.
// *  DTBSV  T PUT F FOR NO TEST. SAME COLUMNS.
// *  DTPSV  T PUT F FOR NO TEST. SAME COLUMNS.
// *  DGER   T PUT F FOR NO TEST. SAME COLUMNS.
// *  DSYR   T PUT F FOR NO TEST. SAME COLUMNS.
// *  DSPR   T PUT F FOR NO TEST. SAME COLUMNS.
// *  DSYR2  T PUT F FOR NO TEST. SAME COLUMNS.
// *  DSPR2  T PUT F FOR NO TEST. SAME COLUMNS.
// *
// *     See:
// *
// *        Dongarra J. J., Du Croz J. J., Hammarling S.  and Hanson R. J..
// *        An  extended  set of Fortran  Basic Linear Algebra Subprograms.
// *
// *        Technical  Memoranda  Nos. 41 (revision 3) and 81,  Mathematics
// *        and  Computer Science  Division,  Argonne  National Laboratory,
// *        9700 South Cass Avenue, Argonne, Illinois 60439, US.
// *
// *        Or
// *
// *        NAG  Technical Reports TR3/87 and TR4/87,  Numerical Algorithms
// *        Group  Ltd.,  NAG  Central  Office,  256  Banbury  Road, Oxford
// *        OX2 7DE, UK,  and  Numerical Algorithms Group Inc.,  1101  31st
// *        Street,  Suite 100,  Downers Grove,  Illinois 60515-1263,  USA.
// *
// *
// *  -- Written on 10-August-1987.
// *     Richard Hanson, Sandia National Labs.
// *     Jeremy Du Croz, NAG Central Office.
// *
// *     .. Parameters ..
static int nin= 5;
static int nsubs= 16;
static double zero= 0.0e0;
static double half= 0.5e0;
static double one= 1.0e0;
static int nmax= 65;
static int incmax= 2;
static int ninmax= 7;
static int nidmax= 9;
static int nkbmax= 7;
static int nalmax= 7;
static int nbemax= 7;
// *     .. Local Scalars ..
static double eps= 0.0;
static doubleW err= new doubleW(0.0);
static double thresh= 0.0;
static int i= 0;
static int isnum= 0;
static int j= 0;
static int n= 0;
static int nalf= 0;
static int nbet= 0;
static int nidim= 0;
static int ninc= 0;
static int nkb= 0;
static int nout= 0;
static int ntra= 0;
static booleanW fatal= new booleanW(false);
static boolean ltestt= false;
static boolean rewi= false;
static boolean same= false;
static boolean sfatal= false;
static boolean trace= false;
static boolean tsterr= false;
static String trans= new String(" ");
static String snamet= new String("      ");
static String snaps= new String("                                ");
static String summry= new String("                                ");
// *     .. Local Arrays ..
static double [] a= new double[(nmax) * (nmax)];
static double [] aa= new double[(nmax*nmax)];
static double [] alf= new double[(nalmax)];
static double [] as= new double[(nmax*nmax)];
static double [] bet= new double[(nbemax)];
static double [] g= new double[(nmax)];
static double [] x= new double[(nmax)];
static double [] xs= new double[(nmax*incmax)];
static double [] xx= new double[(nmax*incmax)];
static double [] y= new double[(nmax)];
static double [] ys= new double[(nmax*incmax)];
static double [] yt= new double[(nmax)];
static double [] yy= new double[(nmax*incmax)];
static double [] z= new double[(2*nmax)];
static int [] idim= new int[(nidmax)];
static int [] inc= new int[(ninmax)];
static int [] kb= new int[(nkbmax)];
static boolean [] ltest= new boolean[(nsubs)];
// *     .. External Functions ..
// *     .. External Subroutines ..
// *     .. Intrinsic Functions ..
// *     .. Scalars in Common ..
// *     .. Common blocks ..
// *     .. Data statements ..
static String [] snames = {"DGEMV " 
, "DGBMV " , "DSYMV " , "DSBMV " , "DSPMV " , "DTRMV " 
, "DTBMV " , "DTPMV " , "DTRSV " , "DTBSV " , "DTPSV " 
, "DGER  " , "DSYR  " , "DSPR  " , "DSYR2 " , "DSPR2 " 
};
// *     .. Executable Statements ..
// *
// *     Read name and unit number for summary output file and open file.
// *

public static void main (String [] args)  {

  EasyIn _f2j_in = new EasyIn();
summry = _f2j_in.readChars(32);
_f2j_in.skipRemaining();
nout = _f2j_in.readInt();
_f2j_in.skipRemaining();
// *     OPEN( NOUT, FILE = SUMMRY, STATUS = 'NEW' )
blas2test_infoc.nout_noutc = nout;
// *
// *     Read name and unit number for snapshot output file and open file.
// *
snaps = _f2j_in.readChars(32);
_f2j_in.skipRemaining();
ntra = _f2j_in.readInt();
_f2j_in.skipRemaining();
trace = ntra >= 0;
// *     IF( TRACE )THEN
// *        OPEN( NTRA, FILE = SNAPS, STATUS = 'NEW' )
// *     END IF
// *     Read the flag that directs rewinding of the snapshot file.
rewi = _f2j_in.readBoolean();
_f2j_in.skipRemaining();
rewi = rewi && trace;
// *     Read the flag that directs stopping on any failure.
sfatal = _f2j_in.readBoolean();
_f2j_in.skipRemaining();
// *     Read the flag that indicates whether error exits are to be tested.
tsterr = _f2j_in.readBoolean();
_f2j_in.skipRemaining();
// *     Read the threshold value of the test ratio
thresh = _f2j_in.readDouble();
_f2j_in.skipRemaining();
// *
// *     Read and check the parameter values for the tests.
// *
// *     Values of N
nidim = _f2j_in.readInt();
_f2j_in.skipRemaining();
if (nidim < 1 || nidim > nidmax)  {
    System.out.println(" NUMBER OF VALUES OF "  + ("N") + " "  + " IS LESS THAN 1 OR GREATER "  + "THAN "  + (nidmax) + " " );
Dummy.go_to("Dblat2",230);
}              // Close if()
for(i = 1; i <= nidim; i++)
idim[(i)- 1] = _f2j_in.readInt();
_f2j_in.skipRemaining();
{
forloop10:
for (i = 1; i <= nidim; i++) {
if (idim[(i)- 1] < 0 || idim[(i)- 1] > nmax)  {
    System.out.println(" VALUE OF N IS LESS THAN 0 OR GREATER THAN "  + (nmax) + " " );
Dummy.go_to("Dblat2",230);
}              // Close if()
Dummy.label("Dblat2",10);
}              //  Close for() loop. 
}
// *     Values of K
nkb = _f2j_in.readInt();
_f2j_in.skipRemaining();
if (nkb < 1 || nkb > nkbmax)  {
    System.out.println(" NUMBER OF VALUES OF "  + ("K") + " "  + " IS LESS THAN 1 OR GREATER "  + "THAN "  + (nkbmax) + " " );
Dummy.go_to("Dblat2",230);
}              // Close if()
for(i = 1; i <= nkb; i++)
kb[(i)- 1] = _f2j_in.readInt();
_f2j_in.skipRemaining();
{
forloop20:
for (i = 1; i <= nkb; i++) {
if (kb[(i)- 1] < 0)  {
    System.out.println(" VALUE OF K IS LESS THAN 0" );
Dummy.go_to("Dblat2",230);
}              // Close if()
Dummy.label("Dblat2",20);
}              //  Close for() loop. 
}
// *     Values of INCX and INCY
ninc = _f2j_in.readInt();
_f2j_in.skipRemaining();
if (ninc < 1 || ninc > ninmax)  {
    System.out.println(" NUMBER OF VALUES OF "  + ("INCX AND INCY") + " "  + " IS LESS THAN 1 OR GREATER "  + "THAN "  + (ninmax) + " " );
Dummy.go_to("Dblat2",230);
}              // Close if()
for(i = 1; i <= ninc; i++)
inc[(i)- 1] = _f2j_in.readInt();
_f2j_in.skipRemaining();
{
forloop30:
for (i = 1; i <= ninc; i++) {
if (inc[(i)- 1] == 0 || Math.abs(inc[(i)- 1]) > incmax)  {
    System.out.println(" ABSOLUTE VALUE OF INCX OR INCY IS 0 OR GREATER THAN "  + (incmax) + " " );
Dummy.go_to("Dblat2",230);
}              // Close if()
Dummy.label("Dblat2",30);
}              //  Close for() loop. 
}
// *     Values of ALPHA
nalf = _f2j_in.readInt();
_f2j_in.skipRemaining();
if (nalf < 1 || nalf > nalmax)  {
    System.out.println(" NUMBER OF VALUES OF "  + ("ALPHA") + " "  + " IS LESS THAN 1 OR GREATER "  + "THAN "  + (nalmax) + " " );
Dummy.go_to("Dblat2",230);
}              // Close if()
for(i = 1; i <= nalf; i++)
alf[(i)- 1] = _f2j_in.readDouble();
_f2j_in.skipRemaining();
// *     Values of BETA
nbet = _f2j_in.readInt();
_f2j_in.skipRemaining();
if (nbet < 1 || nbet > nbemax)  {
    System.out.println(" NUMBER OF VALUES OF "  + ("BETA") + " "  + " IS LESS THAN 1 OR GREATER "  + "THAN "  + (nbemax) + " " );
Dummy.go_to("Dblat2",230);
}              // Close if()
for(i = 1; i <= nbet; i++)
bet[(i)- 1] = _f2j_in.readDouble();
_f2j_in.skipRemaining();
// *
// *     Report values of parameters.
// *
System.out.println(" TESTS OF THE DOUBLE PRECISION LEVEL 2 BLAS"  + "\n\n"  + " THE F"  + "OLLOWING PARAMETER VALUES WILL BE USED:" );
System.out.print("");
for(i = 1; i <= nidim; i++)
  System.out.print(idim[(i)- 1] + " ");

System.out.println();
System.out.print("");
for(i = 1; i <= nkb; i++)
  System.out.print(kb[(i)- 1] + " ");

System.out.println();
System.out.print("");
for(i = 1; i <= ninc; i++)
  System.out.print(inc[(i)- 1] + " ");

System.out.println();
System.out.print("");
for(i = 1; i <= nalf; i++)
  System.out.print(alf[(i)- 1] + " ");

System.out.println();
System.out.print("");
for(i = 1; i <= nbet; i++)
  System.out.print(bet[(i)- 1] + " ");

System.out.println();
if (!tsterr)  {
    System.out.println();
System.out.println(" ERROR-EXITS WILL NOT BE TESTED" );
}              // Close if()
System.out.println();
System.out.println(" ROUTINES PASS COMPUTATIONAL TESTS IF TEST RATIO IS LES"  + "S THAN"  + (thresh) + " " );
System.out.println();
// *
// *     Read names of subroutines and flags which indicate
// *     whether they are to be tested.
// *
{
forloop40:
for (i = 1; i <= nsubs; i++) {
ltest[(i)- 1] = false;
Dummy.label("Dblat2",40);
}              //  Close for() loop. 
}
label50:
   Dummy.label("Dblat2",50);
try {
snamet = _f2j_in.readchars(6);
ltestt = _f2j_in.readboolean();
_f2j_in.skipRemaining();
} catch (java.io.IOException e) {
Dummy.go_to("Dblat2",80);
}
{
forloop60:
for (i = 1; i <= nsubs; i++) {
if (snamet.trim().equalsIgnoreCase(snames[(i)- 1].trim()))  
    Dummy.go_to("Dblat2",70);
Dummy.label("Dblat2",60);
}              //  Close for() loop. 
}
System.out.println(" SUBPROGRAM NAME "  + (snamet) + " "  + " NOT RECOGNIZED"  + "\n"  + " ******* T"  + "ESTS ABANDONED *******" );
System.exit(1);
label70:
   Dummy.label("Dblat2",70);
ltest[(i)- 1] = ltestt;
Dummy.go_to("Dblat2",50);
// *
label80:
   Dummy.label("Dblat2",80);
// WARNING: Unimplemented statement in Fortran source.
// *
// *     Compute EPS (the machine precision).
// *
eps = one;
label90:
   Dummy.label("Dblat2",90);
if (Ddiff.ddiff(one+eps,one) == zero)  
    Dummy.go_to("Dblat2",100);
eps = half*eps;
Dummy.go_to("Dblat2",90);
label100:
   Dummy.label("Dblat2",100);
eps = eps+eps;
System.out.println(" RELATIVE MACHINE PRECISION IS TAKEN TO BE"  + (eps) + " " );
// *
// *     Check the reliability of DMVCH using exact data.
// *
n = (int)(Math.min(32, nmax) );
{
forloop120:
for (j = 1; j <= n; j++) {
{
forloop110:
for (i = 1; i <= n; i++) {
a[(i)- 1+(j- 1)*nmax] = Math.max(i-j+1, 0) ;
Dummy.label("Dblat2",110);
}              //  Close for() loop. 
}
x[(j)- 1] = (double)(j);
y[(j)- 1] = zero;
Dummy.label("Dblat2",120);
}              //  Close for() loop. 
}
{
forloop130:
for (j = 1; j <= n; j++) {
yy[(j)- 1] = (double)(j*((j+1)*j)/2-((j+1)*j*(j-1))/3);
Dummy.label("Dblat2",130);
}              //  Close for() loop. 
}
// *     YY holds the exact result. On exit from DMVCH YT holds
// *     the result computed by DMVCH.
trans = "N";
Dmvch.dmvch(trans,n,n,one,a,0,nmax,x,0,1,zero,y,0,1,yt,0,g,0,yy,0,eps,err,fatal,nout,true);
same = Lde.lde(yy,0,yt,0,n);
if (!same || err.val != zero)  {
    System.out.println(" ERROR IN DMVCH -  IN-LINE DOT PRODUCTS ARE BEING EVALU"  + "ATED WRONGLY."  + "\n"  + " DMVCH WAS CALLED WITH TRANS = "  + (trans) + " "  + " AND RETURNED SAME = "  + (same) + " "  + " AND ERR = "  + (err.val) + " "  + "."  + "\n"  + " THIS MAY BE DUE TO FAULTS IN THE ARITHMETIC OR THE COMPILER."  + "\n"  + " ******* TESTS ABANDONED *******" );
System.exit(1);
}              // Close if()
trans = "T";
Dmvch.dmvch(trans,n,n,one,a,0,nmax,x,0,-1,zero,y,0,-1,yt,0,g,0,yy,0,eps,err,fatal,nout,true);
same = Lde.lde(yy,0,yt,0,n);
if (!same || err.val != zero)  {
    System.out.println(" ERROR IN DMVCH -  IN-LINE DOT PRODUCTS ARE BEING EVALU"  + "ATED WRONGLY."  + "\n"  + " DMVCH WAS CALLED WITH TRANS = "  + (trans) + " "  + " AND RETURNED SAME = "  + (same) + " "  + " AND ERR = "  + (err.val) + " "  + "."  + "\n"  + " THIS MAY BE DUE TO FAULTS IN THE ARITHMETIC OR THE COMPILER."  + "\n"  + " ******* TESTS ABANDONED *******" );
System.exit(1);
}              // Close if()
// *
// *     Test each subroutine in turn.
// *
{
forloop210:
for (isnum = 1; isnum <= nsubs; isnum++) {
System.out.println();
if (!ltest[(isnum)- 1])  {
    // *           Subprogram is not to be tested.
System.out.println(" " + (snames[(isnum)- 1]) + " "  + " WAS NOT TESTED" );
}              // Close if()
else  {
  blas2test_srnamc.srnamt = snames[(isnum)- 1];
// *           Test error exits.
if (tsterr)  {
    Dchke.dchke(isnum,snames[(isnum)- 1],nout);
System.out.println();
}              // Close if()
// *           Test computations.
blas2test_infoc.infot = 0;
blas2test_infoc.ok.val = true;
fatal.val = false;
if (isnum == 1) 
  Dummy.go_to("Dblat2",140);
else if (isnum == 2) 
  Dummy.go_to("Dblat2",140);
else if (isnum == 3) 
  Dummy.go_to("Dblat2",150);
else if (isnum == 4) 
  Dummy.go_to("Dblat2",150);
else if (isnum == 5) 
  Dummy.go_to("Dblat2",150);
else if (isnum == 6) 
  Dummy.go_to("Dblat2",160);
else if (isnum == 7) 
  Dummy.go_to("Dblat2",160);
else if (isnum == 8) 
  Dummy.go_to("Dblat2",160);
else if (isnum == 9) 
  Dummy.go_to("Dblat2",160);
else if (isnum == 10) 
  Dummy.go_to("Dblat2",160);
else if (isnum == 11) 
  Dummy.go_to("Dblat2",160);
else if (isnum == 12) 
  Dummy.go_to("Dblat2",170);
else if (isnum == 13) 
  Dummy.go_to("Dblat2",180);
else if (isnum == 14) 
  Dummy.go_to("Dblat2",180);
else if (isnum == 15) 
  Dummy.go_to("Dblat2",190);
else if (isnum == 16) 
  Dummy.go_to("Dblat2",190);
// *           Test DGEMV, 01, and DGBMV, 02.
label140:
   Dummy.label("Dblat2",140);
Dchk1.dchk1(snames[(isnum)- 1],eps,thresh,nout,ntra,trace,rewi,fatal,nidim,idim,0,nkb,kb,0,nalf,alf,0,nbet,bet,0,ninc,inc,0,nmax,incmax,a,0,aa,0,as,0,x,0,xx,0,xs,0,y,0,yy,0,ys,0,yt,0,g,0);
Dummy.go_to("Dblat2",200);
// *           Test DSYMV, 03, DSBMV, 04, and DSPMV, 05.
label150:
   Dummy.label("Dblat2",150);
Dchk2.dchk2(snames[(isnum)- 1],eps,thresh,nout,ntra,trace,rewi,fatal,nidim,idim,0,nkb,kb,0,nalf,alf,0,nbet,bet,0,ninc,inc,0,nmax,incmax,a,0,aa,0,as,0,x,0,xx,0,xs,0,y,0,yy,0,ys,0,yt,0,g,0);
Dummy.go_to("Dblat2",200);
// *           Test DTRMV, 06, DTBMV, 07, DTPMV, 08,
// *           DTRSV, 09, DTBSV, 10, and DTPSV, 11.
label160:
   Dummy.label("Dblat2",160);
Dchk3.dchk3(snames[(isnum)- 1],eps,thresh,nout,ntra,trace,rewi,fatal,nidim,idim,0,nkb,kb,0,ninc,inc,0,nmax,incmax,a,0,aa,0,as,0,y,0,yy,0,ys,0,yt,0,g,0,z,0);
Dummy.go_to("Dblat2",200);
// *           Test DGER, 12.
label170:
   Dummy.label("Dblat2",170);
Dchk4.dchk4(snames[(isnum)- 1],eps,thresh,nout,ntra,trace,rewi,fatal,nidim,idim,0,nalf,alf,0,ninc,inc,0,nmax,incmax,a,0,aa,0,as,0,x,0,xx,0,xs,0,y,0,yy,0,ys,0,yt,0,g,0,z,0);
Dummy.go_to("Dblat2",200);
// *           Test DSYR, 13, and DSPR, 14.
label180:
   Dummy.label("Dblat2",180);
Dchk5.dchk5(snames[(isnum)- 1],eps,thresh,nout,ntra,trace,rewi,fatal,nidim,idim,0,nalf,alf,0,ninc,inc,0,nmax,incmax,a,0,aa,0,as,0,x,0,xx,0,xs,0,y,0,yy,0,ys,0,yt,0,g,0,z,0);
Dummy.go_to("Dblat2",200);
// *           Test DSYR2, 15, and DSPR2, 16.
label190:
   Dummy.label("Dblat2",190);
Dchk6.dchk6(snames[(isnum)- 1],eps,thresh,nout,ntra,trace,rewi,fatal,nidim,idim,0,nalf,alf,0,ninc,inc,0,nmax,incmax,a,0,aa,0,as,0,x,0,xx,0,xs,0,y,0,yy,0,ys,0,yt,0,g,0,z,0);
// *
label200:
   Dummy.label("Dblat2",200);
if (fatal.val && sfatal)  
    Dummy.go_to("Dblat2",220);
}              //  Close else.
Dummy.label("Dblat2",210);
}              //  Close for() loop. 
}
System.out.println("\n"  + " END OF TESTS" );
Dummy.go_to("Dblat2",240);
// *
label220:
   Dummy.label("Dblat2",220);
System.out.println("\n"  + " ******* FATAL ERROR - TESTS ABANDONED *******" );
Dummy.go_to("Dblat2",240);
// *
label230:
   Dummy.label("Dblat2",230);
System.out.println(" AMEND DATA FILE OR INCREASE ARRAY SIZES IN PROGRAM"  + "\n"  + " ******* TESTS ABANDONED *******" );
// *
label240:
   Dummy.label("Dblat2",240);
if (trace)  
    // WARNING: Unimplemented statement in Fortran source.
// WARNING: Unimplemented statement in Fortran source.
System.exit(1);
// *
// *
// *     End of DBLAT2.
// *
Dummy.label("Dblat2",999999);
return;
   }
} // End class.
