/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: blas2test.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

import java.lang.*;
import org.netlib.util.*;

import org.netlib.blas.*;


public class Dchk6 {

// *
// *  Tests DSYR2 and DSPR2.
// *
// *  Auxiliary routine for test program for Level 2 Blas.
// *
// *  -- Written on 10-August-1987.
// *     Richard Hanson, Sandia National Labs.
// *     Jeremy Du Croz, NAG Central Office.
// *
// *     .. Parameters ..
static double zero= 0.0e0;
static double half= 0.5e0;
static double one= 1.0e0;
// *     .. Scalar Arguments ..
// *     .. Array Arguments ..
// *     .. Local Scalars ..
static double alpha= 0.0;
static double als= 0.0;
static doubleW err= new doubleW(0.0);
static double errmax= 0.0;
static double transl= 0.0;
static int i= 0;
static int ia= 0;
static int ic= 0;
static int in= 0;
static int incx= 0;
static int incxs= 0;
static int incy= 0;
static int incys= 0;
static int ix= 0;
static int iy= 0;
static int j= 0;
static int ja= 0;
static int jj= 0;
static int laa= 0;
static int lda= 0;
static int ldas= 0;
static int lj= 0;
static int lx= 0;
static int ly= 0;
static int n= 0;
static int nargs= 0;
static int nc= 0;
static int ns= 0;
static boolean full= false;
static boolean Null= false;
static boolean packed= false;
static booleanW reset= new booleanW(false);
static boolean same= false;
static boolean upper= false;
static String uplo= new String(" ");
static String uplos= new String(" ");
// *     .. Local Arrays ..
static double [] w= new double[(2)];
static boolean [] isame= new boolean[(13)];
// *     .. External Functions ..
// *     .. External Subroutines ..
// *     .. Intrinsic Functions ..
// *     .. Scalars in Common ..
// *     .. Common blocks ..
// *     .. Data statements ..
static String ich = new String("UL");
// *     .. Executable Statements ..

public static void dchk6 (String sname,
double eps,
double thresh,
int nout,
int ntra,
boolean trace,
boolean rewi,
booleanW fatal,
int nidim,
int [] idim, int _idim_offset,
int nalf,
double [] alf, int _alf_offset,
int ninc,
int [] inc, int _inc_offset,
int nmax,
int incmax,
double [] a, int _a_offset,
double [] aa, int _aa_offset,
double [] as, int _as_offset,
double [] x, int _x_offset,
double [] xx, int _xx_offset,
double [] xs, int _xs_offset,
double [] y, int _y_offset,
double [] yy, int _yy_offset,
double [] ys, int _ys_offset,
double [] yt, int _yt_offset,
double [] g, int _g_offset,
double [] z, int _z_offset)  {

full = sname.substring((3)-1,3).trim().equalsIgnoreCase("Y".trim());
packed = sname.substring((3)-1,3).trim().equalsIgnoreCase("P".trim());
// *     Define the number of arguments.
if (full)  {
    nargs = 9;
}              // Close if()
else if (packed)  {
    nargs = 8;
}              // Close else if()
// *
nc = 0;
reset.val = true;
errmax = zero;
// *
{
forloop140:
for (in = 1; in <= nidim; in++) {
n = idim[(in)- 1+ _idim_offset];
// *        Set LDA to 1 more than minimum value if room.
lda = n;
if (lda < nmax)  
    lda = lda+1;
// *        Skip tests if not enough room.
if (lda > nmax)  
    continue forloop140;
if (packed)  {
    laa = (n*(n+1))/2;
}              // Close if()
else  {
  laa = lda*n;
}              //  Close else.
// *
{
forloop130:
for (ic = 1; ic <= 2; ic++) {
uplo = ich.substring((ic)-1,ic);
upper = uplo.trim().equalsIgnoreCase("U".trim());
// *
{
forloop120:
for (ix = 1; ix <= ninc; ix++) {
incx = inc[(ix)- 1+ _inc_offset];
lx = (int)(Math.abs(incx)*n);
// *
// *              Generate the vector X.
// *
transl = half;
Dmake.dmake("GE"," "," ",1,n,x,_x_offset,1,xx,_xx_offset,(int) ( Math.abs(incx)),0,n-1,reset,transl);
if (n > 1)  {
    x[(n/2)- 1+ _x_offset] = zero;
xx[(int)((1+Math.abs(incx)*(n/2-1))- 1+ _xx_offset)] = zero;
}              // Close if()
// *
{
forloop110:
for (iy = 1; iy <= ninc; iy++) {
incy = inc[(iy)- 1+ _inc_offset];
ly = (int)(Math.abs(incy)*n);
// *
// *                 Generate the vector Y.
// *
transl = zero;
Dmake.dmake("GE"," "," ",1,n,y,_y_offset,1,yy,_yy_offset,(int) ( Math.abs(incy)),0,n-1,reset,transl);
if (n > 1)  {
    y[(n/2)- 1+ _y_offset] = zero;
yy[(int)((1+Math.abs(incy)*(n/2-1))- 1+ _yy_offset)] = zero;
}              // Close if()
// *
{
forloop100:
for (ia = 1; ia <= nalf; ia++) {
alpha = alf[(ia)- 1+ _alf_offset];
Null = n <= 0 || alpha == zero;
// *
// *                    Generate the matrix A.
// *
transl = zero;
Dmake.dmake(sname.substring((2)-1,3),uplo," ",n,n,a,_a_offset,nmax,aa,_aa_offset,lda,n-1,n-1,reset,transl);
// *
nc = nc+1;
// *
// *                    Save every datum before calling the subroutine.
// *
uplos = uplo;
ns = n;
als = alpha;
{
forloop10:
for (i = 1; i <= laa; i++) {
as[(i)- 1+ _as_offset] = aa[(i)- 1+ _aa_offset];
Dummy.label("Dchk6",10);
}              //  Close for() loop. 
}
ldas = lda;
{
forloop20:
for (i = 1; i <= lx; i++) {
xs[(i)- 1+ _xs_offset] = xx[(i)- 1+ _xx_offset];
Dummy.label("Dchk6",20);
}              //  Close for() loop. 
}
incxs = incx;
{
forloop30:
for (i = 1; i <= ly; i++) {
ys[(i)- 1+ _ys_offset] = yy[(i)- 1+ _yy_offset];
Dummy.label("Dchk6",30);
}              //  Close for() loop. 
}
incys = incy;
// *
// *                    Call the subroutine.
// *
if (full)  {
    if (trace)  
    System.out.println(" " + (nc) + " "  + ": "  + (sname) + " "  + "(\'"  + (uplo) + " "  + "\',"  + (n) + " "  + ","  + (alpha) + " "  + ", X,"  + (incx) + " "  + ", Y,"  + (incy) + " "  + ", A,"  + (lda) + " "  + ")                  ." );
// *                       IF( REWI )
// *    $                     REWIND NTRA
Dsyr2.dsyr2(uplo,n,alpha,xx,_xx_offset,incx,yy,_yy_offset,incy,aa,_aa_offset,lda);
}              // Close if()
else if (packed)  {
    if (trace)  
    System.out.println(" " + (nc) + " "  + ": "  + (sname) + " "  + "(\'"  + (uplo) + " "  + "\',"  + (n) + " "  + ","  + (alpha) + " "  + ", X,"  + (incx) + " "  + ", Y,"  + (incy) + " "  + ", AP)                     ." );
// *                       IF( REWI )
// *    $                     REWIND NTRA
Dspr2.dspr2(uplo,n,alpha,xx,_xx_offset,incx,yy,_yy_offset,incy,aa,_aa_offset);
}              // Close else if()
// *
// *                    Check if error-exit was taken incorrectly.
// *
if (!blas2test_infoc.ok.val)  {
    System.out.println(" ******* FATAL ERROR - ERROR-EXIT TAKEN ON VALID CALL *"  + "******" );
fatal.val = true;
Dummy.go_to("Dchk6",160);
}              // Close if()
// *
// *                    See what data changed inside subroutines.
// *
isame[(1)- 1] = uplo.trim().equalsIgnoreCase(uplos.trim());
isame[(2)- 1] = ns == n;
isame[(3)- 1] = als == alpha;
isame[(4)- 1] = Lde.lde(xs,_xs_offset,xx,_xx_offset,lx);
isame[(5)- 1] = incxs == incx;
isame[(6)- 1] = Lde.lde(ys,_ys_offset,yy,_yy_offset,ly);
isame[(7)- 1] = incys == incy;
if (Null)  {
    isame[(8)- 1] = Lde.lde(as,_as_offset,aa,_aa_offset,laa);
}              // Close if()
else  {
  isame[(8)- 1] = Lderes.lderes(sname.substring((2)-1,3),uplo,n,n,as,_as_offset,aa,_aa_offset,lda);
}              //  Close else.
if (!packed)  {
    isame[(9)- 1] = ldas == lda;
}              // Close if()
// *
// *                    If data was incorrectly changed, report and return.
// *
same = true;
{
forloop40:
for (i = 1; i <= nargs; i++) {
same = same && isame[(i)- 1];
if (!isame[(i)- 1])  
    System.out.println(" ******* FATAL ERROR - PARAMETER NUMBER "  + (i) + " "  + " WAS CH"  + "ANGED INCORRECTLY *******" );
Dummy.label("Dchk6",40);
}              //  Close for() loop. 
}
if (!same)  {
    fatal.val = true;
Dummy.go_to("Dchk6",160);
}              // Close if()
// *
if (!Null)  {
    // *
// *                       Check the result column by column.
// *
if (incx > 0)  {
    {
forloop50:
for (i = 1; i <= n; i++) {
z[(i)- 1+(1- 1)*nmax+ _z_offset] = x[(i)- 1+ _x_offset];
Dummy.label("Dchk6",50);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  {
forloop60:
for (i = 1; i <= n; i++) {
z[(i)- 1+(1- 1)*nmax+ _z_offset] = x[(n-i+1)- 1+ _x_offset];
Dummy.label("Dchk6",60);
}              //  Close for() loop. 
}
}              //  Close else.
if (incy > 0)  {
    {
forloop70:
for (i = 1; i <= n; i++) {
z[(i)- 1+(2- 1)*nmax+ _z_offset] = y[(i)- 1+ _y_offset];
Dummy.label("Dchk6",70);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  {
forloop80:
for (i = 1; i <= n; i++) {
z[(i)- 1+(2- 1)*nmax+ _z_offset] = y[(n-i+1)- 1+ _y_offset];
Dummy.label("Dchk6",80);
}              //  Close for() loop. 
}
}              //  Close else.
ja = 1;
{
forloop90:
for (j = 1; j <= n; j++) {
w[(1)- 1] = z[(j)- 1+(2- 1)*nmax+ _z_offset];
w[(2)- 1] = z[(j)- 1+(1- 1)*nmax+ _z_offset];
if (upper)  {
    jj = 1;
lj = j;
}              // Close if()
else  {
  jj = j;
lj = n-j+1;
}              //  Close else.
Dmvch.dmvch("N",lj,2,alpha,z,(jj)- 1+(1- 1)*nmax+ _z_offset,nmax,w,0,1,one,a,(jj)- 1+(j- 1)*nmax+ _a_offset,1,yt,_yt_offset,g,_g_offset,aa,(ja)- 1+ _aa_offset,eps,err,fatal,nout,true);
if (full)  {
    if (upper)  {
    ja = ja+lda;
}              // Close if()
else  {
  ja = ja+lda+1;
}              //  Close else.
}              // Close if()
else  {
  ja = ja+lj;
}              //  Close else.
errmax = Math.max(errmax, err.val) ;
// *                          If got really bad answer, report and return.
if (fatal.val)  
    Dummy.go_to("Dchk6",150);
Dummy.label("Dchk6",90);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  // *                       Avoid repeating tests with N.le.0.
if (n <= 0)  
    continue forloop140;
}              //  Close else.
// *
Dummy.label("Dchk6",100);
}              //  Close for() loop. 
}
// *
Dummy.label("Dchk6",110);
}              //  Close for() loop. 
}
// *
Dummy.label("Dchk6",120);
}              //  Close for() loop. 
}
// *
Dummy.label("Dchk6",130);
}              //  Close for() loop. 
}
// *
Dummy.label("Dchk6",140);
}              //  Close for() loop. 
}
// *
// *     Report result.
// *
if (errmax < thresh)  {
    System.out.println(" "  + (sname) + " "  + " PASSED THE COMPUTATIONAL TESTS ("  + (nc) + " "  + " CALL"  + "S)" );
}              // Close if()
else  {
  System.out.println(" "  + (sname) + " "  + " COMPLETED THE COMPUTATIONAL TESTS ("  + (nc) + " "  + " C"  + "ALLS)"  + "\n"  + " ******* BUT WITH MAXIMUM TEST RATIO"  + (errmax) + " "  + " - SUSPECT *******" );
}              //  Close else.
Dummy.go_to("Dchk6",170);
// *
label150:
   Dummy.label("Dchk6",150);
System.out.println("      THESE ARE THE RESULTS FOR COLUMN "  + (j) + " " );
// *
label160:
   Dummy.label("Dchk6",160);
System.out.println(" ******* "  + (sname) + " "  + " FAILED ON CALL NUMBER:" );
if (full)  {
    System.out.println(" " + (nc) + " "  + ": "  + (sname) + " "  + "(\'"  + (uplo) + " "  + "\',"  + (n) + " "  + ","  + (alpha) + " "  + ", X,"  + (incx) + " "  + ", Y,"  + (incy) + " "  + ", A,"  + (lda) + " "  + ")                  ." );
}              // Close if()
else if (packed)  {
    System.out.println(" " + (nc) + " "  + ": "  + (sname) + " "  + "(\'"  + (uplo) + " "  + "\',"  + (n) + " "  + ","  + (alpha) + " "  + ", X,"  + (incx) + " "  + ", Y,"  + (incy) + " "  + ", AP)                     ." );
}              // Close else if()
// *
label170:
   Dummy.label("Dchk6",170);
Dummy.go_to("Dchk6",999999);
// *
// *
// *     End of DCHK6.
// *
Dummy.label("Dchk6",999999);
return;
   }
} // End class.
