/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: eigtest.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

import java.lang.*;
import org.netlib.util.*;
import org.netlib.lapack.*;




public class Dchkbb {

// *
// *  -- LAPACK test routine (release 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DCHKBB tests the reduction of a general real rectangular band
// *  matrix to bidiagonal form.
// *
// *  DGBBRD factors a general band matrix A as  Q B P* , where * means
// *  transpose, B is upper bidiagonal, and Q and P are orthogonal;
// *  DGBBRD can also overwrite a given matrix C with Q* C .
// *
// *  For each pair of matrix dimensions (M,N) and each selected matrix
// *  type, an M by N matrix A and an M by NRHS matrix C are generated.
// *  The problem dimensions are as follows
// *     A:          M x N
// *     Q:          M x M
// *     P:          N x N
// *     B:          min(M,N) x min(M,N)
// *     C:          M x NRHS
// *
// *  For each generated matrix, 4 tests are performed:
// *
// *  (1)   | A - Q B PT | / ( |A| max(M,N) ulp ), PT = P'
// *
// *  (2)   | I - Q' Q | / ( M ulp )
// *
// *  (3)   | I - PT PT' | / ( N ulp )
// *
// *  (4)   | Y - Q' C | / ( |Y| max(M,NRHS) ulp ), where Y = Q' C.
// *
// *  The "types" are specified by a logical array DOTYPE( 1:NTYPES );
// *  if DOTYPE(j) is .TRUE., then matrix type "j" will be generated.
// *  Currently, the list of possible types is:
// *
// *  The possible matrix types are
// *
// *  (1)  The zero matrix.
// *  (2)  The identity matrix.
// *
// *  (3)  A diagonal matrix with evenly spaced entries
// *       1, ..., ULP  and random signs.
// *       (ULP = (first number larger than 1) - 1 )
// *  (4)  A diagonal matrix with geometrically spaced entries
// *       1, ..., ULP  and random signs.
// *  (5)  A diagonal matrix with "clustered" entries 1, ULP, ..., ULP
// *       and random signs.
// *
// *  (6)  Same as (3), but multiplied by SQRT( overflow threshold )
// *  (7)  Same as (3), but multiplied by SQRT( underflow threshold )
// *
// *  (8)  A matrix of the form  U D V, where U and V are orthogonal and
// *       D has evenly spaced entries 1, ..., ULP with random signs
// *       on the diagonal.
// *
// *  (9)  A matrix of the form  U D V, where U and V are orthogonal and
// *       D has geometrically spaced entries 1, ..., ULP with random
// *       signs on the diagonal.
// *
// *  (10) A matrix of the form  U D V, where U and V are orthogonal and
// *       D has "clustered" entries 1, ULP,..., ULP with random
// *       signs on the diagonal.
// *
// *  (11) Same as (8), but multiplied by SQRT( overflow threshold )
// *  (12) Same as (8), but multiplied by SQRT( underflow threshold )
// *
// *  (13) Rectangular matrix with random entries chosen from (-1,1).
// *  (14) Same as (13), but multiplied by SQRT( overflow threshold )
// *  (15) Same as (13), but multiplied by SQRT( underflow threshold )
// *
// *  Arguments
// *  =========
// *
// *  NSIZES  (input) INTEGER
// *          The number of values of M and N contained in the vectors
// *          MVAL and NVAL.  The matrix sizes are used in pairs (M,N).
// *          If NSIZES is zero, DCHKBB does nothing.  NSIZES must be at
// *          least zero.
// *
// *  MVAL    (input) INTEGER array, dimension (NSIZES)
// *          The values of the matrix row dimension M.
// *
// *  NVAL    (input) INTEGER array, dimension (NSIZES)
// *          The values of the matrix column dimension N.
// *
// *  NWDTHS  (input) INTEGER
// *          The number of bandwidths to use.  If it is zero,
// *          DCHKBB does nothing.  It must be at least zero.
// *
// *  KK      (input) INTEGER array, dimension (NWDTHS)
// *          An array containing the bandwidths to be used for the band
// *          matrices.  The values must be at least zero.
// *
// *  NTYPES  (input) INTEGER
// *          The number of elements in DOTYPE.   If it is zero, DCHKBB
// *          does nothing.  It must be at least zero.  If it is MAXTYP+1
// *          and NSIZES is 1, then an additional type, MAXTYP+1 is
// *          defined, which is to use whatever matrix is in A.  This
// *          is only useful if DOTYPE(1:MAXTYP) is .FALSE. and
// *          DOTYPE(MAXTYP+1) is .TRUE. .
// *
// *  DOTYPE  (input) LOGICAL array, dimension (NTYPES)
// *          If DOTYPE(j) is .TRUE., then for each size in NN a
// *          matrix of that size and of type j will be generated.
// *          If NTYPES is smaller than the maximum number of types
// *          defined (PARAMETER MAXTYP), then types NTYPES+1 through
// *          MAXTYP will not be generated.  If NTYPES is larger
// *          than MAXTYP, DOTYPE(MAXTYP+1) through DOTYPE(NTYPES)
// *          will be ignored.
// *
// *  NRHS    (input) INTEGER
// *          The number of columns in the "right-hand side" matrix C.
// *          If NRHS = 0, then the operations on the right-hand side will
// *          not be tested. NRHS must be at least 0.
// *
// *  ISEED   (input/output) INTEGER array, dimension (4)
// *          On entry ISEED specifies the seed of the random number
// *          generator. The array elements should be between 0 and 4095;
// *          if not they will be reduced mod 4096.  Also, ISEED(4) must
// *          be odd.  The random number generator uses a linear
// *          congruential sequence limited to small integers, and so
// *          should produce machine independent random numbers. The
// *          values of ISEED are changed on exit, and can be used in the
// *          next call to DCHKBB to continue the same random number
// *          sequence.
// *
// *  THRESH  (input) DOUBLE PRECISION
// *          A test will count as "failed" if the "error", computed as
// *          described above, exceeds THRESH.  Note that the error
// *          is scaled to be O(1), so THRESH should be a reasonably
// *          small multiple of 1, e.g., 10 or 100.  In particular,
// *          it should not depend on the precision (single vs. double)
// *          or the size of the matrix.  It must be at least zero.
// *
// *  NOUNIT  (input) INTEGER
// *          The FORTRAN unit number for printing out error messages
// *          (e.g., if a routine returns IINFO not equal to 0.)
// *
// *  A       (input/workspace) DOUBLE PRECISION array, dimension
// *                            (LDA, max(NN))
// *          Used to hold the matrix A.
// *
// *  LDA     (input) INTEGER
// *          The leading dimension of A.  It must be at least 1
// *          and at least max( NN ).
// *
// *  AB      (workspace) DOUBLE PRECISION array, dimension (LDAB, max(NN))
// *          Used to hold A in band storage format.
// *
// *  LDAB    (input) INTEGER
// *          The leading dimension of AB.  It must be at least 2 (not 1!)
// *          and at least max( KK )+1.
// *
// *  BD      (workspace) DOUBLE PRECISION array, dimension (max(NN))
// *          Used to hold the diagonal of the bidiagonal matrix computed
// *          by DGBBRD.
// *
// *  BE      (workspace) DOUBLE PRECISION array, dimension (max(NN))
// *          Used to hold the off-diagonal of the bidiagonal matrix
// *          computed by DGBBRD.
// *
// *  Q       (workspace) DOUBLE PRECISION array, dimension (LDQ, max(NN))
// *          Used to hold the orthogonal matrix Q computed by DGBBRD.
// *
// *  LDQ     (input) INTEGER
// *          The leading dimension of Q.  It must be at least 1
// *          and at least max( NN ).
// *
// *  P       (workspace) DOUBLE PRECISION array, dimension (LDP, max(NN))
// *          Used to hold the orthogonal matrix P computed by DGBBRD.
// *
// *  LDP     (input) INTEGER
// *          The leading dimension of P.  It must be at least 1
// *          and at least max( NN ).
// *
// *  C       (workspace) DOUBLE PRECISION array, dimension (LDC, max(NN))
// *          Used to hold the matrix C updated by DGBBRD.
// *
// *  LDC     (input) INTEGER
// *          The leading dimension of U.  It must be at least 1
// *          and at least max( NN ).
// *
// *  CC      (workspace) DOUBLE PRECISION array, dimension (LDC, max(NN))
// *          Used to hold a copy of the matrix C.
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension (LWORK)
// *
// *  LWORK   (input) INTEGER
// *          The number of entries in WORK.  This must be at least
// *          max( LDA+1, max(NN)+1 )*max(NN).
// *
// *  RESULT  (output) DOUBLE PRECISION array, dimension (4)
// *          The values computed by the tests described above.
// *          The values are currently limited to 1/ulp, to avoid
// *          overflow.
// *
// *  INFO    (output) INTEGER
// *          If 0, then everything ran OK.
// *
// *-----------------------------------------------------------------------
// *
// *       Some Local Variables and Parameters:
// *       ---- ----- --------- --- ----------
// *       ZERO, ONE       Real 0 and 1.
// *       MAXTYP          The number of types defined.
// *       NTEST           The number of tests performed, or which can
// *                       be performed so far, for the current matrix.
// *       NTESTT          The total number of tests performed so far.
// *       NMAX            Largest value in NN.
// *       NMATS           The number of matrices generated so far.
// *       NERRS           The number of tests which have exceeded THRESH
// *                       so far.
// *       COND, IMODE     Values to be passed to the matrix generators.
// *       ANORM           Norm of A; passed to matrix generators.
// *
// *       OVFL, UNFL      Overflow and underflow thresholds.
// *       ULP, ULPINV     Finest relative precision and its inverse.
// *       RTOVFL, RTUNFL  Square roots of the previous 2 values.
// *               The following four arrays decode JTYPE:
// *       KTYPE(j)        The general type (1-10) for type "j".
// *       KMODE(j)        The MODE value to be passed to the matrix
// *                       generator for type "j".
// *       KMAGN(j)        The order of magnitude ( O(1),
// *                       O(overflow^(1/2) ), O(underflow^(1/2) )
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e0;
static double one= 1.0e0;
static int maxtyp= 15;
// *     ..
// *     .. Local Scalars ..
static boolean badmm= false;
static boolean badnn= false;
static boolean badnnb= false;
static int i= 0;
static intW iinfo= new intW(0);
static int imode= 0;
static int itype= 0;
static int [] iwork= new int[(1)];
static int j= 0;
static int jcol= 0;
static int jr= 0;
static int jsize= 0;
static int jtype= 0;
static int jwidth= 0;
static int k= 0;
static int kl= 0;
static int kmax= 0;
static int ku= 0;
static int m= 0;
static int mmax= 0;
static int mnmax= 0;
static int mnmin= 0;
static int mtypes= 0;
static int n= 0;
static int nerrs= 0;
static int nmats= 0;
static int nmax= 0;
static int ntest= 0;
static int ntestt= 0;
static double amninv= 0.0;
static double anorm= 0.0;
static double cond= 0.0;
static double ovfl= 0.0;
static double rtovfl= 0.0;
static double rtunfl= 0.0;
static double ulp= 0.0;
static double ulpinv= 0.0;
static double unfl= 0.0;
// *     ..
// *     .. Local Arrays ..
static int [] idumma= new int[(1)];
static int [] ioldsd= new int[(4)];
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Data statements ..
static int [] ktype = {1 
, 2 , 4, 4, 4, 4, 4 , 6, 6, 6, 6, 6 , 9, 9, 9 };
static int [] kmagn = {1, 1 
, 1, 1, 1 , 2 , 3 , 1, 1, 1 , 2 
, 3 , 1 , 2 , 3 };
static int [] kmode = {0, 0 
, 4 , 3 , 1 , 4 , 4 
, 4 , 3 , 1 , 4 , 4 
, 0 , 0 , 0 };
// *     ..
// *     .. Executable Statements ..
// *
// *     Check for errors
// *

public static void dchkbb (int nsizes,
int [] mval, int _mval_offset,
int [] nval, int _nval_offset,
int nwdths,
int [] kk, int _kk_offset,
int ntypes,
boolean [] dotype, int _dotype_offset,
int nrhs,
int [] iseed, int _iseed_offset,
double thresh,
int nounit,
double [] a, int _a_offset,
int lda,
double [] ab, int _ab_offset,
int ldab,
double [] bd, int _bd_offset,
double [] be, int _be_offset,
double [] q, int _q_offset,
int ldq,
double [] p, int _p_offset,
int ldp,
double [] c, int _c_offset,
int Ldc,
double [] cc, int _cc_offset,
double [] work, int _work_offset,
int lwork,
double [] result, int _result_offset,
intW info)  {

ntestt = 0;
info.val = 0;
// *
// *     Important constants
// *
badmm = false;
badnn = false;
mmax = 1;
nmax = 1;
mnmax = 1;
{
forloop10:
for (j = 1; j <= nsizes; j++) {
mmax = (int)(Math.max(mmax, mval[(j)- 1+ _mval_offset]) );
if (mval[(j)- 1+ _mval_offset] < 0)  
    badmm = true;
nmax = (int)(Math.max(nmax, nval[(j)- 1+ _nval_offset]) );
if (nval[(j)- 1+ _nval_offset] < 0)  
    badnn = true;
mnmax = (int)(Math.max(mnmax, Math.min(mval[(j)- 1+ _mval_offset], nval[(j)- 1+ _nval_offset]) ) );
Dummy.label("Dchkbb",10);
}              //  Close for() loop. 
}
// *
badnnb = false;
kmax = 0;
{
forloop20:
for (j = 1; j <= nwdths; j++) {
kmax = (int)(Math.max(kmax, kk[(j)- 1+ _kk_offset]) );
if (kk[(j)- 1+ _kk_offset] < 0)  
    badnnb = true;
Dummy.label("Dchkbb",20);
}              //  Close for() loop. 
}
// *
// *     Check for errors
// *
if (nsizes < 0)  {
    info.val = -1;
}              // Close if()
else if (badmm)  {
    info.val = -2;
}              // Close else if()
else if (badnn)  {
    info.val = -3;
}              // Close else if()
else if (nwdths < 0)  {
    info.val = -4;
}              // Close else if()
else if (badnnb)  {
    info.val = -5;
}              // Close else if()
else if (ntypes < 0)  {
    info.val = -6;
}              // Close else if()
else if (nrhs < 0)  {
    info.val = -8;
}              // Close else if()
else if (lda < nmax)  {
    info.val = -13;
}              // Close else if()
else if (ldab < 2*kmax+1)  {
    info.val = -15;
}              // Close else if()
else if (ldq < nmax)  {
    info.val = -19;
}              // Close else if()
else if (ldp < nmax)  {
    info.val = -21;
}              // Close else if()
else if (Ldc < nmax)  {
    info.val = -23;
}              // Close else if()
else if ((Math.max(lda, nmax) +1)*nmax > lwork)  {
    info.val = -26;
}              // Close else if()
// *
if (info.val != 0)  {
    Xerbla.xerbla("DCHKBB",-info.val);
Dummy.go_to("Dchkbb",999999);
}              // Close if()
// *
// *     Quick return if possible
// *
if (nsizes == 0 || ntypes == 0 || nwdths == 0)  
    Dummy.go_to("Dchkbb",999999);
// *
// *     More Important constants
// *
unfl = Dlamch.dlamch("Safe minimum");
ovfl = one/unfl;
ulp = Dlamch.dlamch("Epsilon")*Dlamch.dlamch("Base");
ulpinv = one/ulp;
rtunfl = Math.sqrt(unfl);
rtovfl = Math.sqrt(ovfl);
// *
// *     Loop over sizes, widths, types
// *
nerrs = 0;
nmats = 0;
// *
{
forloop160:
for (jsize = 1; jsize <= nsizes; jsize++) {
m = mval[(jsize)- 1+ _mval_offset];
n = nval[(jsize)- 1+ _nval_offset];
mnmin = (int)(Math.min(m, n) );
amninv = one/(double)(Math.max((1) > (m) ? (1) : (m), n));
// *
{
forloop150:
for (jwidth = 1; jwidth <= nwdths; jwidth++) {
k = kk[(jwidth)- 1+ _kk_offset];
if (k >= m && k >= n)  
    continue forloop150;
kl = (int)(Math.max(0, Math.min(m-1, k) ) );
ku = (int)(Math.max(0, Math.min(n-1, k) ) );
// *
if (nsizes != 1)  {
    mtypes = (int)(Math.min(maxtyp, ntypes) );
}              // Close if()
else  {
  mtypes = (int)(Math.min(maxtyp+1, ntypes) );
}              //  Close else.
// *
{
forloop140:
for (jtype = 1; jtype <= mtypes; jtype++) {
if (!dotype[(jtype)- 1+ _dotype_offset])  
    continue forloop140;
nmats = nmats+1;
ntest = 0;
// *
{
forloop30:
for (j = 1; j <= 4; j++) {
ioldsd[(j)- 1] = iseed[(j)- 1+ _iseed_offset];
Dummy.label("Dchkbb",30);
}              //  Close for() loop. 
}
// *
// *              Compute "A".
// *
// *              Control parameters:
// *
// *                  KMAGN  KMODE        KTYPE
// *              =1  O(1)   clustered 1  zero
// *              =2  large  clustered 2  identity
// *              =3  small  exponential  (none)
// *              =4         arithmetic   diagonal, (w/ singular values)
// *              =5         random log   (none)
// *              =6         random       nonhermitian, w/ singular values
// *              =7                      (none)
// *              =8                      (none)
// *              =9                      random nonhermitian
// *
if (mtypes > maxtyp)  
    Dummy.go_to("Dchkbb",90);
// *
itype = ktype[(jtype)- 1];
imode = kmode[(jtype)- 1];
// *
// *              Compute norm
// *
if (kmagn[(jtype)- 1] == 1) 
  Dummy.go_to("Dchkbb",40);
else if (kmagn[(jtype)- 1] == 2) 
  Dummy.go_to("Dchkbb",50);
else if (kmagn[(jtype)- 1] == 3) 
  Dummy.go_to("Dchkbb",60);
// *
label40:
   Dummy.label("Dchkbb",40);
anorm = one;
Dummy.go_to("Dchkbb",70);
// *
label50:
   Dummy.label("Dchkbb",50);
anorm = (rtovfl*ulp)*amninv;
Dummy.go_to("Dchkbb",70);
// *
label60:
   Dummy.label("Dchkbb",60);
anorm = rtunfl*Math.max(m, n) *ulpinv;
Dummy.go_to("Dchkbb",70);
// *
label70:
   Dummy.label("Dchkbb",70);
// *
Dlaset.dlaset("Full",lda,n,zero,zero,a,_a_offset,lda);
Dlaset.dlaset("Full",ldab,n,zero,zero,ab,_ab_offset,ldab);
iinfo.val = 0;
cond = ulpinv;
// *
// *              Special Matrices -- Identity & Jordan block
// *
// *                 Zero
// *
if (itype == 1)  {
    iinfo.val = 0;
// *
}              // Close if()
else if (itype == 2)  {
    // *
// *                 Identity
// *
{
forloop80:
for (jcol = 1; jcol <= n; jcol++) {
a[(jcol)- 1+(jcol- 1)*lda+ _a_offset] = anorm;
Dummy.label("Dchkbb",80);
}              //  Close for() loop. 
}
// *
}              // Close else if()
else if (itype == 4)  {
    // *
// *                 Diagonal Matrix, singular values specified
// *
Dlatms.dlatms(m,n,"S",iseed,_iseed_offset,"N",work,_work_offset,imode,cond,anorm,0,0,"N",a,_a_offset,lda,work,(m+1)- 1+ _work_offset,iinfo);
// *
}              // Close else if()
else if (itype == 6)  {
    // *
// *                 Nonhermitian, singular values specified
// *
Dlatms.dlatms(m,n,"S",iseed,_iseed_offset,"N",work,_work_offset,imode,cond,anorm,kl,ku,"N",a,_a_offset,lda,work,(m+1)- 1+ _work_offset,iinfo);
// *
}              // Close else if()
else if (itype == 9)  {
    // *
// *                 Nonhermitian, random entries
// *
Dlatmr.dlatmr(m,n,"S",iseed,_iseed_offset,"N",work,_work_offset,6,one,one,"T","N",work,(n+1)- 1+ _work_offset,1,one,work,(2*n+1)- 1+ _work_offset,1,one,"N",idumma,0,kl,ku,zero,anorm,"N",a,_a_offset,lda,idumma,0,iinfo);
// *
}              // Close else if()
else  {
  // *
iinfo.val = 1;
}              //  Close else.
// *
// *              Generate Right-Hand Side
// *
Dlatmr.dlatmr(m,nrhs,"S",iseed,_iseed_offset,"N",work,_work_offset,6,one,one,"T","N",work,(m+1)- 1+ _work_offset,1,one,work,(2*m+1)- 1+ _work_offset,1,one,"N",iwork,0,m,nrhs,zero,one,"NO",c,_c_offset,Ldc,iwork,0,iinfo);
// *
if (iinfo.val != 0)  {
    System.out.println(" DCHKBB: "  + ("Generator") + " "  + " returned INFO="  + (iinfo.val) + " "  + "."  + "\n"  + "         " + "M="  + (n) + " "  + " N="  + (jtype) + " "  + " K="  + (ioldsd) + " "  + ", JTYPE="  + " NULL " + " "  + ", ISEED=("  + " NULL " + " "  + ","  + " NULL " + " "  + ","  + " NULL " + " "  + ","  + " NULL " + " "  + ")" );
info.val = (int)(Math.abs(iinfo.val));
Dummy.go_to("Dchkbb",999999);
}              // Close if()
// *
label90:
   Dummy.label("Dchkbb",90);
// *
// *              Copy A to band storage.
// *
{
forloop110:
for (j = 1; j <= n; j++) {
{
forloop100:
for (i = (int)(Math.max(1, j-ku) ); i <= Math.min(m, j+kl) ; i++) {
ab[(ku+1+i-j)- 1+(j- 1)*ldab+ _ab_offset] = a[(i)- 1+(j- 1)*lda+ _a_offset];
Dummy.label("Dchkbb",100);
}              //  Close for() loop. 
}
Dummy.label("Dchkbb",110);
}              //  Close for() loop. 
}
// *
// *              Copy C
// *
Dlacpy.dlacpy("Full",m,nrhs,c,_c_offset,Ldc,cc,_cc_offset,Ldc);
// *
// *              Call DGBBRD to compute B, Q and P, and to update C.
// *
Dgbbrd.dgbbrd("B",m,n,nrhs,kl,ku,ab,_ab_offset,ldab,bd,_bd_offset,be,_be_offset,q,_q_offset,ldq,p,_p_offset,ldp,cc,_cc_offset,Ldc,work,_work_offset,iinfo);
// *
if (iinfo.val != 0)  {
    System.out.println(" DCHKBB: "  + ("DGBBRD") + " "  + " returned INFO="  + (iinfo.val) + " "  + "."  + "\n"  + "         " + "M="  + (n) + " "  + " N="  + (jtype) + " "  + " K="  + (ioldsd) + " "  + ", JTYPE="  + " NULL " + " "  + ", ISEED=("  + " NULL " + " "  + ","  + " NULL " + " "  + ","  + " NULL " + " "  + ","  + " NULL " + " "  + ")" );
info.val = (int)(Math.abs(iinfo.val));
if (iinfo.val < 0)  {
    Dummy.go_to("Dchkbb",999999);
}              // Close if()
else  {
  result[(1)- 1+ _result_offset] = ulpinv;
Dummy.go_to("Dchkbb",120);
}              //  Close else.
}              // Close if()
// *
// *              Test 1:  Check the decomposition A := Q * B * P'
// *                   2:  Check the orthogonality of Q
// *                   3:  Check the orthogonality of P
// *                   4:  Check the computation of Q' * C
// *
dbdt01_adapter(m,n,-1,a,_a_offset,lda,q,_q_offset,ldq,bd,_bd_offset,be,_be_offset,p,_p_offset,ldp,work,_work_offset,result,(1)- 1+ _result_offset);
dort01_adapter("Columns",m,m,q,_q_offset,ldq,work,_work_offset,lwork,result,(2)- 1+ _result_offset);
dort01_adapter("Rows",n,n,p,_p_offset,ldp,work,_work_offset,lwork,result,(3)- 1+ _result_offset);
dbdt02_adapter(m,nrhs,c,_c_offset,Ldc,cc,_cc_offset,Ldc,q,_q_offset,ldq,work,_work_offset,result,(4)- 1+ _result_offset);
// *
// *              End of Loop -- Check for RESULT(j) > THRESH
// *
ntest = 4;
label120:
   Dummy.label("Dchkbb",120);
ntestt = ntestt+ntest;
// *
// *              Print out tests which fail.
// *
{
forloop130:
for (jr = 1; jr <= ntest; jr++) {
if (result[(jr)- 1+ _result_offset] >= thresh)  {
    if (nerrs == 0)  
    Dlahd2.dlahd2(nounit,"DBB");
nerrs = nerrs+1;
System.out.println(" M ="  + (m) + " "  + " N="  + (n) + " "  + ", K="  + (k) + " "  + ", seed="  + (ioldsd) + " "  + ","  + (jtype) + " "  + ","  + (jr) + " "  + ","  + (result[(jr)- 1+ _result_offset]) + " "  + ","  + " type "  + " NULL " + " "  + ", test("  + " NULL " + " "  + ")="  + " NULL " + " " );
}              // Close if()
Dummy.label("Dchkbb",130);
}              //  Close for() loop. 
}
// *
Dummy.label("Dchkbb",140);
}              //  Close for() loop. 
}
Dummy.label("Dchkbb",150);
}              //  Close for() loop. 
}
Dummy.label("Dchkbb",160);
}              //  Close for() loop. 
}
// *
// *     Summary
// *
Dlasum.dlasum("DBB",nounit,nerrs,ntestt);
Dummy.go_to("Dchkbb",999999);
// *
// *
// *     End of DCHKBB
// *
Dummy.label("Dchkbb",999999);
return;
   }
// adapter for dbdt01
private static void dbdt01_adapter(int arg0 ,int arg1 ,int arg2 ,double [] arg3 , int arg3_offset ,int arg4 ,double [] arg5 , int arg5_offset ,int arg6 ,double [] arg7 , int arg7_offset ,double [] arg8 , int arg8_offset ,double [] arg9 , int arg9_offset ,int arg10 ,double [] arg11 , int arg11_offset ,double [] arg12 , int arg12_offset )
{
doubleW _f2j_tmp12 = new doubleW(arg12[arg12_offset]);

Dbdt01.dbdt01(arg0,arg1,arg2,arg3, arg3_offset,arg4,arg5, arg5_offset,arg6,arg7, arg7_offset,arg8, arg8_offset,arg9, arg9_offset,arg10,arg11, arg11_offset,_f2j_tmp12);

arg12[arg12_offset] = _f2j_tmp12.val;
}

// adapter for dort01
private static void dort01_adapter(String arg0 ,int arg1 ,int arg2 ,double [] arg3 , int arg3_offset ,int arg4 ,double [] arg5 , int arg5_offset ,int arg6 ,double [] arg7 , int arg7_offset )
{
doubleW _f2j_tmp7 = new doubleW(arg7[arg7_offset]);

Dort01.dort01(arg0,arg1,arg2,arg3, arg3_offset,arg4,arg5, arg5_offset,arg6,_f2j_tmp7);

arg7[arg7_offset] = _f2j_tmp7.val;
}

// adapter for dbdt02
private static void dbdt02_adapter(int arg0 ,int arg1 ,double [] arg2 , int arg2_offset ,int arg3 ,double [] arg4 , int arg4_offset ,int arg5 ,double [] arg6 , int arg6_offset ,int arg7 ,double [] arg8 , int arg8_offset ,double [] arg9 , int arg9_offset )
{
doubleW _f2j_tmp9 = new doubleW(arg9[arg9_offset]);

Dbdt02.dbdt02(arg0,arg1,arg2, arg2_offset,arg3,arg4, arg4_offset,arg5,arg6, arg6_offset,arg7,arg8, arg8_offset,_f2j_tmp9);

arg9[arg9_offset] = _f2j_tmp9.val;
}

} // End class.
