/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: eigtest.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

import java.lang.*;
import org.netlib.util.*;
import org.netlib.lapack.*;




public class Ddrvsx {

// *
// *  -- LAPACK test routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *     DDRVSX checks the nonsymmetric eigenvalue (Schur form) problem
// *     expert driver DGEESX.
// *
// *     DDRVSX uses both test matrices generated randomly depending on
// *     data supplied in the calling sequence, as well as on data
// *     read from an input file and including precomputed condition
// *     numbers to which it compares the ones it computes.
// *
// *     When DDRVSX is called, a number of matrix "sizes" ("n's") and a
// *     number of matrix "types" are specified.  For each size ("n")
// *     and each type of matrix, one matrix will be generated and used
// *     to test the nonsymmetric eigenroutines.  For each matrix, 15
// *     tests will be performed:
// *
// *     (1)     0 if T is in Schur form, 1/ulp otherwise
// *            (no sorting of eigenvalues)
// *
// *     (2)     | A - VS T VS' | / ( n |A| ulp )
// *
// *       Here VS is the matrix of Schur eigenvectors, and T is in Schur
// *       form  (no sorting of eigenvalues).
// *
// *     (3)     | I - VS VS' | / ( n ulp ) (no sorting of eigenvalues).
// *
// *     (4)     0     if WR+sqrt(-1)*WI are eigenvalues of T
// *             1/ulp otherwise
// *             (no sorting of eigenvalues)
// *
// *     (5)     0     if T(with VS) = T(without VS),
// *             1/ulp otherwise
// *             (no sorting of eigenvalues)
// *
// *     (6)     0     if eigenvalues(with VS) = eigenvalues(without VS),
// *             1/ulp otherwise
// *             (no sorting of eigenvalues)
// *
// *     (7)     0 if T is in Schur form, 1/ulp otherwise
// *             (with sorting of eigenvalues)
// *
// *     (8)     | A - VS T VS' | / ( n |A| ulp )
// *
// *       Here VS is the matrix of Schur eigenvectors, and T is in Schur
// *       form  (with sorting of eigenvalues).
// *
// *     (9)     | I - VS VS' | / ( n ulp ) (with sorting of eigenvalues).
// *
// *     (10)    0     if WR+sqrt(-1)*WI are eigenvalues of T
// *             1/ulp otherwise
// *             If workspace sufficient, also compare WR, WI with and
// *             without reciprocal condition numbers
// *             (with sorting of eigenvalues)
// *
// *     (11)    0     if T(with VS) = T(without VS),
// *             1/ulp otherwise
// *             If workspace sufficient, also compare T with and without
// *             reciprocal condition numbers
// *             (with sorting of eigenvalues)
// *
// *     (12)    0     if eigenvalues(with VS) = eigenvalues(without VS),
// *             1/ulp otherwise
// *             If workspace sufficient, also compare VS with and without
// *             reciprocal condition numbers
// *             (with sorting of eigenvalues)
// *
// *     (13)    if sorting worked and SDIM is the number of
// *             eigenvalues which were SELECTed
// *             If workspace sufficient, also compare SDIM with and
// *             without reciprocal condition numbers
// *
// *     (14)    if RCONDE the same no matter if VS and/or RCONDV computed
// *
// *     (15)    if RCONDV the same no matter if VS and/or RCONDE computed
// *
// *     The "sizes" are specified by an array NN(1:NSIZES); the value of
// *     each element NN(j) specifies one size.
// *     The "types" are specified by a logical array DOTYPE( 1:NTYPES );
// *     if DOTYPE(j) is .TRUE., then matrix type "j" will be generated.
// *     Currently, the list of possible types is:
// *
// *     (1)  The zero matrix.
// *     (2)  The identity matrix.
// *     (3)  A (transposed) Jordan block, with 1's on the diagonal.
// *
// *     (4)  A diagonal matrix with evenly spaced entries
// *          1, ..., ULP  and random signs.
// *          (ULP = (first number larger than 1) - 1 )
// *     (5)  A diagonal matrix with geometrically spaced entries
// *          1, ..., ULP  and random signs.
// *     (6)  A diagonal matrix with "clustered" entries 1, ULP, ..., ULP
// *          and random signs.
// *
// *     (7)  Same as (4), but multiplied by a constant near
// *          the overflow threshold
// *     (8)  Same as (4), but multiplied by a constant near
// *          the underflow threshold
// *
// *     (9)  A matrix of the form  U' T U, where U is orthogonal and
// *          T has evenly spaced entries 1, ..., ULP with random signs
// *          on the diagonal and random O(1) entries in the upper
// *          triangle.
// *
// *     (10) A matrix of the form  U' T U, where U is orthogonal and
// *          T has geometrically spaced entries 1, ..., ULP with random
// *          signs on the diagonal and random O(1) entries in the upper
// *          triangle.
// *
// *     (11) A matrix of the form  U' T U, where U is orthogonal and
// *          T has "clustered" entries 1, ULP,..., ULP with random
// *          signs on the diagonal and random O(1) entries in the upper
// *          triangle.
// *
// *     (12) A matrix of the form  U' T U, where U is orthogonal and
// *          T has real or complex conjugate paired eigenvalues randomly
// *          chosen from ( ULP, 1 ) and random O(1) entries in the upper
// *          triangle.
// *
// *     (13) A matrix of the form  X' T X, where X has condition
// *          SQRT( ULP ) and T has evenly spaced entries 1, ..., ULP
// *          with random signs on the diagonal and random O(1) entries
// *          in the upper triangle.
// *
// *     (14) A matrix of the form  X' T X, where X has condition
// *          SQRT( ULP ) and T has geometrically spaced entries
// *          1, ..., ULP with random signs on the diagonal and random
// *          O(1) entries in the upper triangle.
// *
// *     (15) A matrix of the form  X' T X, where X has condition
// *          SQRT( ULP ) and T has "clustered" entries 1, ULP,..., ULP
// *          with random signs on the diagonal and random O(1) entries
// *          in the upper triangle.
// *
// *     (16) A matrix of the form  X' T X, where X has condition
// *          SQRT( ULP ) and T has real or complex conjugate paired
// *          eigenvalues randomly chosen from ( ULP, 1 ) and random
// *          O(1) entries in the upper triangle.
// *
// *     (17) Same as (16), but multiplied by a constant
// *          near the overflow threshold
// *     (18) Same as (16), but multiplied by a constant
// *          near the underflow threshold
// *
// *     (19) Nonsymmetric matrix with random entries chosen from (-1,1).
// *          If N is at least 4, all entries in first two rows and last
// *          row, and first column and last two columns are zero.
// *     (20) Same as (19), but multiplied by a constant
// *          near the overflow threshold
// *     (21) Same as (19), but multiplied by a constant
// *          near the underflow threshold
// *
// *     In addition, an input file will be read from logical unit number
// *     NIUNIT. The file contains matrices along with precomputed
// *     eigenvalues and reciprocal condition numbers for the eigenvalue
// *     average and right invariant subspace. For these matrices, in
// *     addition to tests (1) to (15) we will compute the following two
// *     tests:
// *
// *    (16)  |RCONDE - RCDEIN| / cond(RCONDE)
// *
// *       RCONDE is the reciprocal average eigenvalue condition number
// *       computed by DGEESX and RCDEIN (the precomputed true value)
// *       is supplied as input.  cond(RCONDE) is the condition number
// *       of RCONDE, and takes errors in computing RCONDE into account,
// *       so that the resulting quantity should be O(ULP). cond(RCONDE)
// *       is essentially given by norm(A)/RCONDV.
// *
// *    (17)  |RCONDV - RCDVIN| / cond(RCONDV)
// *
// *       RCONDV is the reciprocal right invariant subspace condition
// *       number computed by DGEESX and RCDVIN (the precomputed true
// *       value) is supplied as input. cond(RCONDV) is the condition
// *       number of RCONDV, and takes errors in computing RCONDV into
// *       account, so that the resulting quantity should be O(ULP).
// *       cond(RCONDV) is essentially given by norm(A)/RCONDE.
// *
// *  Arguments
// *  =========
// *
// *  NSIZES  (input) INTEGER
// *          The number of sizes of matrices to use.  NSIZES must be at
// *          least zero. If it is zero, no randomly generated matrices
// *          are tested, but any test matrices read from NIUNIT will be
// *          tested.
// *
// *  NN      (input) INTEGER array, dimension (NSIZES)
// *          An array containing the sizes to be used for the matrices.
// *          Zero values will be skipped.  The values must be at least
// *          zero.
// *
// *  NTYPES  (input) INTEGER
// *          The number of elements in DOTYPE. NTYPES must be at least
// *          zero. If it is zero, no randomly generated test matrices
// *          are tested, but and test matrices read from NIUNIT will be
// *          tested. If it is MAXTYP+1 and NSIZES is 1, then an
// *          additional type, MAXTYP+1 is defined, which is to use
// *          whatever matrix is in A.  This is only useful if
// *          DOTYPE(1:MAXTYP) is .FALSE. and DOTYPE(MAXTYP+1) is .TRUE. .
// *
// *  DOTYPE  (input) LOGICAL array, dimension (NTYPES)
// *          If DOTYPE(j) is .TRUE., then for each size in NN a
// *          matrix of that size and of type j will be generated.
// *          If NTYPES is smaller than the maximum number of types
// *          defined (PARAMETER MAXTYP), then types NTYPES+1 through
// *          MAXTYP will not be generated.  If NTYPES is larger
// *          than MAXTYP, DOTYPE(MAXTYP+1) through DOTYPE(NTYPES)
// *          will be ignored.
// *
// *  ISEED   (input/output) INTEGER array, dimension (4)
// *          On entry ISEED specifies the seed of the random number
// *          generator. The array elements should be between 0 and 4095;
// *          if not they will be reduced mod 4096.  Also, ISEED(4) must
// *          be odd.  The random number generator uses a linear
// *          congruential sequence limited to small integers, and so
// *          should produce machine independent random numbers. The
// *          values of ISEED are changed on exit, and can be used in the
// *          next call to DDRVSX to continue the same random number
// *          sequence.
// *
// *  THRESH  (input) DOUBLE PRECISION
// *          A test will count as "failed" if the "error", computed as
// *          described above, exceeds THRESH.  Note that the error
// *          is scaled to be O(1), so THRESH should be a reasonably
// *          small multiple of 1, e.g., 10 or 100.  In particular,
// *          it should not depend on the precision (single vs. double)
// *          or the size of the matrix.  It must be at least zero.
// *
// *  NIUNIT  (input) INTEGER
// *          The FORTRAN unit number for reading in the data file of
// *          problems to solve.
// *
// *  NOUNIT  (input) INTEGER
// *          The FORTRAN unit number for printing out error messages
// *          (e.g., if a routine returns INFO not equal to 0.)
// *
// *  A       (workspace) DOUBLE PRECISION array, dimension (LDA, max(NN))
// *          Used to hold the matrix whose eigenvalues are to be
// *          computed.  On exit, A contains the last matrix actually used.
// *
// *  LDA     (input) INTEGER
// *          The leading dimension of A, and H. LDA must be at
// *          least 1 and at least max( NN ).
// *
// *  H       (workspace) DOUBLE PRECISION array, dimension (LDA, max(NN))
// *          Another copy of the test matrix A, modified by DGEESX.
// *
// *  HT      (workspace) DOUBLE PRECISION array, dimension (LDA, max(NN))
// *          Yet another copy of the test matrix A, modified by DGEESX.
// *
// *  WR      (workspace) DOUBLE PRECISION array, dimension (max(NN))
// *  WI      (workspace) DOUBLE PRECISION array, dimension (max(NN))
// *          The real and imaginary parts of the eigenvalues of A.
// *          On exit, WR + WI*i are the eigenvalues of the matrix in A.
// *
// *  WRT     (workspace) DOUBLE PRECISION array, dimension (max(NN))
// *  WIT     (workspace) DOUBLE PRECISION array, dimension (max(NN))
// *          Like WR, WI, these arrays contain the eigenvalues of A,
// *          but those computed when DGEESX only computes a partial
// *          eigendecomposition, i.e. not Schur vectors
// *
// *  WRTMP   (workspace) DOUBLE PRECISION array, dimension (max(NN))
// *  WITMP   (workspace) DOUBLE PRECISION array, dimension (max(NN))
// *          More temporary storage for eigenvalues.
// *
// *  VS      (workspace) DOUBLE PRECISION array, dimension (LDVS, max(NN))
// *          VS holds the computed Schur vectors.
// *
// *  LDVS    (input) INTEGER
// *          Leading dimension of VS. Must be at least max(1,max(NN)).
// *
// *  VS1     (workspace) DOUBLE PRECISION array, dimension (LDVS, max(NN))
// *          VS1 holds another copy of the computed Schur vectors.
// *
// *  RESULT  (output) DOUBLE PRECISION array, dimension (17)
// *          The values computed by the 17 tests described above.
// *          The values are currently limited to 1/ulp, to avoid overflow.
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension (LWORK)
// *
// *  LWORK   (input) INTEGER
// *          The number of entries in WORK.  This must be at least
// *          max(3*NN(j),2*NN(j)**2) for all j.
// *
// *  IWORK   (workspace) INTEGER array, dimension (max(NN)*max(NN))
// *
// *  INFO    (output) INTEGER
// *          If 0,  successful exit.
// *            <0,  input parameter -INFO is incorrect
// *            >0,  DLATMR, SLATMS, SLATME or DGET24 returned an error
// *                 code and INFO is its absolute value
// *
// *-----------------------------------------------------------------------
// *
// *     Some Local Variables and Parameters:
// *     ---- ----- --------- --- ----------
// *     ZERO, ONE       Real 0 and 1.
// *     MAXTYP          The number of types defined.
// *     NMAX            Largest value in NN.
// *     NERRS           The number of tests which have exceeded THRESH
// *     COND, CONDS,
// *     IMODE           Values to be passed to the matrix generators.
// *     ANORM           Norm of A; passed to matrix generators.
// *
// *     OVFL, UNFL      Overflow and underflow thresholds.
// *     ULP, ULPINV     Finest relative precision and its inverse.
// *     RTULP, RTULPI   Square roots of the previous 4 values.
// *             The following four arrays decode JTYPE:
// *     KTYPE(j)        The general type (1-10) for type "j".
// *     KMODE(j)        The MODE value to be passed to the matrix
// *                     generator for type "j".
// *     KMAGN(j)        The order of magnitude ( O(1),
// *                     O(overflow^(1/2) ), O(underflow^(1/2) )
// *     KCONDS(j)       Selectw whether CONDS is to be 1 or
// *                     1/sqrt(ulp).  (0 means irrelevant.)
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e0;
static double one= 1.0e0;
static int maxtyp= 21;
// *     ..
// *     .. Local Scalars ..
static boolean badnn= false;
static String path= new String("   ");
static int i= 0;
static intW iinfo= new intW(0);
static int imode= 0;
static int itype= 0;
static int iwk= 0;
static int j= 0;
static int jcol= 0;
static int jsize= 0;
static int jtype= 0;
static int mtypes= 0;
static int n= 0;
static int nerrs= 0;
static int nfail= 0;
static int nmax= 0;
static int nnwork= 0;
static int nslct= 0;
static int ntest= 0;
static int ntestf= 0;
static int ntestt= 0;
static double anorm= 0.0;
static double cond= 0.0;
static double conds= 0.0;
static doubleW ovfl= new doubleW(0.0);
static double rcdein= 0.0;
static double rcdvin= 0.0;
static double rtulp= 0.0;
static double rtulpi= 0.0;
static double ulp= 0.0;
static double ulpinv= 0.0;
static doubleW unfl= new doubleW(0.0);
// *     ..
// *     .. Local Arrays ..
static String [] adumma= new String[(1)];
static int [] idumma= new int[(1)];
static int [] ioldsd= new int[(4)];
static int [] islct= new int[(20)];
// *     ..
// *     .. Arrays in Common ..
// *     ..
// *     .. Scalars in Common ..
// *     ..
// *     .. Common blocks ..
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Data statements ..
static int [] ktype = {1 
, 2 , 3 , 4, 4, 4, 4, 4 , 6, 6, 6, 6 , 6, 6, 6, 6, 6, 6 
, 9, 9, 9 };
static int [] kmagn = {1, 1, 1 
, 1 , 1 , 1 , 2 , 3 
, 1, 1, 1, 1 , 1 , 1 , 1 , 1 
, 2 , 3 , 1 , 2 , 3 
};
static int [] kmode = {0, 0, 0 
, 4 , 3 , 1 , 4 , 4 
, 4 , 3 , 1 , 5 , 4 
, 3 , 1 , 5 , 5 , 5 
, 4 , 3 , 1 };
static int [] kconds = {0, 0, 0 
, 0, 0, 0, 0, 0 , 1, 1, 1, 1 , 2, 2, 2, 2, 2, 2 , 0, 0, 0 };
// *     ..
// *     .. Executable Statements ..
// *

public static void ddrvsx (int nsizes,
int [] nn, int _nn_offset,
int ntypes,
boolean [] dotype, int _dotype_offset,
int [] iseed, int _iseed_offset,
double thresh,
int niunit,
int nounit,
double [] a, int _a_offset,
int lda,
double [] h, int _h_offset,
double [] ht, int _ht_offset,
double [] wr, int _wr_offset,
double [] wi, int _wi_offset,
double [] wrt, int _wrt_offset,
double [] wit, int _wit_offset,
double [] wrtmp, int _wrtmp_offset,
double [] witmp, int _witmp_offset,
double [] vs, int _vs_offset,
int ldvs,
double [] vs1, int _vs1_offset,
double [] result, int _result_offset,
double [] work, int _work_offset,
int lwork,
int [] iwork, int _iwork_offset,
boolean [] bwork, int _bwork_offset,
intW info)  {

  EasyIn _f2j_in = new EasyIn();
{
  int E1, E2;
  E1 = 1;
  E2 = 1;
path = new String(path.substring(0,E1-1) + "D".substring(0,E2-E1+1) + path.substring(E2,path.length()));
}
;
{
  int E1, E2;
  E1 = 2;
  E2 = 3;
path = new String(path.substring(0,E1-1) + "SX".substring(0,E2-E1+1) + path.substring(E2,path.length()));
}
;
// *
// *     Check for errors
// *
ntestt = 0;
ntestf = 0;
info.val = 0;
// *
// *     Important constants
// *
badnn = false;
// *
// *     12 is the largest dimension in the input file of precomputed
// *     problems
// *
nmax = 12;
{
forloop10:
for (j = 1; j <= nsizes; j++) {
nmax = (int)(Math.max(nmax, nn[(j)- 1+ _nn_offset]) );
if (nn[(j)- 1+ _nn_offset] < 0)  
    badnn = true;
Dummy.label("Ddrvsx",10);
}              //  Close for() loop. 
}
// *
// *     Check for errors
// *
if (nsizes < 0)  {
    info.val = -1;
}              // Close if()
else if (badnn)  {
    info.val = -2;
}              // Close else if()
else if (ntypes < 0)  {
    info.val = -3;
}              // Close else if()
else if (thresh < zero)  {
    info.val = -6;
}              // Close else if()
else if (niunit <= 0)  {
    info.val = -7;
}              // Close else if()
else if (nounit <= 0)  {
    info.val = -8;
}              // Close else if()
else if (lda < 1 || lda < nmax)  {
    info.val = -10;
}              // Close else if()
else if (ldvs < 1 || ldvs < nmax)  {
    info.val = -20;
}              // Close else if()
else if (Math.max(3*nmax, 2*Math.pow(nmax, 2))  > lwork)  {
    info.val = -24;
}              // Close else if()
// *
if (info.val != 0)  {
    Xerbla.xerbla("DDRVSX",-info.val);
Dummy.go_to("Ddrvsx",999999);
}              // Close if()
// *
// *     If nothing to do check on NIUNIT
// *
if (nsizes == 0 || ntypes == 0)  
    Dummy.go_to("Ddrvsx",150);
// *
// *     More Important constants
// *
unfl.val = Dlamch.dlamch("Safe minimum");
ovfl.val = one/unfl.val;
Dlabad.dlabad(unfl,ovfl);
ulp = Dlamch.dlamch("Precision");
ulpinv = one/ulp;
rtulp = Math.sqrt(ulp);
rtulpi = one/rtulp;
// *
// *     Loop over sizes, types
// *
nerrs = 0;
// *
{
forloop140:
for (jsize = 1; jsize <= nsizes; jsize++) {
n = nn[(jsize)- 1+ _nn_offset];
if (nsizes != 1)  {
    mtypes = (int)(Math.min(maxtyp, ntypes) );
}              // Close if()
else  {
  mtypes = (int)(Math.min(maxtyp+1, ntypes) );
}              //  Close else.
// *
{
forloop130:
for (jtype = 1; jtype <= mtypes; jtype++) {
if (!dotype[(jtype)- 1+ _dotype_offset])  
    continue forloop130;
// *
// *           Save ISEED in case of an error.
// *
{
forloop20:
for (j = 1; j <= 4; j++) {
ioldsd[(j)- 1] = iseed[(j)- 1+ _iseed_offset];
Dummy.label("Ddrvsx",20);
}              //  Close for() loop. 
}
// *
// *           Compute "A"
// *
// *           Control parameters:
// *
// *           KMAGN  KCONDS  KMODE        KTYPE
// *       =1  O(1)   1       clustered 1  zero
// *       =2  large  large   clustered 2  identity
// *       =3  small          exponential  Jordan
// *       =4                 arithmetic   diagonal, (w/ eigenvalues)
// *       =5                 random log   symmetric, w/ eigenvalues
// *       =6                 random       general, w/ eigenvalues
// *       =7                              random diagonal
// *       =8                              random symmetric
// *       =9                              random general
// *       =10                             random triangular
// *
if (mtypes > maxtyp)  
    Dummy.go_to("Ddrvsx",90);
// *
itype = ktype[(jtype)- 1];
imode = kmode[(jtype)- 1];
// *
// *           Compute norm
// *
if (kmagn[(jtype)- 1] == 1) 
  Dummy.go_to("Ddrvsx",30);
else if (kmagn[(jtype)- 1] == 2) 
  Dummy.go_to("Ddrvsx",40);
else if (kmagn[(jtype)- 1] == 3) 
  Dummy.go_to("Ddrvsx",50);
// *
label30:
   Dummy.label("Ddrvsx",30);
anorm = one;
Dummy.go_to("Ddrvsx",60);
// *
label40:
   Dummy.label("Ddrvsx",40);
anorm = ovfl.val*ulp;
Dummy.go_to("Ddrvsx",60);
// *
label50:
   Dummy.label("Ddrvsx",50);
anorm = unfl.val*ulpinv;
Dummy.go_to("Ddrvsx",60);
// *
label60:
   Dummy.label("Ddrvsx",60);
// *
Dlaset.dlaset("Full",lda,n,zero,zero,a,_a_offset,lda);
iinfo.val = 0;
cond = ulpinv;
// *
// *           Special Matrices -- Identity & Jordan block
// *
// *              Zero
// *
if (itype == 1)  {
    iinfo.val = 0;
// *
}              // Close if()
else if (itype == 2)  {
    // *
// *              Identity
// *
{
forloop70:
for (jcol = 1; jcol <= n; jcol++) {
a[(jcol)- 1+(jcol- 1)*lda+ _a_offset] = anorm;
Dummy.label("Ddrvsx",70);
}              //  Close for() loop. 
}
// *
}              // Close else if()
else if (itype == 3)  {
    // *
// *              Jordan Block
// *
{
forloop80:
for (jcol = 1; jcol <= n; jcol++) {
a[(jcol)- 1+(jcol- 1)*lda+ _a_offset] = anorm;
if (jcol > 1)  
    a[(jcol)- 1+(jcol-1- 1)*lda+ _a_offset] = one;
Dummy.label("Ddrvsx",80);
}              //  Close for() loop. 
}
// *
}              // Close else if()
else if (itype == 4)  {
    // *
// *              Diagonal Matrix, [Eigen]values Specified
// *
Dlatms.dlatms(n,n,"S",iseed,_iseed_offset,"S",work,_work_offset,imode,cond,anorm,0,0,"N",a,_a_offset,lda,work,(n+1)- 1+ _work_offset,iinfo);
// *
}              // Close else if()
else if (itype == 5)  {
    // *
// *              Symmetric, eigenvalues specified
// *
Dlatms.dlatms(n,n,"S",iseed,_iseed_offset,"S",work,_work_offset,imode,cond,anorm,n,n,"N",a,_a_offset,lda,work,(n+1)- 1+ _work_offset,iinfo);
// *
}              // Close else if()
else if (itype == 6)  {
    // *
// *              General, eigenvalues specified
// *
if (kconds[(jtype)- 1] == 1)  {
    conds = one;
}              // Close if()
else if (kconds[(jtype)- 1] == 2)  {
    conds = rtulpi;
}              // Close else if()
else  {
  conds = zero;
}              //  Close else.
// *
adumma[(1)- 1] = " ";
Dlatme.dlatme(n,"S",iseed,_iseed_offset,work,_work_offset,imode,cond,one,adumma,0,"T","T","T",work,(n+1)- 1+ _work_offset,4,conds,n,n,anorm,a,_a_offset,lda,work,(2*n+1)- 1+ _work_offset,iinfo);
// *
}              // Close else if()
else if (itype == 7)  {
    // *
// *              Diagonal, random eigenvalues
// *
Dlatmr.dlatmr(n,n,"S",iseed,_iseed_offset,"S",work,_work_offset,6,one,one,"T","N",work,(n+1)- 1+ _work_offset,1,one,work,(2*n+1)- 1+ _work_offset,1,one,"N",idumma,0,0,0,zero,anorm,"NO",a,_a_offset,lda,iwork,_iwork_offset,iinfo);
// *
}              // Close else if()
else if (itype == 8)  {
    // *
// *              Symmetric, random eigenvalues
// *
Dlatmr.dlatmr(n,n,"S",iseed,_iseed_offset,"S",work,_work_offset,6,one,one,"T","N",work,(n+1)- 1+ _work_offset,1,one,work,(2*n+1)- 1+ _work_offset,1,one,"N",idumma,0,n,n,zero,anorm,"NO",a,_a_offset,lda,iwork,_iwork_offset,iinfo);
// *
}              // Close else if()
else if (itype == 9)  {
    // *
// *              General, random eigenvalues
// *
Dlatmr.dlatmr(n,n,"S",iseed,_iseed_offset,"N",work,_work_offset,6,one,one,"T","N",work,(n+1)- 1+ _work_offset,1,one,work,(2*n+1)- 1+ _work_offset,1,one,"N",idumma,0,n,n,zero,anorm,"NO",a,_a_offset,lda,iwork,_iwork_offset,iinfo);
if (n >= 4)  {
    Dlaset.dlaset("Full",2,n,zero,zero,a,_a_offset,lda);
Dlaset.dlaset("Full",n-3,1,zero,zero,a,(3)- 1+(1- 1)*lda+ _a_offset,lda);
Dlaset.dlaset("Full",n-3,2,zero,zero,a,(3)- 1+(n-1- 1)*lda+ _a_offset,lda);
Dlaset.dlaset("Full",1,n,zero,zero,a,(n)- 1+(1- 1)*lda+ _a_offset,lda);
}              // Close if()
// *
}              // Close else if()
else if (itype == 10)  {
    // *
// *              Triangular, random eigenvalues
// *
Dlatmr.dlatmr(n,n,"S",iseed,_iseed_offset,"N",work,_work_offset,6,one,one,"T","N",work,(n+1)- 1+ _work_offset,1,one,work,(2*n+1)- 1+ _work_offset,1,one,"N",idumma,0,n,0,zero,anorm,"NO",a,_a_offset,lda,iwork,_iwork_offset,iinfo);
// *
}              // Close else if()
else  {
  // *
iinfo.val = 1;
}              //  Close else.
// *
if (iinfo.val != 0)  {
    System.out.println(" DDRVSX: "  + ("Generator") + " "  + " returned INFO="  + (iinfo.val) + " "  + "."  + "\n"  + "         " + "N="  + (n) + " "  + ", JTYPE="  + (jtype) + " "  + ", ISEED=("  + (ioldsd) + " "  + ","  + " NULL " + " "  + ","  + " NULL " + " "  + ","  + " NULL " + " "  + ")" );
info.val = (int)(Math.abs(iinfo.val));
Dummy.go_to("Ddrvsx",999999);
}              // Close if()
// *
label90:
   Dummy.label("Ddrvsx",90);
// *
// *           Test for minimal and generous workspace
// *
{
forloop120:
for (iwk = 1; iwk <= 2; iwk++) {
if (iwk == 1)  {
    nnwork = 3*n;
}              // Close if()
else  {
  nnwork = (int)(Math.max(3*n, 2*n*n) );
}              //  Close else.
nnwork = (int)(Math.max(nnwork, 1) );
// *
Dget24.dget24(false,jtype,thresh,ioldsd,0,nounit,n,a,_a_offset,lda,h,_h_offset,ht,_ht_offset,wr,_wr_offset,wi,_wi_offset,wrt,_wrt_offset,wit,_wit_offset,wrtmp,_wrtmp_offset,witmp,_witmp_offset,vs,_vs_offset,ldvs,vs1,_vs1_offset,rcdein,rcdvin,nslct,islct,0,result,_result_offset,work,_work_offset,nnwork,iwork,_iwork_offset,bwork,_bwork_offset,info);
// *
// *              Check for RESULT(j) > THRESH
// *
ntest = 0;
nfail = 0;
{
forloop100:
for (j = 1; j <= 15; j++) {
if (result[(j)- 1+ _result_offset] >= zero)  
    ntest = ntest+1;
if (result[(j)- 1+ _result_offset] >= thresh)  
    nfail = nfail+1;
Dummy.label("Ddrvsx",100);
}              //  Close for() loop. 
}
// *
if (nfail > 0)  
    ntestf = ntestf+1;
if (ntestf == 1)  {
    System.out.println("\n"  + " " + (path) + " "  + " -- Real Schur Form Decomposition Expert "  + "Driver"  + "\n"  + " Matrix types (see DDRVSX for details):" );
System.out.println("\n"  + " Special Matrices:"  + "\n"  + "  1=Zero matrix.             "  + "           "  + "  5=Diagonal: geometr. spaced entries."  + "\n"  + "  2=Identity matrix.                    "  + "  6=Diagona"  + "l: clustered entries."  + "\n"  + "  3=Transposed Jordan block.  "  + "          "  + "  7=Diagonal: large, evenly spaced."  + "\n"  + "  "  + "4=Diagonal: evenly spaced entries.    "  + "  8=Diagonal: s"  + "mall, evenly spaced." );
System.out.println(" Dense, Non-Symmetric Matrices:"  + "\n"  + "  9=Well-cond., ev"  + "enly spaced eigenvals."  + " 14=Ill-cond., geomet. spaced e"  + "igenals."  + "\n"  + " 10=Well-cond., geom. spaced eigenvals. "  + " 15=Ill-conditioned, clustered e.vals."  + "\n"  + " 11=Well-cond"  + "itioned, clustered e.vals. "  + " 16=Ill-cond., random comp"  + "lex "  + "\n"  + " 12=Well-cond., random complex "  + "         "  + " 17=Ill-cond., large rand. complx "  + "\n"  + " 13=Ill-condi"  + "tioned, evenly spaced.     "  + " 18=Ill-cond., small rand."  + " complx " );
System.out.println(" 19=Matrix with random O(1) entries.    "  + " 21=Matrix "  + "with small random entries."  + "\n"  + " 20=Matrix with large ran"  + "dom entries.   "  + "\n" );
System.out.println(" Tests performed with test threshold ="  + (thresh) + " "  + "\n"  + " ( A denotes A on input and T denotes A on output)"  + "\n\n"  + " 1 = 0 if T in Schur form (no sort), "  + "  1/ulp otherwise"  + "\n"  + " 2 = | A - VS T transpose(VS) | / ( n |A| ulp ) (no sort)"  + "\n"  + " 3 = | I - VS transpose(VS) | / ( n ulp ) (no sort) "  + "\n"  + " 4 = 0 if WR+sqrt(-1)*WI are eigenvalues of T (no sort),"  + "  1/ulp otherwise"  + "\n"  + " 5 = 0 if T same no matter if VS computed (no sort),"  + "  1/ulp otherwise"  + "\n"  + " 6 = 0 if WR, WI same no matter if VS computed (no sort)"  + ",  1/ulp otherwise" );
System.out.println(" 7 = 0 if T in Schur form (sort), "  + "  1/ulp otherwise"  + "\n"  + " 8 = | A - VS T transpose(VS) | / ( n |A| ulp ) (sort)"  + "\n"  + " 9 = | I - VS transpose(VS) | / ( n ulp ) (sort) "  + "\n"  + " 10 = 0 if WR+sqrt(-1)*WI are eigenvalues of T (sort),"  + "  1/ulp otherwise"  + "\n"  + " 11 = 0 if T same no matter what else computed (sort),"  + "  1/ulp otherwise"  + "\n"  + " 12 = 0 if WR, WI same no matter what else computed "  + "(sort), 1/ulp otherwise"  + "\n"  + " 13 = 0 if sorting succesful, 1/ulp otherwise"  + "\n"  + " 14 = 0 if RCONDE same no matter what else computed,"  + " 1/ulp otherwise"  + "\n"  + " 15 = 0 if RCONDv same no matter what else computed,"  + " 1/ulp otherwise"  + "\n"  + " 16 = | RCONDE - RCONDE(precomputed) | / cond(RCONDE),"  + "\n"  + " 17 = | RCONDV - RCONDV(precomputed) | / cond(RCONDV)," );
ntestf = 2;
}              // Close if()
// *
{
forloop110:
for (j = 1; j <= 15; j++) {
if (result[(j)- 1+ _result_offset] >= thresh)  {
    System.out.println(" N="  + (n) + " "  + ", IWK="  + (iwk) + " "  + ", seed="  + (ioldsd) + " "  + ","  + (jtype) + " "  + ","  + (j) + " "  + ","  + (result[(j)- 1+ _result_offset]) + " "  + ","  + " type "  + " NULL " + " "  + ", test("  + " NULL " + " "  + ")="  + " NULL " + " " );
}              // Close if()
Dummy.label("Ddrvsx",110);
}              //  Close for() loop. 
}
// *
nerrs = nerrs+nfail;
ntestt = ntestt+ntest;
// *
Dummy.label("Ddrvsx",120);
}              //  Close for() loop. 
}
Dummy.label("Ddrvsx",130);
}              //  Close for() loop. 
}
Dummy.label("Ddrvsx",140);
}              //  Close for() loop. 
}
// *
label150:
   Dummy.label("Ddrvsx",150);
// *
// *     Read in data from file to check accuracy of condition estimation
// *     Read input data until N=0
// *
jtype = 0;
label160:
   Dummy.label("Ddrvsx",160);
try {
n = _f2j_in.readint();
nslct = _f2j_in.readint();
_f2j_in.skipRemaining();
} catch (java.io.IOException e) {
Dummy.go_to("Ddrvsx",200);
}
if (n == 0)  
    Dummy.go_to("Ddrvsx",200);
jtype = jtype+1;
iseed[(1)- 1+ _iseed_offset] = jtype;
if (nslct > 0)  
    for(i = 1; i <= nslct; i++)
islct[(i)- 1] = _f2j_in.readInt();
_f2j_in.skipRemaining();
{
forloop170:
for (i = 1; i <= n; i++) {
for(j = 1; j <= n; j++)
a[(i)- 1+(j- 1)*lda+ _a_offset] = _f2j_in.readDouble();
_f2j_in.skipRemaining();
Dummy.label("Ddrvsx",170);
}              //  Close for() loop. 
}
rcdein = _f2j_in.readDouble();
rcdvin = _f2j_in.readDouble();
_f2j_in.skipRemaining();
// *
Dget24.dget24(true,22,thresh,iseed,_iseed_offset,nounit,n,a,_a_offset,lda,h,_h_offset,ht,_ht_offset,wr,_wr_offset,wi,_wi_offset,wrt,_wrt_offset,wit,_wit_offset,wrtmp,_wrtmp_offset,witmp,_witmp_offset,vs,_vs_offset,ldvs,vs1,_vs1_offset,rcdein,rcdvin,nslct,islct,0,result,_result_offset,work,_work_offset,lwork,iwork,_iwork_offset,bwork,_bwork_offset,info);
// *
// *     Check for RESULT(j) > THRESH
// *
ntest = 0;
nfail = 0;
{
forloop180:
for (j = 1; j <= 17; j++) {
if (result[(j)- 1+ _result_offset] >= zero)  
    ntest = ntest+1;
if (result[(j)- 1+ _result_offset] >= thresh)  
    nfail = nfail+1;
Dummy.label("Ddrvsx",180);
}              //  Close for() loop. 
}
// *
if (nfail > 0)  
    ntestf = ntestf+1;
if (ntestf == 1)  {
    System.out.println("\n"  + " " + (path) + " "  + " -- Real Schur Form Decomposition Expert "  + "Driver"  + "\n"  + " Matrix types (see DDRVSX for details):" );
System.out.println("\n"  + " Special Matrices:"  + "\n"  + "  1=Zero matrix.             "  + "           "  + "  5=Diagonal: geometr. spaced entries."  + "\n"  + "  2=Identity matrix.                    "  + "  6=Diagona"  + "l: clustered entries."  + "\n"  + "  3=Transposed Jordan block.  "  + "          "  + "  7=Diagonal: large, evenly spaced."  + "\n"  + "  "  + "4=Diagonal: evenly spaced entries.    "  + "  8=Diagonal: s"  + "mall, evenly spaced." );
System.out.println(" Dense, Non-Symmetric Matrices:"  + "\n"  + "  9=Well-cond., ev"  + "enly spaced eigenvals."  + " 14=Ill-cond., geomet. spaced e"  + "igenals."  + "\n"  + " 10=Well-cond., geom. spaced eigenvals. "  + " 15=Ill-conditioned, clustered e.vals."  + "\n"  + " 11=Well-cond"  + "itioned, clustered e.vals. "  + " 16=Ill-cond., random comp"  + "lex "  + "\n"  + " 12=Well-cond., random complex "  + "         "  + " 17=Ill-cond., large rand. complx "  + "\n"  + " 13=Ill-condi"  + "tioned, evenly spaced.     "  + " 18=Ill-cond., small rand."  + " complx " );
System.out.println(" 19=Matrix with random O(1) entries.    "  + " 21=Matrix "  + "with small random entries."  + "\n"  + " 20=Matrix with large ran"  + "dom entries.   "  + "\n" );
System.out.println(" Tests performed with test threshold ="  + (thresh) + " "  + "\n"  + " ( A denotes A on input and T denotes A on output)"  + "\n\n"  + " 1 = 0 if T in Schur form (no sort), "  + "  1/ulp otherwise"  + "\n"  + " 2 = | A - VS T transpose(VS) | / ( n |A| ulp ) (no sort)"  + "\n"  + " 3 = | I - VS transpose(VS) | / ( n ulp ) (no sort) "  + "\n"  + " 4 = 0 if WR+sqrt(-1)*WI are eigenvalues of T (no sort),"  + "  1/ulp otherwise"  + "\n"  + " 5 = 0 if T same no matter if VS computed (no sort),"  + "  1/ulp otherwise"  + "\n"  + " 6 = 0 if WR, WI same no matter if VS computed (no sort)"  + ",  1/ulp otherwise" );
System.out.println(" 7 = 0 if T in Schur form (sort), "  + "  1/ulp otherwise"  + "\n"  + " 8 = | A - VS T transpose(VS) | / ( n |A| ulp ) (sort)"  + "\n"  + " 9 = | I - VS transpose(VS) | / ( n ulp ) (sort) "  + "\n"  + " 10 = 0 if WR+sqrt(-1)*WI are eigenvalues of T (sort),"  + "  1/ulp otherwise"  + "\n"  + " 11 = 0 if T same no matter what else computed (sort),"  + "  1/ulp otherwise"  + "\n"  + " 12 = 0 if WR, WI same no matter what else computed "  + "(sort), 1/ulp otherwise"  + "\n"  + " 13 = 0 if sorting succesful, 1/ulp otherwise"  + "\n"  + " 14 = 0 if RCONDE same no matter what else computed,"  + " 1/ulp otherwise"  + "\n"  + " 15 = 0 if RCONDv same no matter what else computed,"  + " 1/ulp otherwise"  + "\n"  + " 16 = | RCONDE - RCONDE(precomputed) | / cond(RCONDE),"  + "\n"  + " 17 = | RCONDV - RCONDV(precomputed) | / cond(RCONDV)," );
ntestf = 2;
}              // Close if()
{
forloop190:
for (j = 1; j <= 17; j++) {
if (result[(j)- 1+ _result_offset] >= thresh)  {
    System.out.println(" N="  + (n) + " "  + ", input example ="  + (jtype) + " "  + ",  test("  + (j) + " "  + ")="  + (result[(j)- 1+ _result_offset]) + " " );
}              // Close if()
Dummy.label("Ddrvsx",190);
}              //  Close for() loop. 
}
// *
nerrs = nerrs+nfail;
ntestt = ntestt+ntest;
Dummy.go_to("Ddrvsx",160);
label200:
   Dummy.label("Ddrvsx",200);
// *
// *     Summary
// *
Dlasum.dlasum(path,nounit,nerrs,ntestt);
// *
// *
// *
Dummy.go_to("Ddrvsx",999999);
// *
// *     End of DDRVSX
// *
Dummy.label("Ddrvsx",999999);
return;
   }
} // End class.
