/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: eigtest.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

import java.lang.*;
import org.netlib.util.*;
import org.netlib.lapack.*;




public class Ddrvvx {

// *
// *  -- LAPACK test routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *     DDRVVX  checks the nonsymmetric eigenvalue problem expert driver
// *     DGEEVX.
// *
// *     DDRVVX uses both test matrices generated randomly depending on
// *     data supplied in the calling sequence, as well as on data
// *     read from an input file and including precomputed condition
// *     numbers to which it compares the ones it computes.
// *
// *     When DDRVVX is called, a number of matrix "sizes" ("n's") and a
// *     number of matrix "types" are specified in the calling sequence.
// *     For each size ("n") and each type of matrix, one matrix will be
// *     generated and used to test the nonsymmetric eigenroutines.  For
// *     each matrix, 9 tests will be performed:
// *
// *     (1)     | A * VR - VR * W | / ( n |A| ulp )
// *
// *       Here VR is the matrix of unit right eigenvectors.
// *       W is a block diagonal matrix, with a 1x1 block for each
// *       real eigenvalue and a 2x2 block for each complex conjugate
// *       pair.  If eigenvalues j and j+1 are a complex conjugate pair,
// *       so WR(j) = WR(j+1) = wr and WI(j) = - WI(j+1) = wi, then the
// *       2 x 2 block corresponding to the pair will be:
// *
// *               (  wr  wi  )
// *               ( -wi  wr  )
// *
// *       Such a block multiplying an n x 2 matrix  ( ur ui ) on the
// *       right will be the same as multiplying  ur + i*ui  by  wr + i*wi.
// *
// *     (2)     | A**H * VL - VL * W**H | / ( n |A| ulp )
// *
// *       Here VL is the matrix of unit left eigenvectors, A**H is the
// *       conjugate transpose of A, and W is as above.
// *
// *     (3)     | |VR(i)| - 1 | / ulp and largest component real
// *
// *       VR(i) denotes the i-th column of VR.
// *
// *     (4)     | |VL(i)| - 1 | / ulp and largest component real
// *
// *       VL(i) denotes the i-th column of VL.
// *
// *     (5)     W(full) = W(partial)
// *
// *       W(full) denotes the eigenvalues computed when VR, VL, RCONDV
// *       and RCONDE are also computed, and W(partial) denotes the
// *       eigenvalues computed when only some of VR, VL, RCONDV, and
// *       RCONDE are computed.
// *
// *     (6)     VR(full) = VR(partial)
// *
// *       VR(full) denotes the right eigenvectors computed when VL, RCONDV
// *       and RCONDE are computed, and VR(partial) denotes the result
// *       when only some of VL and RCONDV are computed.
// *
// *     (7)     VL(full) = VL(partial)
// *
// *       VL(full) denotes the left eigenvectors computed when VR, RCONDV
// *       and RCONDE are computed, and VL(partial) denotes the result
// *       when only some of VR and RCONDV are computed.
// *
// *     (8)     0 if SCALE, ILO, IHI, ABNRM (full) =
// *                  SCALE, ILO, IHI, ABNRM (partial)
// *             1/ulp otherwise
// *
// *       SCALE, ILO, IHI and ABNRM describe how the matrix is balanced.
// *       (full) is when VR, VL, RCONDE and RCONDV are also computed, and
// *       (partial) is when some are not computed.
// *
// *     (9)     RCONDV(full) = RCONDV(partial)
// *
// *       RCONDV(full) denotes the reciprocal condition numbers of the
// *       right eigenvectors computed when VR, VL and RCONDE are also
// *       computed. RCONDV(partial) denotes the reciprocal condition
// *       numbers when only some of VR, VL and RCONDE are computed.
// *
// *     The "sizes" are specified by an array NN(1:NSIZES); the value of
// *     each element NN(j) specifies one size.
// *     The "types" are specified by a logical array DOTYPE( 1:NTYPES );
// *     if DOTYPE(j) is .TRUE., then matrix type "j" will be generated.
// *     Currently, the list of possible types is:
// *
// *     (1)  The zero matrix.
// *     (2)  The identity matrix.
// *     (3)  A (transposed) Jordan block, with 1's on the diagonal.
// *
// *     (4)  A diagonal matrix with evenly spaced entries
// *          1, ..., ULP  and random signs.
// *          (ULP = (first number larger than 1) - 1 )
// *     (5)  A diagonal matrix with geometrically spaced entries
// *          1, ..., ULP  and random signs.
// *     (6)  A diagonal matrix with "clustered" entries 1, ULP, ..., ULP
// *          and random signs.
// *
// *     (7)  Same as (4), but multiplied by a constant near
// *          the overflow threshold
// *     (8)  Same as (4), but multiplied by a constant near
// *          the underflow threshold
// *
// *     (9)  A matrix of the form  U' T U, where U is orthogonal and
// *          T has evenly spaced entries 1, ..., ULP with random signs
// *          on the diagonal and random O(1) entries in the upper
// *          triangle.
// *
// *     (10) A matrix of the form  U' T U, where U is orthogonal and
// *          T has geometrically spaced entries 1, ..., ULP with random
// *          signs on the diagonal and random O(1) entries in the upper
// *          triangle.
// *
// *     (11) A matrix of the form  U' T U, where U is orthogonal and
// *          T has "clustered" entries 1, ULP,..., ULP with random
// *          signs on the diagonal and random O(1) entries in the upper
// *          triangle.
// *
// *     (12) A matrix of the form  U' T U, where U is orthogonal and
// *          T has real or complex conjugate paired eigenvalues randomly
// *          chosen from ( ULP, 1 ) and random O(1) entries in the upper
// *          triangle.
// *
// *     (13) A matrix of the form  X' T X, where X has condition
// *          SQRT( ULP ) and T has evenly spaced entries 1, ..., ULP
// *          with random signs on the diagonal and random O(1) entries
// *          in the upper triangle.
// *
// *     (14) A matrix of the form  X' T X, where X has condition
// *          SQRT( ULP ) and T has geometrically spaced entries
// *          1, ..., ULP with random signs on the diagonal and random
// *          O(1) entries in the upper triangle.
// *
// *     (15) A matrix of the form  X' T X, where X has condition
// *          SQRT( ULP ) and T has "clustered" entries 1, ULP,..., ULP
// *          with random signs on the diagonal and random O(1) entries
// *          in the upper triangle.
// *
// *     (16) A matrix of the form  X' T X, where X has condition
// *          SQRT( ULP ) and T has real or complex conjugate paired
// *          eigenvalues randomly chosen from ( ULP, 1 ) and random
// *          O(1) entries in the upper triangle.
// *
// *     (17) Same as (16), but multiplied by a constant
// *          near the overflow threshold
// *     (18) Same as (16), but multiplied by a constant
// *          near the underflow threshold
// *
// *     (19) Nonsymmetric matrix with random entries chosen from (-1,1).
// *          If N is at least 4, all entries in first two rows and last
// *          row, and first column and last two columns are zero.
// *     (20) Same as (19), but multiplied by a constant
// *          near the overflow threshold
// *     (21) Same as (19), but multiplied by a constant
// *          near the underflow threshold
// *
// *     In addition, an input file will be read from logical unit number
// *     NIUNIT. The file contains matrices along with precomputed
// *     eigenvalues and reciprocal condition numbers for the eigenvalues
// *     and right eigenvectors. For these matrices, in addition to tests
// *     (1) to (9) we will compute the following two tests:
// *
// *    (10)  |RCONDV - RCDVIN| / cond(RCONDV)
// *
// *       RCONDV is the reciprocal right eigenvector condition number
// *       computed by DGEEVX and RCDVIN (the precomputed true value)
// *       is supplied as input. cond(RCONDV) is the condition number of
// *       RCONDV, and takes errors in computing RCONDV into account, so
// *       that the resulting quantity should be O(ULP). cond(RCONDV) is
// *       essentially given by norm(A)/RCONDE.
// *
// *    (11)  |RCONDE - RCDEIN| / cond(RCONDE)
// *
// *       RCONDE is the reciprocal eigenvalue condition number
// *       computed by DGEEVX and RCDEIN (the precomputed true value)
// *       is supplied as input.  cond(RCONDE) is the condition number
// *       of RCONDE, and takes errors in computing RCONDE into account,
// *       so that the resulting quantity should be O(ULP). cond(RCONDE)
// *       is essentially given by norm(A)/RCONDV.
// *
// *  Arguments
// *  ==========
// *
// *  NSIZES  (input) INTEGER
// *          The number of sizes of matrices to use.  NSIZES must be at
// *          least zero. If it is zero, no randomly generated matrices
// *          are tested, but any test matrices read from NIUNIT will be
// *          tested.
// *
// *  NN      (input) INTEGER array, dimension (NSIZES)
// *          An array containing the sizes to be used for the matrices.
// *          Zero values will be skipped.  The values must be at least
// *          zero.
// *
// *  NTYPES  (input) INTEGER
// *          The number of elements in DOTYPE. NTYPES must be at least
// *          zero. If it is zero, no randomly generated test matrices
// *          are tested, but and test matrices read from NIUNIT will be
// *          tested. If it is MAXTYP+1 and NSIZES is 1, then an
// *          additional type, MAXTYP+1 is defined, which is to use
// *          whatever matrix is in A.  This is only useful if
// *          DOTYPE(1:MAXTYP) is .FALSE. and DOTYPE(MAXTYP+1) is .TRUE. .
// *
// *  DOTYPE  (input) LOGICAL array, dimension (NTYPES)
// *          If DOTYPE(j) is .TRUE., then for each size in NN a
// *          matrix of that size and of type j will be generated.
// *          If NTYPES is smaller than the maximum number of types
// *          defined (PARAMETER MAXTYP), then types NTYPES+1 through
// *          MAXTYP will not be generated.  If NTYPES is larger
// *          than MAXTYP, DOTYPE(MAXTYP+1) through DOTYPE(NTYPES)
// *          will be ignored.
// *
// *  ISEED   (input/output) INTEGER array, dimension (4)
// *          On entry ISEED specifies the seed of the random number
// *          generator. The array elements should be between 0 and 4095;
// *          if not they will be reduced mod 4096.  Also, ISEED(4) must
// *          be odd.  The random number generator uses a linear
// *          congruential sequence limited to small integers, and so
// *          should produce machine independent random numbers. The
// *          values of ISEED are changed on exit, and can be used in the
// *          next call to DDRVVX to continue the same random number
// *          sequence.
// *
// *  THRESH  (input) DOUBLE PRECISION
// *          A test will count as "failed" if the "error", computed as
// *          described above, exceeds THRESH.  Note that the error
// *          is scaled to be O(1), so THRESH should be a reasonably
// *          small multiple of 1, e.g., 10 or 100.  In particular,
// *          it should not depend on the precision (single vs. double)
// *          or the size of the matrix.  It must be at least zero.
// *
// *  NIUNIT  (input) INTEGER
// *          The FORTRAN unit number for reading in the data file of
// *          problems to solve.
// *
// *  NOUNIT  (input) INTEGER
// *          The FORTRAN unit number for printing out error messages
// *          (e.g., if a routine returns INFO not equal to 0.)
// *
// *  A       (workspace) DOUBLE PRECISION array, dimension
// *                      (LDA, max(NN,12))
// *          Used to hold the matrix whose eigenvalues are to be
// *          computed.  On exit, A contains the last matrix actually used.
// *
// *  LDA     (input) INTEGER
// *          The leading dimension of the arrays A and H.
// *          LDA >= max(NN,12), since 12 is the dimension of the largest
// *          matrix in the precomputed input file.
// *
// *  H       (workspace) DOUBLE PRECISION array, dimension
// *                      (LDA, max(NN,12))
// *          Another copy of the test matrix A, modified by DGEEVX.
// *
// *  WR      (workspace) DOUBLE PRECISION array, dimension (max(NN))
// *  WI      (workspace) DOUBLE PRECISION array, dimension (max(NN))
// *          The real and imaginary parts of the eigenvalues of A.
// *          On exit, WR + WI*i are the eigenvalues of the matrix in A.
// *
// *  WR1     (workspace) DOUBLE PRECISION array, dimension (max(NN,12))
// *  WI1     (workspace) DOUBLE PRECISION array, dimension (max(NN,12))
// *          Like WR, WI, these arrays contain the eigenvalues of A,
// *          but those computed when DGEEVX only computes a partial
// *          eigendecomposition, i.e. not the eigenvalues and left
// *          and right eigenvectors.
// *
// *  VL      (workspace) DOUBLE PRECISION array, dimension
// *                      (LDVL, max(NN,12))
// *          VL holds the computed left eigenvectors.
// *
// *  LDVL    (input) INTEGER
// *          Leading dimension of VL. Must be at least max(1,max(NN,12)).
// *
// *  VR      (workspace) DOUBLE PRECISION array, dimension
// *                      (LDVR, max(NN,12))
// *          VR holds the computed right eigenvectors.
// *
// *  LDVR    (input) INTEGER
// *          Leading dimension of VR. Must be at least max(1,max(NN,12)).
// *
// *  LRE     (workspace) DOUBLE PRECISION array, dimension
// *                      (LDLRE, max(NN,12))
// *          LRE holds the computed right or left eigenvectors.
// *
// *  LDLRE   (input) INTEGER
// *          Leading dimension of LRE. Must be at least max(1,max(NN,12))
// *
// *  RCONDV  (workspace) DOUBLE PRECISION array, dimension (N)
// *          RCONDV holds the computed reciprocal condition numbers
// *          for eigenvectors.
// *
// *  RCNDV1  (workspace) DOUBLE PRECISION array, dimension (N)
// *          RCNDV1 holds more computed reciprocal condition numbers
// *          for eigenvectors.
// *
// *  RCDVIN  (workspace) DOUBLE PRECISION array, dimension (N)
// *          When COMP = .TRUE. RCDVIN holds the precomputed reciprocal
// *          condition numbers for eigenvectors to be compared with
// *          RCONDV.
// *
// *  RCONDE  (workspace) DOUBLE PRECISION array, dimension (N)
// *          RCONDE holds the computed reciprocal condition numbers
// *          for eigenvalues.
// *
// *  RCNDE1  (workspace) DOUBLE PRECISION array, dimension (N)
// *          RCNDE1 holds more computed reciprocal condition numbers
// *          for eigenvalues.
// *
// *  RCDEIN  (workspace) DOUBLE PRECISION array, dimension (N)
// *          When COMP = .TRUE. RCDEIN holds the precomputed reciprocal
// *          condition numbers for eigenvalues to be compared with
// *          RCONDE.
// *
// *  RESULT  (output) DOUBLE PRECISION array, dimension (11)
// *          The values computed by the seven tests described above.
// *          The values are currently limited to 1/ulp, to avoid overflow.
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension (NWORK)
// *
// *  NWORK   (input) INTEGER
// *          The number of entries in WORK.  This must be at least
// *          max(6*12+2*12**2,6*NN(j)+2*NN(j)**2) =
// *          max(    360     ,6*NN(j)+2*NN(j)**2)    for all j.
// *
// *  IWORK   (workspace) INTEGER array, dimension (2*max(NN,12))
// *
// *  INFO    (output) INTEGER
// *          If 0,  then successful exit.
// *          If <0, then input paramter -INFO is incorrect.
// *          If >0, DLATMR, SLATMS, SLATME or DGET23 returned an error
// *                 code, and INFO is its absolute value.
// *
// *-----------------------------------------------------------------------
// *
// *     Some Local Variables and Parameters:
// *     ---- ----- --------- --- ----------
// *
// *     ZERO, ONE       Real 0 and 1.
// *     MAXTYP          The number of types defined.
// *     NMAX            Largest value in NN or 12.
// *     NERRS           The number of tests which have exceeded THRESH
// *     COND, CONDS,
// *     IMODE           Values to be passed to the matrix generators.
// *     ANORM           Norm of A; passed to matrix generators.
// *
// *     OVFL, UNFL      Overflow and underflow thresholds.
// *     ULP, ULPINV     Finest relative precision and its inverse.
// *     RTULP, RTULPI   Square roots of the previous 4 values.
// *
// *             The following four arrays decode JTYPE:
// *     KTYPE(j)        The general type (1-10) for type "j".
// *     KMODE(j)        The MODE value to be passed to the matrix
// *                     generator for type "j".
// *     KMAGN(j)        The order of magnitude ( O(1),
// *                     O(overflow^(1/2) ), O(underflow^(1/2) )
// *     KCONDS(j)       Selectw whether CONDS is to be 1 or
// *                     1/sqrt(ulp).  (0 means irrelevant.)
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e0;
static double one= 1.0e0;
static int maxtyp= 21;
// *     ..
// *     .. Local Scalars ..
static boolean badnn= false;
static String balanc= new String(" ");
static String path= new String("   ");
static int i= 0;
static int ibal= 0;
static intW iinfo= new intW(0);
static int imode= 0;
static int itype= 0;
static int iwk= 0;
static int j= 0;
static int jcol= 0;
static int jsize= 0;
static int jtype= 0;
static int mtypes= 0;
static int n= 0;
static int nerrs= 0;
static int nfail= 0;
static int nmax= 0;
static int nnwork= 0;
static int ntest= 0;
static int ntestf= 0;
static int ntestt= 0;
static double anorm= 0.0;
static double cond= 0.0;
static double conds= 0.0;
static doubleW ovfl= new doubleW(0.0);
static double rtulp= 0.0;
static double rtulpi= 0.0;
static double ulp= 0.0;
static double ulpinv= 0.0;
static doubleW unfl= new doubleW(0.0);
// *     ..
// *     .. Local Arrays ..
static String [] adumma= new String[(1)];
static int [] idumma= new int[(1)];
static int [] ioldsd= new int[(4)];
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Data statements ..
static int [] ktype = {1 
, 2 , 3 , 4, 4, 4, 4, 4 , 6, 6, 6, 6 , 6, 6, 6, 6, 6, 6 
, 9, 9, 9 };
static int [] kmagn = {1, 1, 1 
, 1 , 1 , 1 , 2 , 3 
, 1, 1, 1, 1 , 1 , 1 , 1 , 1 
, 2 , 3 , 1 , 2 , 3 
};
static int [] kmode = {0, 0, 0 
, 4 , 3 , 1 , 4 , 4 
, 4 , 3 , 1 , 5 , 4 
, 3 , 1 , 5 , 5 , 5 
, 4 , 3 , 1 };
static int [] kconds = {0, 0, 0 
, 0, 0, 0, 0, 0 , 1, 1, 1, 1 , 2, 2, 2, 2, 2, 2 , 0, 0, 0 };
static String [] bal = {"N" 
, "P" , "S" , "B" };
// *     ..
// *     .. Executable Statements ..
// *

public static void ddrvvx (int nsizes,
int [] nn, int _nn_offset,
int ntypes,
boolean [] dotype, int _dotype_offset,
int [] iseed, int _iseed_offset,
double thresh,
int niunit,
int nounit,
double [] a, int _a_offset,
int lda,
double [] h, int _h_offset,
double [] wr, int _wr_offset,
double [] wi, int _wi_offset,
double [] wr1, int _wr1_offset,
double [] wi1, int _wi1_offset,
double [] vl, int _vl_offset,
int ldvl,
double [] vr, int _vr_offset,
int ldvr,
double [] lre, int _lre_offset,
int ldlre,
double [] rcondv, int _rcondv_offset,
double [] rcndv1, int _rcndv1_offset,
double [] rcdvin, int _rcdvin_offset,
double [] rconde, int _rconde_offset,
double [] rcnde1, int _rcnde1_offset,
double [] rcdein, int _rcdein_offset,
double [] scale, int _scale_offset,
double [] scale1, int _scale1_offset,
double [] result, int _result_offset,
double [] work, int _work_offset,
int nwork,
int [] iwork, int _iwork_offset,
intW info)  {

  EasyIn _f2j_in = new EasyIn();
{
  int E1, E2;
  E1 = 1;
  E2 = 1;
path = new String(path.substring(0,E1-1) + "D".substring(0,E2-E1+1) + path.substring(E2,path.length()));
}
;
{
  int E1, E2;
  E1 = 2;
  E2 = 3;
path = new String(path.substring(0,E1-1) + "VX".substring(0,E2-E1+1) + path.substring(E2,path.length()));
}
;
// *
// *     Check for errors
// *
ntestt = 0;
ntestf = 0;
info.val = 0;
// *
// *     Important constants
// *
badnn = false;
// *
// *     12 is the largest dimension in the input file of precomputed
// *     problems
// *
nmax = 12;
{
forloop10:
for (j = 1; j <= nsizes; j++) {
nmax = (int)(Math.max(nmax, nn[(j)- 1+ _nn_offset]) );
if (nn[(j)- 1+ _nn_offset] < 0)  
    badnn = true;
Dummy.label("Ddrvvx",10);
}              //  Close for() loop. 
}
// *
// *     Check for errors
// *
if (nsizes < 0)  {
    info.val = -1;
}              // Close if()
else if (badnn)  {
    info.val = -2;
}              // Close else if()
else if (ntypes < 0)  {
    info.val = -3;
}              // Close else if()
else if (thresh < zero)  {
    info.val = -6;
}              // Close else if()
else if (lda < 1 || lda < nmax)  {
    info.val = -10;
}              // Close else if()
else if (ldvl < 1 || ldvl < nmax)  {
    info.val = -17;
}              // Close else if()
else if (ldvr < 1 || ldvr < nmax)  {
    info.val = -19;
}              // Close else if()
else if (ldlre < 1 || ldlre < nmax)  {
    info.val = -21;
}              // Close else if()
else if (6*nmax+2*Math.pow(nmax, 2) > nwork)  {
    info.val = -32;
}              // Close else if()
// *
if (info.val != 0)  {
    Xerbla.xerbla("DDRVVX",-info.val);
Dummy.go_to("Ddrvvx",999999);
}              // Close if()
// *
// *     If nothing to do check on NIUNIT
// *
if (nsizes == 0 || ntypes == 0)  
    Dummy.go_to("Ddrvvx",160);
// *
// *     More Important constants
// *
unfl.val = Dlamch.dlamch("Safe minimum");
ovfl.val = one/unfl.val;
Dlabad.dlabad(unfl,ovfl);
ulp = Dlamch.dlamch("Precision");
ulpinv = one/ulp;
rtulp = Math.sqrt(ulp);
rtulpi = one/rtulp;
// *
// *     Loop over sizes, types
// *
nerrs = 0;
// *
{
forloop150:
for (jsize = 1; jsize <= nsizes; jsize++) {
n = nn[(jsize)- 1+ _nn_offset];
if (nsizes != 1)  {
    mtypes = (int)(Math.min(maxtyp, ntypes) );
}              // Close if()
else  {
  mtypes = (int)(Math.min(maxtyp+1, ntypes) );
}              //  Close else.
// *
{
forloop140:
for (jtype = 1; jtype <= mtypes; jtype++) {
if (!dotype[(jtype)- 1+ _dotype_offset])  
    continue forloop140;
// *
// *           Save ISEED in case of an error.
// *
{
forloop20:
for (j = 1; j <= 4; j++) {
ioldsd[(j)- 1] = iseed[(j)- 1+ _iseed_offset];
Dummy.label("Ddrvvx",20);
}              //  Close for() loop. 
}
// *
// *           Compute "A"
// *
// *           Control parameters:
// *
// *           KMAGN  KCONDS  KMODE        KTYPE
// *       =1  O(1)   1       clustered 1  zero
// *       =2  large  large   clustered 2  identity
// *       =3  small          exponential  Jordan
// *       =4                 arithmetic   diagonal, (w/ eigenvalues)
// *       =5                 random log   symmetric, w/ eigenvalues
// *       =6                 random       general, w/ eigenvalues
// *       =7                              random diagonal
// *       =8                              random symmetric
// *       =9                              random general
// *       =10                             random triangular
// *
if (mtypes > maxtyp)  
    Dummy.go_to("Ddrvvx",90);
// *
itype = ktype[(jtype)- 1];
imode = kmode[(jtype)- 1];
// *
// *           Compute norm
// *
if (kmagn[(jtype)- 1] == 1) 
  Dummy.go_to("Ddrvvx",30);
else if (kmagn[(jtype)- 1] == 2) 
  Dummy.go_to("Ddrvvx",40);
else if (kmagn[(jtype)- 1] == 3) 
  Dummy.go_to("Ddrvvx",50);
// *
label30:
   Dummy.label("Ddrvvx",30);
anorm = one;
Dummy.go_to("Ddrvvx",60);
// *
label40:
   Dummy.label("Ddrvvx",40);
anorm = ovfl.val*ulp;
Dummy.go_to("Ddrvvx",60);
// *
label50:
   Dummy.label("Ddrvvx",50);
anorm = unfl.val*ulpinv;
Dummy.go_to("Ddrvvx",60);
// *
label60:
   Dummy.label("Ddrvvx",60);
// *
Dlaset.dlaset("Full",lda,n,zero,zero,a,_a_offset,lda);
iinfo.val = 0;
cond = ulpinv;
// *
// *           Special Matrices -- Identity & Jordan block
// *
// *              Zero
// *
if (itype == 1)  {
    iinfo.val = 0;
// *
}              // Close if()
else if (itype == 2)  {
    // *
// *              Identity
// *
{
forloop70:
for (jcol = 1; jcol <= n; jcol++) {
a[(jcol)- 1+(jcol- 1)*lda+ _a_offset] = anorm;
Dummy.label("Ddrvvx",70);
}              //  Close for() loop. 
}
// *
}              // Close else if()
else if (itype == 3)  {
    // *
// *              Jordan Block
// *
{
forloop80:
for (jcol = 1; jcol <= n; jcol++) {
a[(jcol)- 1+(jcol- 1)*lda+ _a_offset] = anorm;
if (jcol > 1)  
    a[(jcol)- 1+(jcol-1- 1)*lda+ _a_offset] = one;
Dummy.label("Ddrvvx",80);
}              //  Close for() loop. 
}
// *
}              // Close else if()
else if (itype == 4)  {
    // *
// *              Diagonal Matrix, [Eigen]values Specified
// *
Dlatms.dlatms(n,n,"S",iseed,_iseed_offset,"S",work,_work_offset,imode,cond,anorm,0,0,"N",a,_a_offset,lda,work,(n+1)- 1+ _work_offset,iinfo);
// *
}              // Close else if()
else if (itype == 5)  {
    // *
// *              Symmetric, eigenvalues specified
// *
Dlatms.dlatms(n,n,"S",iseed,_iseed_offset,"S",work,_work_offset,imode,cond,anorm,n,n,"N",a,_a_offset,lda,work,(n+1)- 1+ _work_offset,iinfo);
// *
}              // Close else if()
else if (itype == 6)  {
    // *
// *              General, eigenvalues specified
// *
if (kconds[(jtype)- 1] == 1)  {
    conds = one;
}              // Close if()
else if (kconds[(jtype)- 1] == 2)  {
    conds = rtulpi;
}              // Close else if()
else  {
  conds = zero;
}              //  Close else.
// *
adumma[(1)- 1] = " ";
Dlatme.dlatme(n,"S",iseed,_iseed_offset,work,_work_offset,imode,cond,one,adumma,0,"T","T","T",work,(n+1)- 1+ _work_offset,4,conds,n,n,anorm,a,_a_offset,lda,work,(2*n+1)- 1+ _work_offset,iinfo);
// *
}              // Close else if()
else if (itype == 7)  {
    // *
// *              Diagonal, random eigenvalues
// *
Dlatmr.dlatmr(n,n,"S",iseed,_iseed_offset,"S",work,_work_offset,6,one,one,"T","N",work,(n+1)- 1+ _work_offset,1,one,work,(2*n+1)- 1+ _work_offset,1,one,"N",idumma,0,0,0,zero,anorm,"NO",a,_a_offset,lda,iwork,_iwork_offset,iinfo);
// *
}              // Close else if()
else if (itype == 8)  {
    // *
// *              Symmetric, random eigenvalues
// *
Dlatmr.dlatmr(n,n,"S",iseed,_iseed_offset,"S",work,_work_offset,6,one,one,"T","N",work,(n+1)- 1+ _work_offset,1,one,work,(2*n+1)- 1+ _work_offset,1,one,"N",idumma,0,n,n,zero,anorm,"NO",a,_a_offset,lda,iwork,_iwork_offset,iinfo);
// *
}              // Close else if()
else if (itype == 9)  {
    // *
// *              General, random eigenvalues
// *
Dlatmr.dlatmr(n,n,"S",iseed,_iseed_offset,"N",work,_work_offset,6,one,one,"T","N",work,(n+1)- 1+ _work_offset,1,one,work,(2*n+1)- 1+ _work_offset,1,one,"N",idumma,0,n,n,zero,anorm,"NO",a,_a_offset,lda,iwork,_iwork_offset,iinfo);
if (n >= 4)  {
    Dlaset.dlaset("Full",2,n,zero,zero,a,_a_offset,lda);
Dlaset.dlaset("Full",n-3,1,zero,zero,a,(3)- 1+(1- 1)*lda+ _a_offset,lda);
Dlaset.dlaset("Full",n-3,2,zero,zero,a,(3)- 1+(n-1- 1)*lda+ _a_offset,lda);
Dlaset.dlaset("Full",1,n,zero,zero,a,(n)- 1+(1- 1)*lda+ _a_offset,lda);
}              // Close if()
// *
}              // Close else if()
else if (itype == 10)  {
    // *
// *              Triangular, random eigenvalues
// *
Dlatmr.dlatmr(n,n,"S",iseed,_iseed_offset,"N",work,_work_offset,6,one,one,"T","N",work,(n+1)- 1+ _work_offset,1,one,work,(2*n+1)- 1+ _work_offset,1,one,"N",idumma,0,n,0,zero,anorm,"NO",a,_a_offset,lda,iwork,_iwork_offset,iinfo);
// *
}              // Close else if()
else  {
  // *
iinfo.val = 1;
}              //  Close else.
// *
if (iinfo.val != 0)  {
    System.out.println(" DDRVVX: "  + ("Generator") + " "  + " returned INFO="  + (iinfo.val) + " "  + "."  + "\n"  + "         " + "N="  + (n) + " "  + ", JTYPE="  + (jtype) + " "  + ", ISEED=("  + (ioldsd) + " "  + ","  + " NULL " + " "  + ","  + " NULL " + " "  + ","  + " NULL " + " "  + ")" );
info.val = (int)(Math.abs(iinfo.val));
Dummy.go_to("Ddrvvx",999999);
}              // Close if()
// *
label90:
   Dummy.label("Ddrvvx",90);
// *
// *           Test for minimal and generous workspace
// *
{
forloop130:
for (iwk = 1; iwk <= 3; iwk++) {
if (iwk == 1)  {
    nnwork = 3*n;
}              // Close if()
else if (iwk == 2)  {
    nnwork = (int)(6*n+Math.pow(n, 2));
}              // Close else if()
else  {
  nnwork = (int)(6*n+2*Math.pow(n, 2));
}              //  Close else.
nnwork = (int)(Math.max(nnwork, 1) );
// *
// *              Test for all balancing options
// *
{
forloop120:
for (ibal = 1; ibal <= 4; ibal++) {
balanc = bal[(ibal)- 1];
// *
// *                 Perform tests
// *
Dget23.dget23(false,balanc,jtype,thresh,ioldsd,0,nounit,n,a,_a_offset,lda,h,_h_offset,wr,_wr_offset,wi,_wi_offset,wr1,_wr1_offset,wi1,_wi1_offset,vl,_vl_offset,ldvl,vr,_vr_offset,ldvr,lre,_lre_offset,ldlre,rcondv,_rcondv_offset,rcndv1,_rcndv1_offset,rcdvin,_rcdvin_offset,rconde,_rconde_offset,rcnde1,_rcnde1_offset,rcdein,_rcdein_offset,scale,_scale_offset,scale1,_scale1_offset,result,_result_offset,work,_work_offset,nnwork,iwork,_iwork_offset,info);
// *
// *                 Check for RESULT(j) > THRESH
// *
ntest = 0;
nfail = 0;
{
forloop100:
for (j = 1; j <= 9; j++) {
if (result[(j)- 1+ _result_offset] >= zero)  
    ntest = ntest+1;
if (result[(j)- 1+ _result_offset] >= thresh)  
    nfail = nfail+1;
Dummy.label("Ddrvvx",100);
}              //  Close for() loop. 
}
// *
if (nfail > 0)  
    ntestf = ntestf+1;
if (ntestf == 1)  {
    System.out.println("\n"  + " " + (path) + " "  + " -- Real Eigenvalue-Eigenvector Decomposition"  + " Expert Driver"  + "\n"  + " Matrix types (see DDRVVX for details): " );
System.out.println("\n"  + " Special Matrices:"  + "\n"  + "  1=Zero matrix.             "  + "           "  + "  5=Diagonal: geometr. spaced entries."  + "\n"  + "  2=Identity matrix.                    "  + "  6=Diagona"  + "l: clustered entries."  + "\n"  + "  3=Transposed Jordan block.  "  + "          "  + "  7=Diagonal: large, evenly spaced."  + "\n"  + "  "  + "4=Diagonal: evenly spaced entries.    "  + "  8=Diagonal: s"  + "mall, evenly spaced." );
System.out.println(" Dense, Non-Symmetric Matrices:"  + "\n"  + "  9=Well-cond., ev"  + "enly spaced eigenvals."  + " 14=Ill-cond., geomet. spaced e"  + "igenals."  + "\n"  + " 10=Well-cond., geom. spaced eigenvals. "  + " 15=Ill-conditioned, clustered e.vals."  + "\n"  + " 11=Well-cond"  + "itioned, clustered e.vals. "  + " 16=Ill-cond., random comp"  + "lex "  + "\n"  + " 12=Well-cond., random complex "  + "         "  + " 17=Ill-cond., large rand. complx "  + "\n"  + " 13=Ill-condi"  + "tioned, evenly spaced.     "  + " 18=Ill-cond., small rand."  + " complx " );
System.out.println(" 19=Matrix with random O(1) entries.    "  + " 21=Matrix "  + "with small random entries."  + "\n"  + " 20=Matrix with large ran"  + "dom entries.   "  + " 22=Matrix read from input file"  + "\n" );
System.out.println(" Tests performed with test threshold ="  + (thresh) + " "  + "\n\n"  + " 1 = | A VR - VR W | / ( n |A| ulp ) "  + "\n"  + " 2 = | transpose(A) VL - VL W | / ( n |A| ulp ) "  + "\n"  + " 3 = | |VR(i)| - 1 | / ulp "  + "\n"  + " 4 = | |VL(i)| - 1 | / ulp "  + "\n"  + " 5 = 0 if W same no matter if VR or VL computed,"  + " 1/ulp otherwise"  + "\n"  + " 6 = 0 if VR same no matter what else computed,"  + "  1/ulp otherwise"  + "\n"  + " 7 = 0 if VL same no matter what else computed,"  + "  1/ulp otherwise"  + "\n"  + " 8 = 0 if RCONDV same no matter what else computed,"  + "  1/ulp otherwise"  + "\n"  + " 9 = 0 if SCALE, ILO, IHI, ABNRM same no matter what else"  + " computed,  1/ulp otherwise"  + "\n"  + " 10 = | RCONDV - RCONDV(precomputed) | / cond(RCONDV),"  + "\n"  + " 11 = | RCONDE - RCONDE(precomputed) | / cond(RCONDE)," );
ntestf = 2;
}              // Close if()
// *
{
forloop110:
for (j = 1; j <= 9; j++) {
if (result[(j)- 1+ _result_offset] >= thresh)  {
    System.out.println(" BALANC=\'"  + (balanc) + " "  + "\',N="  + (n) + " "  + ",IWK="  + (iwk) + " "  + ", seed="  + (ioldsd) + " "  + ","  + (jtype) + " "  + ","  + (j) + " "  + ","  + (result[(j)- 1+ _result_offset]) + " "  + ","  + " type "  + " NULL " + " "  + ", test("  + " NULL " + " "  + ")="  + " NULL " + " " );
}              // Close if()
Dummy.label("Ddrvvx",110);
}              //  Close for() loop. 
}
// *
nerrs = nerrs+nfail;
ntestt = ntestt+ntest;
// *
Dummy.label("Ddrvvx",120);
}              //  Close for() loop. 
}
Dummy.label("Ddrvvx",130);
}              //  Close for() loop. 
}
Dummy.label("Ddrvvx",140);
}              //  Close for() loop. 
}
Dummy.label("Ddrvvx",150);
}              //  Close for() loop. 
}
// *
label160:
   Dummy.label("Ddrvvx",160);
// *
// *     Read in data from file to check accuracy of condition estimation.
// *     Assume input eigenvalues are sorted lexicographically (increasing
// *     by real part, then decreasing by imaginary part)
// *
jtype = 0;
label170:
   Dummy.label("Ddrvvx",170);
try {
n = _f2j_in.readint();
_f2j_in.skipRemaining();
} catch (java.io.IOException e) {
Dummy.go_to("Ddrvvx",220);
}
// *
// *     Read input data until N=0
// *
if (n == 0)  
    Dummy.go_to("Ddrvvx",220);
jtype = jtype+1;
iseed[(1)- 1+ _iseed_offset] = jtype;
{
forloop180:
for (i = 1; i <= n; i++) {
for(j = 1; j <= n; j++)
a[(i)- 1+(j- 1)*lda+ _a_offset] = _f2j_in.readDouble();
_f2j_in.skipRemaining();
Dummy.label("Ddrvvx",180);
}              //  Close for() loop. 
}
{
forloop190:
for (i = 1; i <= n; i++) {
wr1[(i)- 1+ _wr1_offset] = _f2j_in.readDouble();
wi1[(i)- 1+ _wi1_offset] = _f2j_in.readDouble();
rcdein[(i)- 1+ _rcdein_offset] = _f2j_in.readDouble();
rcdvin[(i)- 1+ _rcdvin_offset] = _f2j_in.readDouble();
_f2j_in.skipRemaining();
Dummy.label("Ddrvvx",190);
}              //  Close for() loop. 
}
Dget23.dget23(true,"N",22,thresh,iseed,_iseed_offset,nounit,n,a,_a_offset,lda,h,_h_offset,wr,_wr_offset,wi,_wi_offset,wr1,_wr1_offset,wi1,_wi1_offset,vl,_vl_offset,ldvl,vr,_vr_offset,ldvr,lre,_lre_offset,ldlre,rcondv,_rcondv_offset,rcndv1,_rcndv1_offset,rcdvin,_rcdvin_offset,rconde,_rconde_offset,rcnde1,_rcnde1_offset,rcdein,_rcdein_offset,scale,_scale_offset,scale1,_scale1_offset,result,_result_offset,work,_work_offset,(int) ( 6*n+2*Math.pow(n, 2)),iwork,_iwork_offset,info);
// *
// *     Check for RESULT(j) > THRESH
// *
ntest = 0;
nfail = 0;
{
forloop200:
for (j = 1; j <= 11; j++) {
if (result[(j)- 1+ _result_offset] >= zero)  
    ntest = ntest+1;
if (result[(j)- 1+ _result_offset] >= thresh)  
    nfail = nfail+1;
Dummy.label("Ddrvvx",200);
}              //  Close for() loop. 
}
// *
if (nfail > 0)  
    ntestf = ntestf+1;
if (ntestf == 1)  {
    System.out.println("\n"  + " " + (path) + " "  + " -- Real Eigenvalue-Eigenvector Decomposition"  + " Expert Driver"  + "\n"  + " Matrix types (see DDRVVX for details): " );
System.out.println("\n"  + " Special Matrices:"  + "\n"  + "  1=Zero matrix.             "  + "           "  + "  5=Diagonal: geometr. spaced entries."  + "\n"  + "  2=Identity matrix.                    "  + "  6=Diagona"  + "l: clustered entries."  + "\n"  + "  3=Transposed Jordan block.  "  + "          "  + "  7=Diagonal: large, evenly spaced."  + "\n"  + "  "  + "4=Diagonal: evenly spaced entries.    "  + "  8=Diagonal: s"  + "mall, evenly spaced." );
System.out.println(" Dense, Non-Symmetric Matrices:"  + "\n"  + "  9=Well-cond., ev"  + "enly spaced eigenvals."  + " 14=Ill-cond., geomet. spaced e"  + "igenals."  + "\n"  + " 10=Well-cond., geom. spaced eigenvals. "  + " 15=Ill-conditioned, clustered e.vals."  + "\n"  + " 11=Well-cond"  + "itioned, clustered e.vals. "  + " 16=Ill-cond., random comp"  + "lex "  + "\n"  + " 12=Well-cond., random complex "  + "         "  + " 17=Ill-cond., large rand. complx "  + "\n"  + " 13=Ill-condi"  + "tioned, evenly spaced.     "  + " 18=Ill-cond., small rand."  + " complx " );
System.out.println(" 19=Matrix with random O(1) entries.    "  + " 21=Matrix "  + "with small random entries."  + "\n"  + " 20=Matrix with large ran"  + "dom entries.   "  + " 22=Matrix read from input file"  + "\n" );
System.out.println(" Tests performed with test threshold ="  + (thresh) + " "  + "\n\n"  + " 1 = | A VR - VR W | / ( n |A| ulp ) "  + "\n"  + " 2 = | transpose(A) VL - VL W | / ( n |A| ulp ) "  + "\n"  + " 3 = | |VR(i)| - 1 | / ulp "  + "\n"  + " 4 = | |VL(i)| - 1 | / ulp "  + "\n"  + " 5 = 0 if W same no matter if VR or VL computed,"  + " 1/ulp otherwise"  + "\n"  + " 6 = 0 if VR same no matter what else computed,"  + "  1/ulp otherwise"  + "\n"  + " 7 = 0 if VL same no matter what else computed,"  + "  1/ulp otherwise"  + "\n"  + " 8 = 0 if RCONDV same no matter what else computed,"  + "  1/ulp otherwise"  + "\n"  + " 9 = 0 if SCALE, ILO, IHI, ABNRM same no matter what else"  + " computed,  1/ulp otherwise"  + "\n"  + " 10 = | RCONDV - RCONDV(precomputed) | / cond(RCONDV),"  + "\n"  + " 11 = | RCONDE - RCONDE(precomputed) | / cond(RCONDE)," );
ntestf = 2;
}              // Close if()
// *
{
forloop210:
for (j = 1; j <= 11; j++) {
if (result[(j)- 1+ _result_offset] >= thresh)  {
    System.out.println(" N="  + (n) + " "  + ", input example ="  + (jtype) + " "  + ",  test("  + (j) + " "  + ")="  + (result[(j)- 1+ _result_offset]) + " " );
}              // Close if()
Dummy.label("Ddrvvx",210);
}              //  Close for() loop. 
}
// *
nerrs = nerrs+nfail;
ntestt = ntestt+ntest;
Dummy.go_to("Ddrvvx",170);
label220:
   Dummy.label("Ddrvvx",220);
// *
// *     Summary
// *
Dlasum.dlasum(path,nounit,nerrs,ntestt);
// *
// *
// *
Dummy.go_to("Ddrvvx",999999);
// *
// *     End of DDRVVX
// *
Dummy.label("Ddrvvx",999999);
return;
   }
} // End class.
