/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: eigtest.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

import java.lang.*;
import org.netlib.util.*;
import org.netlib.lapack.*;




public class Dlatm2 {

// *
// *  -- LAPACK auxiliary test routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     February 29, 1992
// *
// *     .. Scalar Arguments ..
// *
// *     ..
// *
// *     .. Array Arguments ..
// *
// *     ..
// *
// *  Purpose
// *  =======
// *
// *     DLATM2 returns the (I,J) entry of a random matrix of dimension
// *     (M, N) described by the other paramters. It is called by the
// *     DLATMR routine in order to build random test matrices. No error
// *     checking on parameters is done, because this routine is called in
// *     a tight loop by DLATMR which has already checked the parameters.
// *
// *     Use of DLATM2 differs from SLATM3 in the order in which the random
// *     number generator is called to fill in random matrix entries.
// *     With DLATM2, the generator is called to fill in the pivoted matrix
// *     columnwise. With DLATM3, the generator is called to fill in the
// *     matrix columnwise, after which it is pivoted. Thus, DLATM3 can
// *     be used to construct random matrices which differ only in their
// *     order of rows and/or columns. DLATM2 is used to construct band
// *     matrices while avoiding calling the random number generator for
// *     entries outside the band (and therefore generating random numbers
// *
// *     The matrix whose (I,J) entry is returned is constructed as
// *     follows (this routine only computes one entry):
// *
// *       If I is outside (1..M) or J is outside (1..N), return zero
// *          (this is convenient for generating matrices in band format).
// *
// *       Generate a matrix A with random entries of distribution IDIST.
// *
// *       Set the diagonal to D.
// *
// *       Grade the matrix, if desired, from the left (by DL) and/or
// *          from the right (by DR or DL) as specified by IGRADE.
// *
// *       Permute, if desired, the rows and/or columns as specified by
// *          IPVTNG and IWORK.
// *
// *       Band the matrix to have lower bandwidth KL and upper
// *          bandwidth KU.
// *
// *       Set random entries to zero as specified by SPARSE.
// *
// *  Arguments
// *  =========
// *
// *  M      - INTEGER
// *           Number of rows of matrix. Not modified.
// *
// *  N      - INTEGER
// *           Number of columns of matrix. Not modified.
// *
// *  I      - INTEGER
// *           Row of entry to be returned. Not modified.
// *
// *  J      - INTEGER
// *           Column of entry to be returned. Not modified.
// *
// *  KL     - INTEGER
// *           Lower bandwidth. Not modified.
// *
// *  KU     - INTEGER
// *           Upper bandwidth. Not modified.
// *
// *  IDIST  - INTEGER
// *           On entry, IDIST specifies the type of distribution to be
// *           used to generate a random matrix .
// *           1 => UNIFORM( 0, 1 )
// *           2 => UNIFORM( -1, 1 )
// *           3 => NORMAL( 0, 1 )
// *           Not modified.
// *
// *  ISEED  - INTEGER array of dimension ( 4 )
// *           Seed for random number generator.
// *           Changed on exit.
// *
// *  D      - DOUBLE PRECISION array of dimension ( MIN( I , J ) )
// *           Diagonal entries of matrix. Not modified.
// *
// *  IGRADE - INTEGER
// *           Specifies grading of matrix as follows:
// *           0  => no grading
// *           1  => matrix premultiplied by diag( DL )
// *           2  => matrix postmultiplied by diag( DR )
// *           3  => matrix premultiplied by diag( DL ) and
// *                         postmultiplied by diag( DR )
// *           4  => matrix premultiplied by diag( DL ) and
// *                         postmultiplied by inv( diag( DL ) )
// *           5  => matrix premultiplied by diag( DL ) and
// *                         postmultiplied by diag( DL )
// *           Not modified.
// *
// *  DL     - DOUBLE PRECISION array ( I or J, as appropriate )
// *           Left scale factors for grading matrix.  Not modified.
// *
// *  DR     - DOUBLE PRECISION array ( I or J, as appropriate )
// *           Right scale factors for grading matrix.  Not modified.
// *
// *  IPVTNG - INTEGER
// *           On entry specifies pivoting permutations as follows:
// *           0 => none.
// *           1 => row pivoting.
// *           2 => column pivoting.
// *           3 => full pivoting, i.e., on both sides.
// *           Not modified.
// *
// *  IWORK  - INTEGER array ( I or J, as appropriate )
// *           This array specifies the permutation used. The
// *           row (or column) in position K was originally in
// *           position IWORK( K ).
// *           This differs from IWORK for DLATM3. Not modified.
// *
// *  SPARSE - DOUBLE PRECISION    between 0. and 1.
// *           On entry specifies the sparsity of the matrix
// *           if sparse matix is to be generated.
// *           SPARSE should lie between 0 and 1.
// *           A uniform ( 0, 1 ) random number x is generated and
// *           compared to SPARSE; if x is larger the matrix entry
// *           is unchanged and if x is smaller the entry is set
// *           to zero. Thus on the average a fraction SPARSE of the
// *           entries will be set to zero.
// *           Not modified.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
// *
static double zero= 0.0e0;
// *     ..
// *
// *     .. Local Scalars ..
// *
static int Isub= 0;
static int jsub= 0;
static double temp= 0.0;
// *     ..
// *
// *     .. External Functions ..
// *
// *     ..
// *
// *-----------------------------------------------------------------------
// *
// *     .. Executable Statements ..
// *
// *
// *     Check for I and J in range
// *
static double dlatm2 = 0.0;


public static double dlatm2 (int m,
int n,
int i,
int j,
int kl,
int ku,
int idist,
int [] iseed, int _iseed_offset,
double [] d, int _d_offset,
int igrade,
double [] dl, int _dl_offset,
double [] dr, int _dr_offset,
int ipvtng,
int [] iwork, int _iwork_offset,
double sparse)  {

if (i < 1 || i > m || j < 1 || j > n)  {
    dlatm2 = zero;
Dummy.go_to("Dlatm2",999999);
}              // Close if()
// *
// *     Check for banding
// *
if (j > i+ku || j < i-kl)  {
    dlatm2 = zero;
Dummy.go_to("Dlatm2",999999);
}              // Close if()
// *
// *     Check for sparsity
// *
if (sparse > zero)  {
    if (Dlaran.dlaran(iseed,_iseed_offset) < sparse)  {
    dlatm2 = zero;
Dummy.go_to("Dlatm2",999999);
}              // Close if()
}              // Close if()
// *
// *     Compute subscripts depending on IPVTNG
// *
if (ipvtng == 0)  {
    Isub = i;
jsub = j;
}              // Close if()
else if (ipvtng == 1)  {
    Isub = iwork[(i)- 1+ _iwork_offset];
jsub = j;
}              // Close else if()
else if (ipvtng == 2)  {
    Isub = i;
jsub = iwork[(j)- 1+ _iwork_offset];
}              // Close else if()
else if (ipvtng == 3)  {
    Isub = iwork[(i)- 1+ _iwork_offset];
jsub = iwork[(j)- 1+ _iwork_offset];
}              // Close else if()
// *
// *     Compute entry and grade it according to IGRADE
// *
if (Isub == jsub)  {
    temp = d[(Isub)- 1+ _d_offset];
}              // Close if()
else  {
  temp = Dlarnd.dlarnd(idist,iseed,_iseed_offset);
}              //  Close else.
if (igrade == 1)  {
    temp = temp*dl[(Isub)- 1+ _dl_offset];
}              // Close if()
else if (igrade == 2)  {
    temp = temp*dr[(jsub)- 1+ _dr_offset];
}              // Close else if()
else if (igrade == 3)  {
    temp = temp*dl[(Isub)- 1+ _dl_offset]*dr[(jsub)- 1+ _dr_offset];
}              // Close else if()
else if (igrade == 4 && Isub != jsub)  {
    temp = temp*dl[(Isub)- 1+ _dl_offset]/dl[(jsub)- 1+ _dl_offset];
}              // Close else if()
else if (igrade == 5)  {
    temp = temp*dl[(Isub)- 1+ _dl_offset]*dl[(jsub)- 1+ _dl_offset];
}              // Close else if()
dlatm2 = temp;
Dummy.go_to("Dlatm2",999999);
// *
// *     End of DLATM2
// *
Dummy.label("Dlatm2",999999);
return dlatm2;
   }
} // End class.
