/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: eigtest.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

import java.lang.*;
import org.netlib.util.*;
import org.netlib.lapack.*;


import org.netlib.blas.*;


public class Dort03 {

// *
// *  -- LAPACK test routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     February 29, 1992
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DORT03 compares two orthogonal matrices U and V to see if their
// *  corresponding rows or columns span the same spaces.  The rows are
// *  checked if RC = 'R', and the columns are checked if RC = 'C'.
// *
// *  RESULT is the maximum of
// *
// *     | V*V' - I | / ( MV ulp ), if RC = 'R', or
// *
// *     | V'*V - I | / ( MV ulp ), if RC = 'C',
// *
// *  and the maximum over rows (or columns) 1 to K of
// *
// *     | U(i) - S*V(i) |/ ( N ulp )
// *
// *  where S is +-1 (chosen to minimize the expression), U(i) is the i-th
// *  row (column) of U, and V(i) is the i-th row (column) of V.
// *
// *  Arguments
// *  ==========
// *
// *  RC      (input) CHARACTER*1
// *          If RC = 'R' the rows of U and V are to be compared.
// *          If RC = 'C' the columns of U and V are to be compared.
// *
// *  MU      (input) INTEGER
// *          The number of rows of U if RC = 'R', and the number of
// *          columns if RC = 'C'.  If MU = 0 DORT03 does nothing.
// *          MU must be at least zero.
// *
// *  MV      (input) INTEGER
// *          The number of rows of V if RC = 'R', and the number of
// *          columns if RC = 'C'.  If MV = 0 DORT03 does nothing.
// *          MV must be at least zero.
// *
// *  N       (input) INTEGER
// *          If RC = 'R', the number of columns in the matrices U and V,
// *          and if RC = 'C', the number of rows in U and V.  If N = 0
// *          DORT03 does nothing.  N must be at least zero.
// *
// *  K       (input) INTEGER
// *          The number of rows or columns of U and V to compare.
// *          0 <= K <= max(MU,MV).
// *
// *  U       (input) DOUBLE PRECISION array, dimension (LDU,N)
// *          The first matrix to compare.  If RC = 'R', U is MU by N, and
// *          if RC = 'C', U is N by MU.
// *
// *  LDU     (input) INTEGER
// *          The leading dimension of U.  If RC = 'R', LDU >= max(1,MU),
// *          and if RC = 'C', LDU >= max(1,N).
// *
// *  V       (input) DOUBLE PRECISION array, dimension (LDV,N)
// *          The second matrix to compare.  If RC = 'R', V is MV by N, and
// *          if RC = 'C', V is N by MV.
// *
// *  LDV     (input) INTEGER
// *          The leading dimension of V.  If RC = 'R', LDV >= max(1,MV),
// *          and if RC = 'C', LDV >= max(1,N).
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension (LWORK)
// *
// *  LWORK   (input) INTEGER
// *          The length of the array WORK.  For best performance, LWORK
// *          should be at least N*N if RC = 'C' or M*M if RC = 'R', but
// *          the tests will be done even if LWORK is 0.
// *
// *  RESULT  (output) DOUBLE PRECISION
// *          The value computed by the test described above.  RESULT is
// *          limited to 1/ulp to avoid overflow.
// *
// *  INFO    (output) INTEGER
// *          0  indicates a successful exit
// *          -k indicates the k-th parameter had an illegal value
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e0;
static double one= 1.0e0;
// *     ..
// *     .. Local Scalars ..
static int i= 0;
static int irc= 0;
static int j= 0;
static int lmx= 0;
static double res1= 0.0;
static doubleW res2= new doubleW(0.0);
static double s= 0.0;
static double ulp= 0.0;
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Check inputs
// *

public static void dort03 (String rc,
int mu,
int mv,
int n,
int k,
double [] u, int _u_offset,
int ldu,
double [] v, int _v_offset,
int ldv,
double [] work, int _work_offset,
int lwork,
doubleW result,
intW info)  {

info.val = 0;
if ((rc.toLowerCase().charAt(0) == "R".toLowerCase().charAt(0)))  {
    irc = 0;
}              // Close if()
else if ((rc.toLowerCase().charAt(0) == "C".toLowerCase().charAt(0)))  {
    irc = 1;
}              // Close else if()
else  {
  irc = -1;
}              //  Close else.
if (irc == -1)  {
    info.val = -1;
}              // Close if()
else if (mu < 0)  {
    info.val = -2;
}              // Close else if()
else if (mv < 0)  {
    info.val = -3;
}              // Close else if()
else if (n < 0)  {
    info.val = -4;
}              // Close else if()
else if (k < 0 || k > Math.max(mu, mv) )  {
    info.val = -5;
}              // Close else if()
else if ((irc == 0 && ldu < Math.max(1, mu) ) || (irc == 1 && ldu < Math.max(1, n) ))  {
    info.val = -7;
}              // Close else if()
else if ((irc == 0 && ldv < Math.max(1, mv) ) || (irc == 1 && ldv < Math.max(1, n) ))  {
    info.val = -9;
}              // Close else if()
if (info.val != 0)  {
    Xerbla.xerbla("DORT03",-info.val);
Dummy.go_to("Dort03",999999);
}              // Close if()
// *
// *     Initialize result
// *
result.val = zero;
if (mu == 0 || mv == 0 || n == 0)  
    Dummy.go_to("Dort03",999999);
// *
// *     Machine constants
// *
ulp = Dlamch.dlamch("Precision");
// *
if (irc == 0)  {
    // *
// *        Compare rows
// *
res1 = zero;
{
forloop20:
for (i = 1; i <= k; i++) {
lmx = Idamax.idamax(n,u,(i)- 1+(1- 1)*ldu+ _u_offset,ldu);
s = ((u[(i)- 1+(lmx- 1)*ldu+ _u_offset]) >= 0 ? Math.abs(one) : -Math.abs(one))*((v[(i)- 1+(lmx- 1)*ldv+ _v_offset]) >= 0 ? Math.abs(one) : -Math.abs(one));
{
forloop10:
for (j = 1; j <= n; j++) {
res1 = Math.max(res1, Math.abs(u[(i)- 1+(j- 1)*ldu+ _u_offset]-s*v[(i)- 1+(j- 1)*ldv+ _v_offset])) ;
Dummy.label("Dort03",10);
}              //  Close for() loop. 
}
Dummy.label("Dort03",20);
}              //  Close for() loop. 
}
res1 = res1/((double)(n)*ulp);
// *
// *        Compute orthogonality of rows of V.
// *
Dort01.dort01("Rows",mv,n,v,_v_offset,ldv,work,_work_offset,lwork,res2);
// *
}              // Close if()
else  {
  // *
// *        Compare columns
// *
res1 = zero;
{
forloop40:
for (i = 1; i <= k; i++) {
lmx = Idamax.idamax(n,u,(1)- 1+(i- 1)*ldu+ _u_offset,1);
s = ((u[(lmx)- 1+(i- 1)*ldu+ _u_offset]) >= 0 ? Math.abs(one) : -Math.abs(one))*((v[(lmx)- 1+(i- 1)*ldv+ _v_offset]) >= 0 ? Math.abs(one) : -Math.abs(one));
{
forloop30:
for (j = 1; j <= n; j++) {
res1 = Math.max(res1, Math.abs(u[(j)- 1+(i- 1)*ldu+ _u_offset]-s*v[(j)- 1+(i- 1)*ldv+ _v_offset])) ;
Dummy.label("Dort03",30);
}              //  Close for() loop. 
}
Dummy.label("Dort03",40);
}              //  Close for() loop. 
}
res1 = res1/((double)(n)*ulp);
// *
// *        Compute orthogonality of columns of V.
// *
Dort01.dort01("Columns",n,mv,v,_v_offset,ldv,work,_work_offset,lwork,res2);
}              //  Close else.
// *
result.val = Math.min(Math.max(res1, res2.val) , one/ulp) ;
Dummy.go_to("Dort03",999999);
// *
// *     End of DORT03
// *
Dummy.label("Dort03",999999);
return;
   }
} // End class.
