/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: eigtest.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

import java.lang.*;
import org.netlib.util.*;
import org.netlib.lapack.*;


import org.netlib.blas.*;


public class Dstt21 {

// *
// *  -- LAPACK test routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DSTT21 checks a decomposition of the form
// *
// *     A = U S U'
// *
// *  where ' means transpose, A is symmetric tridiagonal, U is orthogonal,
// *  and S is diagonal (if KBAND=0) or symmetric tridiagonal (if KBAND=1).
// *  Two tests are performed:
// *
// *     RESULT(1) = | A - U S U' | / ( |A| n ulp )
// *
// *     RESULT(2) = | I - UU' | / ( n ulp )
// *
// *  Arguments
// *  =========
// *
// *  N       (input) INTEGER
// *          The size of the matrix.  If it is zero, DSTT21 does nothing.
// *          It must be at least zero.
// *
// *  KBAND   (input) INTEGER
// *          The bandwidth of the matrix S.  It may only be zero or one.
// *          If zero, then S is diagonal, and SE is not referenced.  If
// *          one, then S is symmetric tri-diagonal.
// *
// *  AD      (input) DOUBLE PRECISION array, dimension (N)
// *          The diagonal of the original (unfactored) matrix A.  A is
// *          assumed to be symmetric tridiagonal.
// *
// *  AE      (input) DOUBLE PRECISION array, dimension (N-1)
// *          The off-diagonal of the original (unfactored) matrix A.  A
// *          is assumed to be symmetric tridiagonal.  AE(1) is the (1,2)
// *          and (2,1) element, AE(2) is the (2,3) and (3,2) element, etc.
// *
// *  SD      (input) DOUBLE PRECISION array, dimension (N)
// *          The diagonal of the (symmetric tri-) diagonal matrix S.
// *
// *  SE      (input) DOUBLE PRECISION array, dimension (N-1)
// *          The off-diagonal of the (symmetric tri-) diagonal matrix S.
// *          Not referenced if KBSND=0.  If KBAND=1, then AE(1) is the
// *          (1,2) and (2,1) element, SE(2) is the (2,3) and (3,2)
// *          element, etc.
// *
// *  U       (input) DOUBLE PRECISION array, dimension (LDU, N)
// *          The orthogonal matrix in the decomposition.
// *
// *  LDU     (input) INTEGER
// *          The leading dimension of U.  LDU must be at least N.
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension (N*(N+1))
// *
// *  RESULT  (output) DOUBLE PRECISION array, dimension (2)
// *          The values computed by the two tests described above.  The
// *          values are currently limited to 1/ulp, to avoid overflow.
// *          RESULT(1) is always modified.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e0;
static double one= 1.0e0;
// *     ..
// *     .. Local Scalars ..
static int j= 0;
static double anorm= 0.0;
static double temp1= 0.0;
static double temp2= 0.0;
static double ulp= 0.0;
static double unfl= 0.0;
static double wnorm= 0.0;
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     1)      Constants
// *

public static void dstt21 (int n,
int kband,
double [] ad, int _ad_offset,
double [] ae, int _ae_offset,
double [] sd, int _sd_offset,
double [] se, int _se_offset,
double [] u, int _u_offset,
int ldu,
double [] work, int _work_offset,
double [] result, int _result_offset)  {

result[(1)- 1+ _result_offset] = zero;
result[(2)- 1+ _result_offset] = zero;
if (n <= 0)  
    Dummy.go_to("Dstt21",999999);
// *
unfl = Dlamch.dlamch("Safe minimum");
ulp = Dlamch.dlamch("Precision");
// *
// *     Do Test 1
// *
// *     Copy A & Compute its 1-Norm:
// *
Dlaset.dlaset("Full",n,n,zero,zero,work,_work_offset,n);
// *
anorm = zero;
temp1 = zero;
// *
{
forloop10:
for (j = 1; j <= n-1; j++) {
work[((n+1)*(j-1)+1)- 1+ _work_offset] = ad[(j)- 1+ _ad_offset];
work[((n+1)*(j-1)+2)- 1+ _work_offset] = ae[(j)- 1+ _ae_offset];
temp2 = Math.abs(ae[(j)- 1+ _ae_offset]);
anorm = Math.max(anorm, Math.abs(ad[(j)- 1+ _ad_offset])+temp1+temp2) ;
temp1 = temp2;
Dummy.label("Dstt21",10);
}              //  Close for() loop. 
}
// *
work[(int)((Math.pow(n, 2))- 1+ _work_offset)] = ad[(n)- 1+ _ad_offset];
anorm = Math.max((anorm) > (Math.abs(ad[(n)- 1+ _ad_offset])+temp1) ? (anorm) : (Math.abs(ad[(n)- 1+ _ad_offset])+temp1), unfl);
// *
// *     Norm of A - USU'
// *
{
forloop20:
for (j = 1; j <= n; j++) {
Dsyr.dsyr("L",n,-sd[(j)- 1+ _sd_offset],u,(1)- 1+(j- 1)*ldu+ _u_offset,1,work,_work_offset,n);
Dummy.label("Dstt21",20);
}              //  Close for() loop. 
}
// *
if (n > 1 && kband == 1)  {
    {
forloop30:
for (j = 1; j <= n-1; j++) {
Dsyr2.dsyr2("L",n,-se[(j)- 1+ _se_offset],u,(1)- 1+(j- 1)*ldu+ _u_offset,1,u,(1)- 1+(j+1- 1)*ldu+ _u_offset,1,work,_work_offset,n);
Dummy.label("Dstt21",30);
}              //  Close for() loop. 
}
}              // Close if()
// *
wnorm = Dlansy.dlansy("1","L",n,work,_work_offset,n,work,(int)((Math.pow(n, 2)+1)- 1+ _work_offset));
// *
if (anorm > wnorm)  {
    result[(1)- 1+ _result_offset] = (wnorm/anorm)/(n*ulp);
}              // Close if()
else  {
  if (anorm < one)  {
    result[(1)- 1+ _result_offset] = (Math.min(wnorm, n*anorm) /anorm)/(n*ulp);
}              // Close if()
else  {
  result[(1)- 1+ _result_offset] = Math.min(wnorm/anorm, (double)(n)) /(n*ulp);
}              //  Close else.
}              //  Close else.
// *
// *     Do Test 2
// *
// *     Compute  UU' - I
// *
Dgemm.dgemm("N","C",n,n,n,one,u,_u_offset,ldu,u,_u_offset,ldu,zero,work,_work_offset,n);
// *
{
forloop40:
for (j = 1; j <= n; j++) {
work[((n+1)*(j-1)+1)- 1+ _work_offset] = work[((n+1)*(j-1)+1)- 1+ _work_offset]-one;
Dummy.label("Dstt21",40);
}              //  Close for() loop. 
}
// *
result[(2)- 1+ _result_offset] = Math.min((double)(n), Dlange.dlange("1",n,n,work,_work_offset,n,work,(int)((Math.pow(n, 2)+1)- 1+ _work_offset))) /(n*ulp);
// *
Dummy.go_to("Dstt21",999999);
// *
// *     End of DSTT21
// *
Dummy.label("Dstt21",999999);
return;
   }
} // End class.
