/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: lintest.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

import java.lang.*;
import org.netlib.util.*;
import org.netlib.lapack.*;




public class Dchkpo {

// *
// *  -- LAPACK test routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DCHKPO tests DPOTRF, -TRI, -TRS, -RFS, and -CON
// *
// *  Arguments
// *  =========
// *
// *  DOTYPE  (input) LOGICAL array, dimension (NTYPES)
// *          The matrix types to be used for testing.  Matrices of type j
// *          (for 1 <= j <= NTYPES) are used for testing if DOTYPE(j) =
// *          .TRUE.; if DOTYPE(j) = .FALSE., then type j is not used.
// *
// *  NN      (input) INTEGER
// *          The number of values of N contained in the vector NVAL.
// *
// *  NVAL    (input) INTEGER array, dimension (NN)
// *          The values of the matrix dimension N.
// *
// *  NNB     (input) INTEGER
// *          The number of values of NB contained in the vector NBVAL.
// *
// *  NBVAL   (input) INTEGER array, dimension (NBVAL)
// *          The values of the blocksize NB.
// *
// *  NRHS    (input) INTEGER
// *          The number of right hand side vectors to be generated for
// *          each linear system.
// *
// *  THRESH  (input) DOUBLE PRECISION
// *          The threshold value for the test ratios.  A result is
// *          included in the output file if RESULT >= THRESH.  To have
// *          every test ratio printed, use THRESH = 0.
// *
// *  TSTERR  (input) LOGICAL
// *          Flag that indicates whether error exits are to be tested.
// *
// *  NMAX    (input) INTEGER
// *          The maximum value permitted for N, used in dimensioning the
// *          work arrays.
// *
// *  A       (workspace) DOUBLE PRECISION array, dimension (NMAX*NMAX)
// *
// *  AFAC    (workspace) DOUBLE PRECISION array, dimension (NMAX*NMAX)
// *
// *  AINV    (workspace) DOUBLE PRECISION array, dimension (NMAX*NMAX)
// *
// *  B       (workspace) DOUBLE PRECISION array, dimension (NMAX*NRHS)
// *
// *  X       (workspace) DOUBLE PRECISION array, dimension (NMAX*NRHS)
// *
// *  XACT    (workspace) DOUBLE PRECISION array, dimension (NMAX*NRHS)
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension
// *                      (NMAX*max(3,NRHS))
// *
// *  RWORK   (workspace) DOUBLE PRECISION array, dimension
// *                      (max(NMAX,2*NRHS))
// *
// *  IWORK   (workspace) INTEGER array, dimension (NMAX)
// *
// *  NOUT    (input) INTEGER
// *          The unit number for output.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e+0;
static int ntypes= 9;
static int ntests= 8;
// *     ..
// *     .. Local Scalars ..
static boolean zerot= false;
static StringW dist= new StringW(" ");
static StringW type= new StringW(" ");
static String uplo= new String(" ");
static String xtype= new String(" ");
static String path= new String("   ");
static int i= 0;
static int imat= 0;
static int in= 0;
static int inb= 0;
static intW info= new intW(0);
static int ioff= 0;
static int iuplo= 0;
static int izero= 0;
static int k= 0;
static intW kl= new intW(0);
static intW ku= new intW(0);
static int lda= 0;
static intW mode= new intW(0);
static int n= 0;
static int nb= 0;
static intW nerrs= new intW(0);
static int nfail= 0;
static int nimat= 0;
static int nrun= 0;
static int nt= 0;
static doubleW anorm= new doubleW(0.0);
static doubleW cndnum= new doubleW(0.0);
static doubleW rcond= new doubleW(0.0);
static doubleW rcondc= new doubleW(0.0);
// *     ..
// *     .. Local Arrays ..
static int [] iseed= new int[(4)];
static double [] result= new double[(ntests)];
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Scalars in Common ..
// *     ..
// *     .. Common blocks ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Data statements ..
static int [] iseedy = {1988 
, 1989 , 1990 , 1991 };
static String [] uplos = {"U" 
, "L" };
// *     ..
// *     .. Executable Statements ..
// *
// *     Initialize constants and the random number seed.
// *

public static void dchkpo (boolean [] dotype, int _dotype_offset,
int nn,
int [] nval, int _nval_offset,
int nnb,
int [] nbval, int _nbval_offset,
int nrhs,
double thresh,
boolean tsterr,
int nmax,
double [] a, int _a_offset,
double [] afac, int _afac_offset,
double [] ainv, int _ainv_offset,
double [] b, int _b_offset,
double [] x, int _x_offset,
double [] xact, int _xact_offset,
double [] work, int _work_offset,
double [] rwork, int _rwork_offset,
int [] iwork, int _iwork_offset,
int nout)  {

{
  int E1, E2;
  E1 = 1;
  E2 = 1;
path = new String(path.substring(0,E1-1) + "D".substring(0,E2-E1+1) + path.substring(E2,path.length()));
}
;
{
  int E1, E2;
  E1 = 2;
  E2 = 3;
path = new String(path.substring(0,E1-1) + "PO".substring(0,E2-E1+1) + path.substring(E2,path.length()));
}
;
nrun = 0;
nfail = 0;
nerrs.val = 0;
{
forloop10:
for (i = 1; i <= 4; i++) {
iseed[(i)- 1] = iseedy[(i)- 1];
Dummy.label("Dchkpo",10);
}              //  Close for() loop. 
}
// *
// *     Test the error exits
// *
if (tsterr)  
    Derrpo.derrpo(path,nout);
lintest_infoc.infot = 0;
Xlaenv.xlaenv(2,2);
// *
// *     Do for each value of N in NVAL
// *
{
forloop110:
for (in = 1; in <= nn; in++) {
n = nval[(in)- 1+ _nval_offset];
lda = (int)(Math.max(n, 1) );
xtype = "N";
nimat = ntypes;
if (n <= 0)  
    nimat = 1;
// *
izero = 0;
{
forloop100:
for (imat = 1; imat <= nimat; imat++) {
// *
// *           Do the tests only if DOTYPE( IMAT ) is true.
// *
if (!dotype[(imat)- 1+ _dotype_offset])  
    continue forloop100;
// *
// *           Skip types 3, 4, or 5 if the matrix size is too small.
// *
zerot = imat >= 3 && imat <= 5;
if (zerot && n < imat-2)  
    continue forloop100;
// *
// *           Do first for UPLO = 'U', then for UPLO = 'L'
// *
{
forloop90:
for (iuplo = 1; iuplo <= 2; iuplo++) {
uplo = uplos[(iuplo)- 1];
// *
// *              Set up parameters with DLATB4 and generate a test matrix
// *              with DLATMS.
// *
Dlatb4.dlatb4(path,imat,n,n,type,kl,ku,anorm,mode,cndnum,dist);
// *
lintest_srnamc.srnamt = "DLATMS";
Dlatms.dlatms(n,n,dist.val,iseed,0,type.val,rwork,_rwork_offset,mode.val,cndnum.val,anorm.val,kl.val,ku.val,uplo,a,_a_offset,lda,work,_work_offset,info);
// *
// *              Check error code from DLATMS.
// *
if (info.val != 0)  {
    Alaerh.alaerh(path,"DLATMS",info.val,0,uplo,n,n,-1,-1,-1,imat,nfail,nerrs,nout);
continue forloop90;
}              // Close if()
// *
// *              For types 3-5, zero one row and column of the matrix to
// *              test that INFO is returned correctly.
// *
if (zerot)  {
    if (imat == 3)  {
    izero = 1;
}              // Close if()
else if (imat == 4)  {
    izero = n;
}              // Close else if()
else  {
  izero = n/2+1;
}              //  Close else.
ioff = (izero-1)*lda;
// *
// *                 Set row and column IZERO of A to 0.
// *
if (iuplo == 1)  {
    {
forloop20:
for (i = 1; i <= izero-1; i++) {
a[(ioff+i)- 1+ _a_offset] = zero;
Dummy.label("Dchkpo",20);
}              //  Close for() loop. 
}
ioff = ioff+izero;
{
forloop30:
for (i = izero; i <= n; i++) {
a[(ioff)- 1+ _a_offset] = zero;
ioff = ioff+lda;
Dummy.label("Dchkpo",30);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  ioff = izero;
{
forloop40:
for (i = 1; i <= izero-1; i++) {
a[(ioff)- 1+ _a_offset] = zero;
ioff = ioff+lda;
Dummy.label("Dchkpo",40);
}              //  Close for() loop. 
}
ioff = ioff-izero;
{
forloop50:
for (i = izero; i <= n; i++) {
a[(ioff+i)- 1+ _a_offset] = zero;
Dummy.label("Dchkpo",50);
}              //  Close for() loop. 
}
}              //  Close else.
}              // Close if()
else  {
  izero = 0;
}              //  Close else.
// *
// *              Do for each value of NB in NBVAL
// *
{
forloop80:
for (inb = 1; inb <= nnb; inb++) {
nb = nbval[(inb)- 1+ _nbval_offset];
Xlaenv.xlaenv(1,nb);
// *
// *                 Compute the L*L' or U'*U factorization of the matrix.
// *
Dlacpy.dlacpy(uplo,n,n,a,_a_offset,lda,afac,_afac_offset,lda);
lintest_srnamc.srnamt = "DPOTRF";
Dpotrf.dpotrf(uplo,n,afac,_afac_offset,lda,info);
// *
// *                 Check error code from DPOTRF.
// *
if (info.val != izero)  {
    Alaerh.alaerh(path,"DPOTRF",info.val,izero,uplo,n,n,-1,-1,nb,imat,nfail,nerrs,nout);
continue forloop80;
}              // Close if()
// *
// *                 Skip the tests if INFO is not 0.
// *
if (info.val != 0)  
    continue forloop80;
// *
// *+    TEST 1
// *                 Reconstruct matrix from factors and compute residual.
// *
Dlacpy.dlacpy(uplo,n,n,afac,_afac_offset,lda,ainv,_ainv_offset,lda);
dpot01_adapter(uplo,n,a,_a_offset,lda,ainv,_ainv_offset,lda,rwork,_rwork_offset,result,(1)- 1);
// *
// *+    TEST 2
// *                 Form the inverse and compute the residual.
// *
Dlacpy.dlacpy(uplo,n,n,afac,_afac_offset,lda,ainv,_ainv_offset,lda);
lintest_srnamc.srnamt = "DPOTRI";
Dpotri.dpotri(uplo,n,ainv,_ainv_offset,lda,info);
// *
// *                 Check error code from DPOTRI.
// *
if (info.val != 0)  
    Alaerh.alaerh(path,"DPOTRI",info.val,0,uplo,n,n,-1,-1,-1,imat,nfail,nerrs,nout);
// *
dpot03_adapter(uplo,n,a,_a_offset,lda,ainv,_ainv_offset,lda,work,_work_offset,lda,rwork,_rwork_offset,rcondc,result,(2)- 1);
// *
// *                 Skip the rest of the tests unless this is the first
// *                 blocksize.
// *
if (inb != 1)  {
    nt = 2;
Dummy.go_to("Dchkpo",60);
}              // Close if()
// *
// *+    TEST 3
// *                 Solve and compute residual for A * X = B .
// *
lintest_srnamc.srnamt = "DLARHS";
Dlarhs.dlarhs(path,xtype,uplo," ",n,n,kl.val,ku.val,nrhs,a,_a_offset,lda,xact,_xact_offset,lda,b,_b_offset,lda,iseed,0,info);
xtype = "C";
Dlacpy.dlacpy("Full",n,nrhs,b,_b_offset,lda,x,_x_offset,lda);
// *
lintest_srnamc.srnamt = "DPOTRS";
Dpotrs.dpotrs(uplo,n,nrhs,afac,_afac_offset,lda,x,_x_offset,lda,info);
// *
// *                 Check error code from DPOTRS.
// *
if (info.val != 0)  
    Alaerh.alaerh(path,"DPOTRS",info.val,0,uplo,n,n,-1,-1,nrhs,imat,nfail,nerrs,nout);
// *
Dlacpy.dlacpy("Full",n,nrhs,b,_b_offset,lda,work,_work_offset,lda);
dpot02_adapter(uplo,n,nrhs,a,_a_offset,lda,x,_x_offset,lda,work,_work_offset,lda,rwork,_rwork_offset,result,(3)- 1);
// *
// *+    TEST 4
// *                 Check solution from generated exact solution.
// *
dget04_adapter(n,nrhs,x,_x_offset,lda,xact,_xact_offset,lda,rcondc.val,result,(4)- 1);
// *
// *+    TESTS 5, 6, and 7
// *                 Use iterative refinement to improve the solution.
// *
lintest_srnamc.srnamt = "DPORFS";
Dporfs.dporfs(uplo,n,nrhs,a,_a_offset,lda,afac,_afac_offset,lda,b,_b_offset,lda,x,_x_offset,lda,rwork,_rwork_offset,rwork,(nrhs+1)- 1+ _rwork_offset,work,_work_offset,iwork,_iwork_offset,info);
// *
// *                 Check error code from DPORFS.
// *
if (info.val != 0)  
    Alaerh.alaerh(path,"DPORFS",info.val,0,uplo,n,n,-1,-1,nrhs,imat,nfail,nerrs,nout);
// *
dget04_adapter(n,nrhs,x,_x_offset,lda,xact,_xact_offset,lda,rcondc.val,result,(5)- 1);
Dpot05.dpot05(uplo,n,nrhs,a,_a_offset,lda,b,_b_offset,lda,x,_x_offset,lda,xact,_xact_offset,lda,rwork,_rwork_offset,rwork,(nrhs+1)- 1+ _rwork_offset,result,(6)- 1);
// *
// *+    TEST 8
// *                 Get an estimate of RCOND = 1/CNDNUM.
// *
anorm.val = Dlansy.dlansy("1",uplo,n,a,_a_offset,lda,rwork,_rwork_offset);
lintest_srnamc.srnamt = "DPOCON";
Dpocon.dpocon(uplo,n,afac,_afac_offset,lda,anorm.val,rcond,work,_work_offset,iwork,_iwork_offset,info);
// *
// *                 Check error code from DPOCON.
// *
if (info.val != 0)  
    Alaerh.alaerh(path,"DPOCON",info.val,0,uplo,n,n,-1,-1,-1,imat,nfail,nerrs,nout);
// *
result[(8)- 1] = Dget06.dget06(rcond.val,rcondc.val);
nt = 8;
// *
// *                 Print information about the tests that did not pass
// *                 the threshold.
// *
label60:
   Dummy.label("Dchkpo",60);
{
forloop70:
for (k = 1; k <= nt; k++) {
if (result[(k)- 1] >= thresh)  {
    if (nfail == 0 && nerrs.val == 0)  
    Alahd.alahd(nout,path);
System.out.println(" UPLO = \'"  + (uplo) + " "  + "\', N ="  + (n) + " "  + ", NB ="  + (nb) + " "  + ", type "  + (imat) + " "  + ", test "  + (k) + " "  + ", ratio ="  + (result[(k)- 1]) + " " );
nfail = nfail+1;
}              // Close if()
Dummy.label("Dchkpo",70);
}              //  Close for() loop. 
}
nrun = nrun+nt;
// *
Dummy.label("Dchkpo",80);
}              //  Close for() loop. 
}
// *
Dummy.label("Dchkpo",90);
}              //  Close for() loop. 
}
Dummy.label("Dchkpo",100);
}              //  Close for() loop. 
}
Dummy.label("Dchkpo",110);
}              //  Close for() loop. 
}
// *
// *     Print a summary of the results.
// *
Alasum.alasum(path,nout,nfail,nrun,nerrs.val);
// *
Dummy.go_to("Dchkpo",999999);
// *
// *     End of DCHKPO
// *
Dummy.label("Dchkpo",999999);
return;
   }
// adapter for dpot01
private static void dpot01_adapter(String arg0 ,int arg1 ,double [] arg2 , int arg2_offset ,int arg3 ,double [] arg4 , int arg4_offset ,int arg5 ,double [] arg6 , int arg6_offset ,double [] arg7 , int arg7_offset )
{
doubleW _f2j_tmp7 = new doubleW(arg7[arg7_offset]);

Dpot01.dpot01(arg0,arg1,arg2, arg2_offset,arg3,arg4, arg4_offset,arg5,arg6, arg6_offset,_f2j_tmp7);

arg7[arg7_offset] = _f2j_tmp7.val;
}

// adapter for dpot03
private static void dpot03_adapter(String arg0 ,int arg1 ,double [] arg2 , int arg2_offset ,int arg3 ,double [] arg4 , int arg4_offset ,int arg5 ,double [] arg6 , int arg6_offset ,int arg7 ,double [] arg8 , int arg8_offset ,doubleW arg9 ,double [] arg10 , int arg10_offset )
{
doubleW _f2j_tmp10 = new doubleW(arg10[arg10_offset]);

Dpot03.dpot03(arg0,arg1,arg2, arg2_offset,arg3,arg4, arg4_offset,arg5,arg6, arg6_offset,arg7,arg8, arg8_offset,arg9,_f2j_tmp10);

arg10[arg10_offset] = _f2j_tmp10.val;
}

// adapter for dpot02
private static void dpot02_adapter(String arg0 ,int arg1 ,int arg2 ,double [] arg3 , int arg3_offset ,int arg4 ,double [] arg5 , int arg5_offset ,int arg6 ,double [] arg7 , int arg7_offset ,int arg8 ,double [] arg9 , int arg9_offset ,double [] arg10 , int arg10_offset )
{
doubleW _f2j_tmp10 = new doubleW(arg10[arg10_offset]);

Dpot02.dpot02(arg0,arg1,arg2,arg3, arg3_offset,arg4,arg5, arg5_offset,arg6,arg7, arg7_offset,arg8,arg9, arg9_offset,_f2j_tmp10);

arg10[arg10_offset] = _f2j_tmp10.val;
}

// adapter for dget04
private static void dget04_adapter(int arg0 ,int arg1 ,double [] arg2 , int arg2_offset ,int arg3 ,double [] arg4 , int arg4_offset ,int arg5 ,double arg6 ,double [] arg7 , int arg7_offset )
{
doubleW _f2j_tmp7 = new doubleW(arg7[arg7_offset]);

Dget04.dget04(arg0,arg1,arg2, arg2_offset,arg3,arg4, arg4_offset,arg5,arg6,_f2j_tmp7);

arg7[arg7_offset] = _f2j_tmp7.val;
}

} // End class.
