/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: lintest.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

import java.lang.*;
import org.netlib.util.*;
import org.netlib.lapack.*;




public class Ddrvgb {

// *
// *  -- LAPACK test routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DDRVGB tests the driver routines DGBSV and -SVX.
// *
// *  Arguments
// *  =========
// *
// *  DOTYPE  (input) LOGICAL array, dimension (NTYPES)
// *          The matrix types to be used for testing.  Matrices of type j
// *          (for 1 <= j <= NTYPES) are used for testing if DOTYPE(j) =
// *          .TRUE.; if DOTYPE(j) = .FALSE., then type j is not used.
// *
// *  NN      (input) INTEGER
// *          The number of values of N contained in the vector NVAL.
// *
// *  NVAL    (input) INTEGER array, dimension (NN)
// *          The values of the matrix column dimension N.
// *
// *  NRHS    (input) INTEGER
// *          The number of right hand side vectors to be generated for
// *          each linear system.
// *
// *  THRESH  (input) DOUBLE PRECISION
// *          The threshold value for the test ratios.  A result is
// *          included in the output file if RESULT >= THRESH.  To have
// *          every test ratio printed, use THRESH = 0.
// *
// *  TSTERR  (input) LOGICAL
// *          Flag that indicates whether error exits are to be tested.
// *
// *  A       (workspace) DOUBLE PRECISION array, dimension (LA)
// *
// *  LA      (input) INTEGER
// *          The length of the array A.  LA >= (2*NMAX-1)*NMAX
// *          where NMAX is the largest entry in NVAL.
// *
// *  AFB     (workspace) DOUBLE PRECISION array, dimension (LAFB)
// *
// *  LAFB    (input) INTEGER
// *          The length of the array AFB.  LAFB >= (3*NMAX-2)*NMAX
// *          where NMAX is the largest entry in NVAL.
// *
// *  ASAV    (workspace) DOUBLE PRECISION array, dimension (LA)
// *
// *  B       (workspace) DOUBLE PRECISION array, dimension (NMAX*NRHS)
// *
// *  BSAV    (workspace) DOUBLE PRECISION array, dimension (NMAX*NRHS)
// *
// *  X       (workspace) DOUBLE PRECISION array, dimension (NMAX*NRHS)
// *
// *  XACT    (workspace) DOUBLE PRECISION array, dimension (NMAX*NRHS)
// *
// *  S       (workspace) DOUBLE PRECISION array, dimension (2*NMAX)
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension
// *                      (NMAX*max(3,NRHS,NMAX))
// *
// *  RWORK   (workspace) DOUBLE PRECISION array, dimension
// *                      (max(NMAX,2*NRHS))
// *
// *  IWORK   (workspace) INTEGER array, dimension (2*NMAX)
// *
// *  NOUT    (input) INTEGER
// *          The unit number for output.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double one= 1.0e+0;
static double zero= 0.0e+0;
static int ntypes= 8;
static int ntests= 7;
static int ntran= 3;
// *     ..
// *     .. Local Scalars ..
static boolean equil= false;
static boolean nofact= false;
static boolean prefac= false;
static boolean trfcon= false;
static boolean zerot= false;
static StringW dist= new StringW(" ");
static StringW equed= new StringW(" ");
static String fact= new String(" ");
static String trans= new String(" ");
static StringW type= new StringW(" ");
static String xtype= new String(" ");
static String path= new String("   ");
static int i= 0;
static int i1= 0;
static int i2= 0;
static int iequed= 0;
static int ifact= 0;
static int ikl= 0;
static int iku= 0;
static int imat= 0;
static int in= 0;
static intW info= new intW(0);
static int ioff= 0;
static int itran= 0;
static int izero= 0;
static int j= 0;
static int k= 0;
static int k1= 0;
static intW kl= new intW(0);
static intW ku= new intW(0);
static int lda= 0;
static int ldafb= 0;
static int ldb= 0;
static intW mode= new intW(0);
static int n= 0;
static int nb= 0;
static int nbmin= 0;
static intW nerrs= new intW(0);
static int nfact= 0;
static int nfail= 0;
static int nimat= 0;
static int nkl= 0;
static int nku= 0;
static int nrun= 0;
static int nt= 0;
static double ainvnm= 0.0;
static doubleW amax= new doubleW(0.0);
static doubleW anorm= new doubleW(0.0);
static double anormi= 0.0;
static double anormo= 0.0;
static double anrmpv= 0.0;
static doubleW cndnum= new doubleW(0.0);
static doubleW colcnd= new doubleW(0.0);
static doubleW rcond= new doubleW(0.0);
static double rcondc= 0.0;
static double rcondi= 0.0;
static double rcondo= 0.0;
static double roldc= 0.0;
static double roldi= 0.0;
static double roldo= 0.0;
static doubleW rowcnd= new doubleW(0.0);
static double rpvgrw= 0.0;
// *     ..
// *     .. Local Arrays ..
static int [] iseed= new int[(4)];
static double [] result= new double[(ntests)];
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Scalars in Common ..
// *     ..
// *     .. Common blocks ..
// *     ..
// *     .. Data statements ..
static int [] iseedy = {1988 
, 1989 , 1990 , 1991 };
static String [] transs = {"N" 
, "T" , "C" };
static String [] facts = {"F" 
, "N" , "E" };
static String [] equeds = {"N" 
, "R" , "C" , "B" };
// *     ..
// *     .. Executable Statements ..
// *
// *     Initialize constants and the random number seed.
// *

public static void ddrvgb (boolean [] dotype, int _dotype_offset,
int nn,
int [] nval, int _nval_offset,
int nrhs,
double thresh,
boolean tsterr,
double [] a, int _a_offset,
int la,
double [] afb, int _afb_offset,
int lafb,
double [] asav, int _asav_offset,
double [] b, int _b_offset,
double [] bsav, int _bsav_offset,
double [] x, int _x_offset,
double [] xact, int _xact_offset,
double [] s, int _s_offset,
double [] work, int _work_offset,
double [] rwork, int _rwork_offset,
int [] iwork, int _iwork_offset,
int nout)  {

{
  int E1, E2;
  E1 = 1;
  E2 = 1;
path = new String(path.substring(0,E1-1) + "D".substring(0,E2-E1+1) + path.substring(E2,path.length()));
}
;
{
  int E1, E2;
  E1 = 2;
  E2 = 3;
path = new String(path.substring(0,E1-1) + "GB".substring(0,E2-E1+1) + path.substring(E2,path.length()));
}
;
nrun = 0;
nfail = 0;
nerrs.val = 0;
{
forloop10:
for (i = 1; i <= 4; i++) {
iseed[(i)- 1] = iseedy[(i)- 1];
Dummy.label("Ddrvgb",10);
}              //  Close for() loop. 
}
// *
// *     Test the error exits
// *
if (tsterr)  
    Derrvx.derrvx(path,nout);
lintest_infoc.infot = 0;
// *
// *     Set the block size and minimum block size for testing.
// *
nb = 1;
nbmin = 2;
Xlaenv.xlaenv(1,nb);
Xlaenv.xlaenv(2,nbmin);
// *
// *     Do for each value of N in NVAL
// *
{
forloop160:
for (in = 1; in <= nn; in++) {
n = nval[(in)- 1+ _nval_offset];
ldb = (int)(Math.max(n, 1) );
xtype = "N";
// *
// *        Set limits on the number of loop iterations.
// *
nkl = (int)(Math.max(1, Math.min(n, 4) ) );
if (n == 0)  
    nkl = 1;
nku = nkl;
nimat = ntypes;
if (n <= 0)  
    nimat = 1;
// *
{
forloop150:
for (ikl = 1; ikl <= nkl; ikl++) {
// *
// *           Do for KL = 0, N-1, (3N-1)/4, and (N+1)/4. This order makes
// *           it easier to skip redundant values for small values of N.
// *
if (ikl == 1)  {
    kl.val = 0;
}              // Close if()
else if (ikl == 2)  {
    kl.val = (int)(Math.max(n-1, 0) );
}              // Close else if()
else if (ikl == 3)  {
    kl.val = (3*n-1)/4;
}              // Close else if()
else if (ikl == 4)  {
    kl.val = (n+1)/4;
}              // Close else if()
{
forloop140:
for (iku = 1; iku <= nku; iku++) {
// *
// *              Do for KU = 0, N-1, (3N-1)/4, and (N+1)/4. This order
// *              makes it easier to skip redundant values for small
// *              values of N.
// *
if (iku == 1)  {
    ku.val = 0;
}              // Close if()
else if (iku == 2)  {
    ku.val = (int)(Math.max(n-1, 0) );
}              // Close else if()
else if (iku == 3)  {
    ku.val = (3*n-1)/4;
}              // Close else if()
else if (iku == 4)  {
    ku.val = (n+1)/4;
}              // Close else if()
// *
// *              Check that A and AFB are big enough to generate this
// *              matrix.
// *
lda = kl.val+ku.val+1;
ldafb = 2*kl.val+ku.val+1;
if (lda*n > la || ldafb*n > lafb)  {
    if (nfail == 0 && nerrs.val == 0)  
    Aladhd.aladhd(nout,path);
if (lda*n > la)  {
    System.out.println(" *** In DDRVGB, LA="  + (la) + " "  + " is too small for N="  + (n) + " "  + ", KU="  + (kl.val) + " "  + ", KL="  + (ku.val) + " "  + "\n"  + " ==> Increase LA to at least "  + (n*(kl.val+ku.val+1)) + " " );
nerrs.val = nerrs.val+1;
}              // Close if()
if (ldafb*n > lafb)  {
    System.out.println(" *** In DDRVGB, LAFB="  + (lafb) + " "  + " is too small for N="  + (n) + " "  + ", KU="  + (kl.val) + " "  + ", KL="  + (ku.val) + " "  + "\n"  + " ==> Increase LAFB to at least "  + (n*(2*kl.val+ku.val+1)) + " " );
nerrs.val = nerrs.val+1;
}              // Close if()
continue forloop140;
}              // Close if()
// *
{
forloop130:
for (imat = 1; imat <= nimat; imat++) {
// *
// *                 Do the tests only if DOTYPE( IMAT ) is true.
// *
if (!dotype[(imat)- 1+ _dotype_offset])  
    continue forloop130;
// *
// *                 Skip types 2, 3, or 4 if the matrix is too small.
// *
zerot = imat >= 2 && imat <= 4;
if (zerot && n < imat-1)  
    continue forloop130;
// *
// *                 Set up parameters with DLATB4 and generate a
// *                 test matrix with DLATMS.
// *
Dlatb4.dlatb4(path,imat,n,n,type,kl,ku,anorm,mode,cndnum,dist);
rcondc = one/cndnum.val;
// *
lintest_srnamc.srnamt = "DLATMS";
Dlatms.dlatms(n,n,dist.val,iseed,0,type.val,rwork,_rwork_offset,mode.val,cndnum.val,anorm.val,kl.val,ku.val,"Z",a,_a_offset,lda,work,_work_offset,info);
// *
// *                 Check the error code from DLATMS.
// *
if (info.val != 0)  {
    Alaerh.alaerh(path,"DLATMS",info.val,0," ",n,n,kl.val,ku.val,-1,imat,nfail,nerrs,nout);
continue forloop130;
}              // Close if()
// *
// *                 For types 2, 3, and 4, zero one or more columns of
// *                 the matrix to test that INFO is returned correctly.
// *
izero = 0;
if (zerot)  {
    if (imat == 2)  {
    izero = 1;
}              // Close if()
else if (imat == 3)  {
    izero = n;
}              // Close else if()
else  {
  izero = n/2+1;
}              //  Close else.
ioff = (izero-1)*lda;
if (imat < 4)  {
    i1 = (int)(Math.max(1, ku.val+2-izero) );
i2 = (int)(Math.min(kl.val+ku.val+1, ku.val+1+(n-izero)) );
{
forloop20:
for (i = i1; i <= i2; i++) {
a[(ioff+i)- 1+ _a_offset] = zero;
Dummy.label("Ddrvgb",20);
}              //  Close for() loop. 
}
}              // Close if()
else  {
  {
forloop40:
for (j = izero; j <= n; j++) {
{
forloop30:
for (i = (int)(Math.max(1, ku.val+2-j) ); i <= Math.min(kl.val+ku.val+1, ku.val+1+(n-j)) ; i++) {
a[(ioff+i)- 1+ _a_offset] = zero;
Dummy.label("Ddrvgb",30);
}              //  Close for() loop. 
}
ioff = ioff+lda;
Dummy.label("Ddrvgb",40);
}              //  Close for() loop. 
}
}              //  Close else.
}              // Close if()
// *
// *                 Save a copy of the matrix A in ASAV.
// *
Dlacpy.dlacpy("Full",kl.val+ku.val+1,n,a,_a_offset,lda,asav,_asav_offset,lda);
// *
{
forloop120:
for (iequed = 1; iequed <= 4; iequed++) {
equed.val = equeds[(iequed)- 1];
if (iequed == 1)  {
    nfact = 3;
}              // Close if()
else  {
  nfact = 1;
}              //  Close else.
// *
{
forloop110:
for (ifact = 1; ifact <= nfact; ifact++) {
fact = facts[(ifact)- 1];
prefac = (fact.toLowerCase().charAt(0) == "F".toLowerCase().charAt(0));
nofact = (fact.toLowerCase().charAt(0) == "N".toLowerCase().charAt(0));
equil = (fact.toLowerCase().charAt(0) == "E".toLowerCase().charAt(0));
// *
if (zerot)  {
    if (prefac)  
    continue forloop110;
rcondo = zero;
rcondi = zero;
// *
}              // Close if()
else if (!nofact)  {
    // *
// *                          Compute the condition number for comparison
// *                          with the value returned by DGESVX (FACT =
// *                          'N' reuses the condition number from the
// *                          previous iteration with FACT = 'F').
// *
Dlacpy.dlacpy("Full",kl.val+ku.val+1,n,asav,_asav_offset,lda,afb,(kl.val+1)- 1+ _afb_offset,ldafb);
if (equil || iequed > 1)  {
    // *
// *                             Compute row and column scale factors to
// *                             equilibrate the matrix A.
// *
Dgbequ.dgbequ(n,n,kl.val,ku.val,afb,(kl.val+1)- 1+ _afb_offset,ldafb,s,_s_offset,s,(n+1)- 1+ _s_offset,rowcnd,colcnd,amax,info);
if (info.val == 0 && n > 0)  {
    if ((equed.val.toLowerCase().charAt(0) == "R".toLowerCase().charAt(0)))  {
    rowcnd.val = zero;
colcnd.val = one;
}              // Close if()
else if ((equed.val.toLowerCase().charAt(0) == "C".toLowerCase().charAt(0)))  {
    rowcnd.val = one;
colcnd.val = zero;
}              // Close else if()
else if ((equed.val.toLowerCase().charAt(0) == "B".toLowerCase().charAt(0)))  {
    rowcnd.val = zero;
colcnd.val = zero;
}              // Close else if()
// *
// *                                Equilibrate the matrix.
// *
Dlaqgb.dlaqgb(n,n,kl.val,ku.val,afb,(kl.val+1)- 1+ _afb_offset,ldafb,s,_s_offset,s,(n+1)- 1+ _s_offset,rowcnd.val,colcnd.val,amax.val,equed);
}              // Close if()
}              // Close if()
// *
// *                          Save the condition number of the
// *                          non-equilibrated system for use in DGET04.
// *
if (equil)  {
    roldo = rcondo;
roldi = rcondi;
}              // Close if()
// *
// *                          Compute the 1-norm and infinity-norm of A.
// *
anormo = Dlangb.dlangb("1",n,kl.val,ku.val,afb,(kl.val+1)- 1+ _afb_offset,ldafb,rwork,_rwork_offset);
anormi = Dlangb.dlangb("I",n,kl.val,ku.val,afb,(kl.val+1)- 1+ _afb_offset,ldafb,rwork,_rwork_offset);
// *
// *                          Factor the matrix A.
// *
Dgbtrf.dgbtrf(n,n,kl.val,ku.val,afb,_afb_offset,ldafb,iwork,_iwork_offset,info);
// *
// *                          Form the inverse of A.
// *
Dlaset.dlaset("Full",n,n,zero,one,work,_work_offset,ldb);
lintest_srnamc.srnamt = "DGBTRS";
Dgbtrs.dgbtrs("No transpose",n,kl.val,ku.val,n,afb,_afb_offset,ldafb,iwork,_iwork_offset,work,_work_offset,ldb,info);
// *
// *                          Compute the 1-norm condition number of A.
// *
ainvnm = Dlange.dlange("1",n,n,work,_work_offset,ldb,rwork,_rwork_offset);
if (anormo <= zero || ainvnm <= zero)  {
    rcondo = one;
}              // Close if()
else  {
  rcondo = (one/anormo)/ainvnm;
}              //  Close else.
// *
// *                          Compute the infinity-norm condition number
// *                          of A.
// *
ainvnm = Dlange.dlange("I",n,n,work,_work_offset,ldb,rwork,_rwork_offset);
if (anormi <= zero || ainvnm <= zero)  {
    rcondi = one;
}              // Close if()
else  {
  rcondi = (one/anormi)/ainvnm;
}              //  Close else.
}              // Close else if()
label50:
   Dummy.label("Ddrvgb",50);
// *
{
forloop100:
for (itran = 1; itran <= ntran; itran++) {
// *
// *                          Do for each value of TRANS.
// *
trans = transs[(itran)- 1];
if (itran == 1)  {
    rcondc = rcondo;
}              // Close if()
else  {
  rcondc = rcondi;
}              //  Close else.
// *
// *                          Restore the matrix A.
// *
Dlacpy.dlacpy("Full",kl.val+ku.val+1,n,asav,_asav_offset,lda,a,_a_offset,lda);
// *
// *                          Form an exact solution and set the right hand
// *                          side.
// *
lintest_srnamc.srnamt = "DLARHS";
Dlarhs.dlarhs(path,xtype,"Full",trans,n,n,kl.val,ku.val,nrhs,a,_a_offset,lda,xact,_xact_offset,ldb,b,_b_offset,ldb,iseed,0,info);
xtype = "C";
Dlacpy.dlacpy("Full",n,nrhs,b,_b_offset,ldb,bsav,_bsav_offset,ldb);
// *
if (nofact && itran == 1)  {
    // *
// *                             --- Test DGBSV  ---
// *
// *                             Compute the LU factorization of the matrix
// *                             and solve the system.
// *
Dlacpy.dlacpy("Full",kl.val+ku.val+1,n,a,_a_offset,lda,afb,(kl.val+1)- 1+ _afb_offset,ldafb);
Dlacpy.dlacpy("Full",n,nrhs,b,_b_offset,ldb,x,_x_offset,ldb);
// *
lintest_srnamc.srnamt = "DGBSV ";
Dgbsv.dgbsv(n,kl.val,ku.val,nrhs,afb,_afb_offset,ldafb,iwork,_iwork_offset,x,_x_offset,ldb,info);
// *
// *                             Check error code from DGBSV .
// *
if (info.val != izero)  
    Alaerh.alaerh(path,"DGBSV ",info.val,izero," ",n,n,kl.val,ku.val,nrhs,imat,nfail,nerrs,nout);
// *
// *                             Reconstruct matrix from factors and
// *                             compute residual.
// *
dgbt01_adapter(n,n,kl.val,ku.val,a,_a_offset,lda,afb,_afb_offset,ldafb,iwork,_iwork_offset,work,_work_offset,result,(1)- 1);
nt = 1;
if (izero == 0)  {
    // *
// *                                Compute residual of the computed
// *                                solution.
// *
Dlacpy.dlacpy("Full",n,nrhs,b,_b_offset,ldb,work,_work_offset,ldb);
dgbt02_adapter("No transpose",n,n,kl.val,ku.val,nrhs,a,_a_offset,lda,x,_x_offset,ldb,work,_work_offset,ldb,result,(2)- 1);
// *
// *                                Check solution from generated exact
// *                                solution.
// *
dget04_adapter(n,nrhs,x,_x_offset,ldb,xact,_xact_offset,ldb,rcondc,result,(3)- 1);
nt = 3;
}              // Close if()
// *
// *                             Print information about the tests that did
// *                             not pass the threshold.
// *
{
forloop60:
for (k = 1; k <= nt; k++) {
if (result[(k)- 1] >= thresh)  {
    if (nfail == 0 && nerrs.val == 0)  
    Aladhd.aladhd(nout,path);
System.out.println(" " + ("DGBSV ") + " "  + ", N="  + (n) + " "  + ", KL="  + (kl.val) + " "  + ", KU="  + (ku.val) + " "  + ", type "  + (imat) + " "  + ", test("  + (k) + " "  + ")="  + (result[(k)- 1]) + " " );
nfail = nfail+1;
}              // Close if()
Dummy.label("Ddrvgb",60);
}              //  Close for() loop. 
}
nrun = nrun+nt;
}              // Close if()
// *
// *                          --- Test DGBSVX ---
// *
if (!prefac)  
    Dlaset.dlaset("Full",2*kl.val+ku.val+1,n,zero,zero,afb,_afb_offset,ldafb);
Dlaset.dlaset("Full",n,nrhs,zero,zero,x,_x_offset,ldb);
if (iequed > 1 && n > 0)  {
    // *
// *                             Equilibrate the matrix if FACT = 'F' and
// *                             EQUED = 'R', 'C', or 'B'.
// *
Dlaqgb.dlaqgb(n,n,kl.val,ku.val,a,_a_offset,lda,s,_s_offset,s,(n+1)- 1+ _s_offset,rowcnd.val,colcnd.val,amax.val,equed);
}              // Close if()
// *
// *                          Solve the system and compute the condition
// *                          number and error bounds using DGBSVX.
// *
lintest_srnamc.srnamt = "DGBSVX";
Dgbsvx.dgbsvx(fact,trans,n,kl.val,ku.val,nrhs,a,_a_offset,lda,afb,_afb_offset,ldafb,iwork,_iwork_offset,equed,s,_s_offset,s,(n+1)- 1+ _s_offset,b,_b_offset,ldb,x,_x_offset,ldb,rcond,rwork,_rwork_offset,rwork,(nrhs+1)- 1+ _rwork_offset,work,_work_offset,iwork,(n+1)- 1+ _iwork_offset,info);
// *
// *                          Check the error code from DGBSVX.
// *
if (info.val != izero)  
    Alaerh.alaerh(path,"DGBSVX",info.val,izero,fact+trans,n,n,kl.val,ku.val,nrhs,imat,nfail,nerrs,nout);
// *
// *                          Compare WORK(1) from DGBSVX with the computed
// *                          reciprocal pivot growth factor RPVGRW
// *
if (info.val != 0)  {
    anrmpv = zero;
{
forloop80:
for (j = 1; j <= info.val; j++) {
{
forloop70:
for (i = (int)(Math.max(ku.val+2-j, 1) ); i <= Math.min(n+ku.val+1-j, kl.val+ku.val+1) ; i++) {
anrmpv = Math.max(anrmpv, Math.abs(a[(i+(j-1)*lda)- 1+ _a_offset])) ;
Dummy.label("Ddrvgb",70);
}              //  Close for() loop. 
}
Dummy.label("Ddrvgb",80);
}              //  Close for() loop. 
}
rpvgrw = Dlantb.dlantb("M","U","N",info.val,(int) ( Math.min(info.val-1, kl.val+ku.val) ),afb,(int)((Math.max(1, kl.val+ku.val+2-info.val) )- 1+ _afb_offset),ldafb,work,_work_offset);
if (rpvgrw == zero)  {
    rpvgrw = one;
}              // Close if()
else  {
  rpvgrw = anrmpv/rpvgrw;
}              //  Close else.
}              // Close if()
else  {
  rpvgrw = Dlantb.dlantb("M","U","N",n,kl.val+ku.val,afb,_afb_offset,ldafb,work,_work_offset);
if (rpvgrw == zero)  {
    rpvgrw = one;
}              // Close if()
else  {
  rpvgrw = Dlangb.dlangb("M",n,kl.val,ku.val,a,_a_offset,lda,work,_work_offset)/rpvgrw;
}              //  Close else.
}              //  Close else.
result[(7)- 1] = Math.abs(rpvgrw-work[(1)- 1+ _work_offset])/Math.max(work[(1)- 1+ _work_offset], rpvgrw) /Dlamch.dlamch("E");
// *
if (!prefac)  {
    // *
// *                             Reconstruct matrix from factors and
// *                             compute residual.
// *
dgbt01_adapter(n,n,kl.val,ku.val,a,_a_offset,lda,afb,_afb_offset,ldafb,iwork,_iwork_offset,work,_work_offset,result,(1)- 1);
k1 = 1;
}              // Close if()
else  {
  k1 = 2;
}              //  Close else.
// *
if (info.val == 0)  {
    trfcon = false;
// *
// *                             Compute residual of the computed solution.
// *
Dlacpy.dlacpy("Full",n,nrhs,bsav,_bsav_offset,ldb,work,_work_offset,ldb);
dgbt02_adapter(trans,n,n,kl.val,ku.val,nrhs,asav,_asav_offset,lda,x,_x_offset,ldb,work,_work_offset,ldb,result,(2)- 1);
// *
// *                             Check solution from generated exact
// *                             solution.
// *
if (nofact || (prefac && (equed.val.toLowerCase().charAt(0) == "N".toLowerCase().charAt(0))))  {
    dget04_adapter(n,nrhs,x,_x_offset,ldb,xact,_xact_offset,ldb,rcondc,result,(3)- 1);
}              // Close if()
else  {
  if (itran == 1)  {
    roldc = roldo;
}              // Close if()
else  {
  roldc = roldi;
}              //  Close else.
dget04_adapter(n,nrhs,x,_x_offset,ldb,xact,_xact_offset,ldb,roldc,result,(3)- 1);
}              //  Close else.
// *
// *                             Check the error bounds from iterative
// *                             refinement.
// *
Dgbt05.dgbt05(trans,n,kl.val,ku.val,nrhs,asav,_asav_offset,lda,b,_b_offset,ldb,x,_x_offset,ldb,xact,_xact_offset,ldb,rwork,_rwork_offset,rwork,(nrhs+1)- 1+ _rwork_offset,result,(4)- 1);
}              // Close if()
else  {
  trfcon = true;
}              //  Close else.
// *
// *                          Compare RCOND from DGBSVX with the computed
// *                          value in RCONDC.
// *
result[(6)- 1] = Dget06.dget06(rcond.val,rcondc);
// *
// *                          Print information about the tests that did
// *                          not pass the threshold.
// *
if (!trfcon)  {
    {
forloop90:
for (k = k1; k <= ntests; k++) {
if (result[(k)- 1] >= thresh)  {
    if (nfail == 0 && nerrs.val == 0)  
    Aladhd.aladhd(nout,path);
if (prefac)  {
    System.out.println(" " + ("DGBSVX") + " "  + "( \'"  + (fact) + " "  + "\',\'"  + (trans) + " "  + "\',"  + (n) + " "  + ","  + (kl.val) + " "  + ","  + (ku.val) + " "  + ",...), EQUED=\'"  + (equed.val) + " "  + "\', type "  + (imat) + " "  + ", test("  + (k) + " "  + ")="  + (result[(k)- 1]) + " " );
}              // Close if()
else  {
  System.out.println(" " + ("DGBSVX") + " "  + "( \'"  + (fact) + " "  + "\',\'"  + (trans) + " "  + "\',"  + (n) + " "  + ","  + (kl.val) + " "  + ","  + (ku.val) + " "  + ",...), type "  + (imat) + " "  + ", test("  + (k) + " "  + ")="  + (result[(k)- 1]) + " " );
}              //  Close else.
nfail = nfail+1;
}              // Close if()
Dummy.label("Ddrvgb",90);
}              //  Close for() loop. 
}
nrun = nrun+7-k1;
}              // Close if()
else  {
  if (result[(1)- 1] >= thresh && !prefac)  {
    if (nfail == 0 && nerrs.val == 0)  
    Aladhd.aladhd(nout,path);
if (prefac)  {
    System.out.println(" " + ("DGBSVX") + " "  + "( \'"  + (fact) + " "  + "\',\'"  + (trans) + " "  + "\',"  + (n) + " "  + ","  + (kl.val) + " "  + ","  + (ku.val) + " "  + ",...), EQUED=\'"  + (equed.val) + " "  + "\', type "  + (imat) + " "  + ", test("  + (1) + " "  + ")="  + (result[(1)- 1]) + " " );
}              // Close if()
else  {
  System.out.println(" " + ("DGBSVX") + " "  + "( \'"  + (fact) + " "  + "\',\'"  + (trans) + " "  + "\',"  + (n) + " "  + ","  + (kl.val) + " "  + ","  + (ku.val) + " "  + ",...), type "  + (imat) + " "  + ", test("  + (1) + " "  + ")="  + (result[(1)- 1]) + " " );
}              //  Close else.
nfail = nfail+1;
nrun = nrun+1;
}              // Close if()
if (result[(6)- 1] >= thresh)  {
    if (nfail == 0 && nerrs.val == 0)  
    Aladhd.aladhd(nout,path);
if (prefac)  {
    System.out.println(" " + ("DGBSVX") + " "  + "( \'"  + (fact) + " "  + "\',\'"  + (trans) + " "  + "\',"  + (n) + " "  + ","  + (kl.val) + " "  + ","  + (ku.val) + " "  + ",...), EQUED=\'"  + (equed.val) + " "  + "\', type "  + (imat) + " "  + ", test("  + (6) + " "  + ")="  + (result[(6)- 1]) + " " );
}              // Close if()
else  {
  System.out.println(" " + ("DGBSVX") + " "  + "( \'"  + (fact) + " "  + "\',\'"  + (trans) + " "  + "\',"  + (n) + " "  + ","  + (kl.val) + " "  + ","  + (ku.val) + " "  + ",...), type "  + (imat) + " "  + ", test("  + (6) + " "  + ")="  + (result[(6)- 1]) + " " );
}              //  Close else.
nfail = nfail+1;
nrun = nrun+1;
}              // Close if()
if (result[(7)- 1] >= thresh)  {
    if (nfail == 0 && nerrs.val == 0)  
    Aladhd.aladhd(nout,path);
if (prefac)  {
    System.out.println(" " + ("DGBSVX") + " "  + "( \'"  + (fact) + " "  + "\',\'"  + (trans) + " "  + "\',"  + (n) + " "  + ","  + (kl.val) + " "  + ","  + (ku.val) + " "  + ",...), EQUED=\'"  + (equed.val) + " "  + "\', type "  + (imat) + " "  + ", test("  + (7) + " "  + ")="  + (result[(7)- 1]) + " " );
}              // Close if()
else  {
  System.out.println(" " + ("DGBSVX") + " "  + "( \'"  + (fact) + " "  + "\',\'"  + (trans) + " "  + "\',"  + (n) + " "  + ","  + (kl.val) + " "  + ","  + (ku.val) + " "  + ",...), type "  + (imat) + " "  + ", test("  + (7) + " "  + ")="  + (result[(7)- 1]) + " " );
}              //  Close else.
nfail = nfail+1;
nrun = nrun+1;
}              // Close if()
// *
}              //  Close else.
Dummy.label("Ddrvgb",100);
}              //  Close for() loop. 
}
Dummy.label("Ddrvgb",110);
}              //  Close for() loop. 
}
Dummy.label("Ddrvgb",120);
}              //  Close for() loop. 
}
Dummy.label("Ddrvgb",130);
}              //  Close for() loop. 
}
Dummy.label("Ddrvgb",140);
}              //  Close for() loop. 
}
Dummy.label("Ddrvgb",150);
}              //  Close for() loop. 
}
Dummy.label("Ddrvgb",160);
}              //  Close for() loop. 
}
// *
// *     Print a summary of the results.
// *
Alasvm.alasvm(path,nout,nfail,nrun,nerrs.val);
// *
// *
Dummy.go_to("Ddrvgb",999999);
// *
// *     End of DDRVGB
// *
Dummy.label("Ddrvgb",999999);
return;
   }
// adapter for dgbt01
private static void dgbt01_adapter(int arg0 ,int arg1 ,int arg2 ,int arg3 ,double [] arg4 , int arg4_offset ,int arg5 ,double [] arg6 , int arg6_offset ,int arg7 ,int [] arg8 , int arg8_offset ,double [] arg9 , int arg9_offset ,double [] arg10 , int arg10_offset )
{
doubleW _f2j_tmp10 = new doubleW(arg10[arg10_offset]);

Dgbt01.dgbt01(arg0,arg1,arg2,arg3,arg4, arg4_offset,arg5,arg6, arg6_offset,arg7,arg8, arg8_offset,arg9, arg9_offset,_f2j_tmp10);

arg10[arg10_offset] = _f2j_tmp10.val;
}

// adapter for dgbt02
private static void dgbt02_adapter(String arg0 ,int arg1 ,int arg2 ,int arg3 ,int arg4 ,int arg5 ,double [] arg6 , int arg6_offset ,int arg7 ,double [] arg8 , int arg8_offset ,int arg9 ,double [] arg10 , int arg10_offset ,int arg11 ,double [] arg12 , int arg12_offset )
{
doubleW _f2j_tmp12 = new doubleW(arg12[arg12_offset]);

Dgbt02.dgbt02(arg0,arg1,arg2,arg3,arg4,arg5,arg6, arg6_offset,arg7,arg8, arg8_offset,arg9,arg10, arg10_offset,arg11,_f2j_tmp12);

arg12[arg12_offset] = _f2j_tmp12.val;
}

// adapter for dget04
private static void dget04_adapter(int arg0 ,int arg1 ,double [] arg2 , int arg2_offset ,int arg3 ,double [] arg4 , int arg4_offset ,int arg5 ,double arg6 ,double [] arg7 , int arg7_offset )
{
doubleW _f2j_tmp7 = new doubleW(arg7[arg7_offset]);

Dget04.dget04(arg0,arg1,arg2, arg2_offset,arg3,arg4, arg4_offset,arg5,arg6,_f2j_tmp7);

arg7[arg7_offset] = _f2j_tmp7.val;
}

} // End class.
