/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: lintest.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

import java.lang.*;
import org.netlib.util.*;
import org.netlib.lapack.*;




public class Derrls {

// *
// *  -- LAPACK test routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     February 29, 1992
// *
// *     .. Scalar Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DERRLS tests the error exits for the DOUBLE PRECISION least squares
// *  driver routines.
// *
// *  Arguments
// *  =========
// *
// *  PATH    (input) CHARACTER*3
// *          The LAPACK path name for the routines to be tested.
// *
// *  NUNIT   (input) INTEGER
// *          The unit number for output.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static int nmax= 2;
// *     ..
// *     .. Local Scalars ..
static String c2= new String("  ");
static intW info= new intW(0);
static intW irnk= new intW(0);
static double rcond= 0.0;
// *     ..
// *     .. Local Arrays ..
static int [] ip= new int[(nmax)];
static double [] a= new double[(nmax) * (nmax)];
static double [] b= new double[(nmax) * (nmax)];
static double [] s= new double[(nmax)];
static double [] w= new double[(nmax)];
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Scalars in Common ..
// *     ..
// *     .. Common blocks ..
// *     ..
// *     .. Executable Statements ..
// *

public static void derrls (String path,
int nunit)  {

lintest_infoc.nout_iounit_nunit = nunit;
System.out.println();
c2 = path.substring((2)-1,3);
a[(1)- 1+(1- 1)*nmax] = 1.e0;
a[(1)- 1+(2- 1)*nmax] = 2.e0;
a[(2)- 1+(2- 1)*nmax] = 3.e0;
a[(2)- 1+(1- 1)*nmax] = 4.e0;
lintest_infoc.ok.val = true;
// *
if (c2.regionMatches(true,0,"LS",0,2))  {
    // *
// *        Test error exits for the least squares driver routines.
// *
// *        DGELS
// *
lintest_srnamc.srnamt = "DGELS ";
lintest_infoc.infot = 1;
Dgels.dgels("/",0,0,0,a,0,1,b,0,1,w,0,1,info);
Chkxer.chkxer("DGELS ",lintest_infoc.infot,lintest_infoc.nout_iounit_nunit,lintest_infoc.lerr,lintest_infoc.ok);
lintest_infoc.infot = 2;
Dgels.dgels("N",-1,0,0,a,0,1,b,0,1,w,0,1,info);
Chkxer.chkxer("DGELS ",lintest_infoc.infot,lintest_infoc.nout_iounit_nunit,lintest_infoc.lerr,lintest_infoc.ok);
lintest_infoc.infot = 3;
Dgels.dgels("N",0,-1,0,a,0,1,b,0,1,w,0,1,info);
Chkxer.chkxer("DGELS ",lintest_infoc.infot,lintest_infoc.nout_iounit_nunit,lintest_infoc.lerr,lintest_infoc.ok);
lintest_infoc.infot = 4;
Dgels.dgels("N",0,0,-1,a,0,1,b,0,1,w,0,1,info);
Chkxer.chkxer("DGELS ",lintest_infoc.infot,lintest_infoc.nout_iounit_nunit,lintest_infoc.lerr,lintest_infoc.ok);
lintest_infoc.infot = 6;
Dgels.dgels("N",2,0,0,a,0,1,b,0,2,w,0,2,info);
Chkxer.chkxer("DGELS ",lintest_infoc.infot,lintest_infoc.nout_iounit_nunit,lintest_infoc.lerr,lintest_infoc.ok);
lintest_infoc.infot = 8;
Dgels.dgels("N",2,0,0,a,0,2,b,0,1,w,0,2,info);
Chkxer.chkxer("DGELS ",lintest_infoc.infot,lintest_infoc.nout_iounit_nunit,lintest_infoc.lerr,lintest_infoc.ok);
lintest_infoc.infot = 10;
Dgels.dgels("N",1,1,0,a,0,1,b,0,1,w,0,1,info);
Chkxer.chkxer("DGELS ",lintest_infoc.infot,lintest_infoc.nout_iounit_nunit,lintest_infoc.lerr,lintest_infoc.ok);
// *
// *        DGELSS
// *
lintest_srnamc.srnamt = "DGELSS";
lintest_infoc.infot = 1;
Dgelss.dgelss(-1,0,0,a,0,1,b,0,1,s,0,rcond,irnk,w,0,1,info);
Chkxer.chkxer("DGELSS",lintest_infoc.infot,lintest_infoc.nout_iounit_nunit,lintest_infoc.lerr,lintest_infoc.ok);
lintest_infoc.infot = 2;
Dgelss.dgelss(0,-1,0,a,0,1,b,0,1,s,0,rcond,irnk,w,0,1,info);
Chkxer.chkxer("DGELSS",lintest_infoc.infot,lintest_infoc.nout_iounit_nunit,lintest_infoc.lerr,lintest_infoc.ok);
lintest_infoc.infot = 3;
Dgelss.dgelss(0,0,-1,a,0,1,b,0,1,s,0,rcond,irnk,w,0,1,info);
Chkxer.chkxer("DGELSS",lintest_infoc.infot,lintest_infoc.nout_iounit_nunit,lintest_infoc.lerr,lintest_infoc.ok);
lintest_infoc.infot = 5;
Dgelss.dgelss(2,0,0,a,0,1,b,0,2,s,0,rcond,irnk,w,0,2,info);
Chkxer.chkxer("DGELSS",lintest_infoc.infot,lintest_infoc.nout_iounit_nunit,lintest_infoc.lerr,lintest_infoc.ok);
lintest_infoc.infot = 7;
Dgelss.dgelss(2,0,0,a,0,2,b,0,1,s,0,rcond,irnk,w,0,2,info);
Chkxer.chkxer("DGELSS",lintest_infoc.infot,lintest_infoc.nout_iounit_nunit,lintest_infoc.lerr,lintest_infoc.ok);
// *
// *        DGELSX
// *
lintest_srnamc.srnamt = "DGELSX";
lintest_infoc.infot = 1;
Dgelsx.dgelsx(-1,0,0,a,0,1,b,0,1,ip,0,rcond,irnk,w,0,info);
Chkxer.chkxer("DGELSX",lintest_infoc.infot,lintest_infoc.nout_iounit_nunit,lintest_infoc.lerr,lintest_infoc.ok);
lintest_infoc.infot = 2;
Dgelsx.dgelsx(0,-1,0,a,0,1,b,0,1,ip,0,rcond,irnk,w,0,info);
Chkxer.chkxer("DGELSX",lintest_infoc.infot,lintest_infoc.nout_iounit_nunit,lintest_infoc.lerr,lintest_infoc.ok);
lintest_infoc.infot = 3;
Dgelsx.dgelsx(0,0,-1,a,0,1,b,0,1,ip,0,rcond,irnk,w,0,info);
Chkxer.chkxer("DGELSX",lintest_infoc.infot,lintest_infoc.nout_iounit_nunit,lintest_infoc.lerr,lintest_infoc.ok);
lintest_infoc.infot = 5;
Dgelsx.dgelsx(2,0,0,a,0,1,b,0,2,ip,0,rcond,irnk,w,0,info);
Chkxer.chkxer("DGELSX",lintest_infoc.infot,lintest_infoc.nout_iounit_nunit,lintest_infoc.lerr,lintest_infoc.ok);
lintest_infoc.infot = 7;
Dgelsx.dgelsx(2,0,0,a,0,2,b,0,1,ip,0,rcond,irnk,w,0,info);
Chkxer.chkxer("DGELSX",lintest_infoc.infot,lintest_infoc.nout_iounit_nunit,lintest_infoc.lerr,lintest_infoc.ok);
}              // Close if()
// *
// *     Print a summary line.
// *
Alaesm.alaesm(path,lintest_infoc.ok.val,lintest_infoc.nout_iounit_nunit);
// *
Dummy.go_to("Derrls",999999);
// *
// *     End of DERRLS
// *
Dummy.label("Derrls",999999);
return;
   }
} // End class.
