/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: lintest.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

import java.lang.*;
import org.netlib.util.*;
import org.netlib.lapack.*;


import org.netlib.blas.*;


public class Dgbt02 {

// *
// *  -- LAPACK test routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     February 29, 1992
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DGBT02 computes the residual for a solution of a banded system of
// *  equations  A*x = b  or  A'*x = b:
// *     RESID = norm( B - A*X ) / ( norm(A) * norm(X) * EPS).
// *  where EPS is the machine precision.
// *
// *  Arguments
// *  =========
// *
// *  TRANS   (input) CHARACTER*1
// *          Specifies the form of the system of equations:
// *          = 'N':  A *x = b
// *          = 'T':  A'*x = b, where A' is the transpose of A
// *          = 'C':  A'*x = b, where A' is the transpose of A
// *
// *  M       (input) INTEGER
// *          The number of rows of the matrix A.  M >= 0.
// *
// *  N       (input) INTEGER
// *          The number of columns of the matrix A.  N >= 0.
// *
// *  KL      (input) INTEGER
// *          The number of subdiagonals within the band of A.  KL >= 0.
// *
// *  KU      (input) INTEGER
// *          The number of superdiagonals within the band of A.  KU >= 0.
// *
// *  NRHS    (input) INTEGER
// *          The number of columns of B.  NRHS >= 0.
// *
// *  A       (input) DOUBLE PRECISION array, dimension (LDA,N)
// *          The original matrix A in band storage, stored in rows 1 to
// *          KL+KU+1.
// *
// *  LDA     (input) INTEGER
// *          The leading dimension of the array A.  LDA >= max(1,KL+KU+1).
// *
// *  X       (input) DOUBLE PRECISION array, dimension (LDX,NRHS)
// *          The computed solution vectors for the system of linear
// *          equations.
// *
// *  LDX     (input) INTEGER
// *          The leading dimension of the array X.  If TRANS = 'N',
// *          LDX >= max(1,N); if TRANS = 'T' or 'C', LDX >= max(1,M).
// *
// *  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
// *          On entry, the right hand side vectors for the system of
// *          linear equations.
// *          On exit, B is overwritten with the difference B - A*X.
// *
// *  LDB     (input) INTEGER
// *          The leading dimension of the array B.  IF TRANS = 'N',
// *          LDB >= max(1,M); if TRANS = 'T' or 'C', LDB >= max(1,N).
// *
// *  RESID   (output) DOUBLE PRECISION
// *          The maximum over the number of right hand sides of
// *          norm(B - A*X) / ( norm(A) * norm(X) * EPS ).
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e+0;
static double one= 1.0e+0;
// *     ..
// *     .. Local Scalars ..
static int i1= 0;
static int i2= 0;
static int j= 0;
static int kd= 0;
static int n1= 0;
static double anorm= 0.0;
static double bnorm= 0.0;
static double eps= 0.0;
static double xnorm= 0.0;
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Quick return if N = 0 pr NRHS = 0
// *

public static void dgbt02 (String trans,
int m,
int n,
int kl,
int ku,
int nrhs,
double [] a, int _a_offset,
int lda,
double [] x, int _x_offset,
int ldx,
double [] b, int _b_offset,
int ldb,
doubleW resid)  {

if (m <= 0 || n <= 0 || nrhs <= 0)  {
    resid.val = zero;
Dummy.go_to("Dgbt02",999999);
}              // Close if()
// *
// *     Exit with RESID = 1/EPS if ANORM = 0.
// *
eps = Dlamch.dlamch("Epsilon");
kd = ku+1;
anorm = zero;
{
forloop10:
for (j = 1; j <= n; j++) {
i1 = (int)(Math.max(kd+1-j, 1) );
i2 = (int)(Math.min(kd+m-j, kl+kd) );
anorm = Math.max(anorm, Dasum.dasum(i2-i1+1,a,(i1)- 1+(j- 1)*lda+ _a_offset,1)) ;
Dummy.label("Dgbt02",10);
}              //  Close for() loop. 
}
if (anorm <= zero)  {
    resid.val = one/eps;
Dummy.go_to("Dgbt02",999999);
}              // Close if()
// *
if ((trans.toLowerCase().charAt(0) == "T".toLowerCase().charAt(0)) || (trans.toLowerCase().charAt(0) == "C".toLowerCase().charAt(0)))  {
    n1 = n;
}              // Close if()
else  {
  n1 = m;
}              //  Close else.
// *
// *     Compute  B - A*X (or  B - A'*X )
// *
{
forloop20:
for (j = 1; j <= nrhs; j++) {
Dgbmv.dgbmv(trans,m,n,kl,ku,-one,a,_a_offset,lda,x,(1)- 1+(j- 1)*ldx+ _x_offset,1,one,b,(1)- 1+(j- 1)*ldb+ _b_offset,1);
Dummy.label("Dgbt02",20);
}              //  Close for() loop. 
}
// *
// *     Compute the maximum over the number of right hand sides of
// *        norm(B - A*X) / ( norm(A) * norm(X) * EPS ).
// *
resid.val = zero;
{
forloop30:
for (j = 1; j <= nrhs; j++) {
bnorm = Dasum.dasum(n1,b,(1)- 1+(j- 1)*ldb+ _b_offset,1);
xnorm = Dasum.dasum(n1,x,(1)- 1+(j- 1)*ldx+ _x_offset,1);
if (xnorm <= zero)  {
    resid.val = one/eps;
}              // Close if()
else  {
  resid.val = Math.max(resid.val, ((bnorm/anorm)/xnorm)/eps) ;
}              //  Close else.
Dummy.label("Dgbt02",30);
}              //  Close for() loop. 
}
// *
Dummy.go_to("Dgbt02",999999);
// *
// *     End of DGBT02
// *
Dummy.label("Dgbt02",999999);
return;
   }
} // End class.
