/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: lintest.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

import java.lang.*;
import org.netlib.util.*;
import org.netlib.lapack.*;


import org.netlib.blas.*;


public class Dgtt02 {

// *
// *  -- LAPACK test routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     February 29, 1992
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DGTT02 computes the residual for the solution to a tridiagonal
// *  system of equations:
// *     RESID = norm(B - op(A)*X) / (norm(A) * norm(X) * EPS),
// *  where EPS is the machine epsilon.
// *
// *  Arguments
// *  =========
// *
// *  TRANS   (input) CHARACTER
// *          Specifies the form of the residual.
// *          = 'N':  B - A * X  (No transpose)
// *          = 'T':  B - A'* X  (Transpose)
// *          = 'C':  B - A'* X  (Conjugate transpose = Transpose)
// *
// *  N       (input) INTEGTER
// *          The order of the matrix A.  N >= 0.
// *
// *  NRHS    (input) INTEGER
// *          The number of right hand sides, i.e., the number of columns
// *          of the matrices B and X.  NRHS >= 0.
// *
// *  DL      (input) DOUBLE PRECISION array, dimension (N-1)
// *          The (n-1) sub-diagonal elements of A.
// *
// *  D       (input) DOUBLE PRECISION array, dimension (N)
// *          The diagonal elements of A.
// *
// *  DU      (input) DOUBLE PRECISION array, dimension (N-1)
// *          The (n-1) super-diagonal elements of A.
// *
// *  X       (input) DOUBLE PRECISION array, dimension (LDX,NRHS)
// *          The computed solution vectors X.
// *
// *  LDX     (input) INTEGER
// *          The leading dimension of the array X.  LDX >= max(1,N).
// *
// *  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
// *          On entry, the right hand side vectors for the system of
// *          linear equations.
// *          On exit, B is overwritten with the difference B - op(A)*X.
// *
// *  LDB     (input) INTEGER
// *          The leading dimension of the array B.  LDB >= max(1,N).
// *
// *  RWORK   (workspace) DOUBLE PRECISION array, dimension (N)
// *
// *  RESID   (output) DOUBLE PRECISION
// *          norm(B - op(A)*X) / (norm(A) * norm(X) * EPS)
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double one= 1.0e+0;
static double zero= 0.0e+0;
// *     ..
// *     .. Local Scalars ..
static int j= 0;
static double anorm= 0.0;
static double bnorm= 0.0;
static double eps= 0.0;
static double xnorm= 0.0;
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
// *     Quick exit if N = 0 or NRHS = 0
// *

public static void dgtt02 (String trans,
int n,
int nrhs,
double [] dl, int _dl_offset,
double [] d, int _d_offset,
double [] du, int _du_offset,
double [] x, int _x_offset,
int ldx,
double [] b, int _b_offset,
int ldb,
double [] rwork, int _rwork_offset,
doubleW resid)  {

resid.val = zero;
if (n <= 0 || nrhs == 0)  
    Dummy.go_to("Dgtt02",999999);
// *
// *     Compute the maximum over the number of right hand sides of
// *        norm(B - op(A)*X) / ( norm(A) * norm(X) * EPS ).
// *
if ((trans.toLowerCase().charAt(0) == "N".toLowerCase().charAt(0)))  {
    anorm = Dlangt.dlangt("1",n,dl,_dl_offset,d,_d_offset,du,_du_offset);
}              // Close if()
else  {
  anorm = Dlangt.dlangt("I",n,dl,_dl_offset,d,_d_offset,du,_du_offset);
}              //  Close else.
// *
// *     Exit with RESID = 1/EPS if ANORM = 0.
// *
eps = Dlamch.dlamch("Epsilon");
if (anorm <= zero)  {
    resid.val = one/eps;
Dummy.go_to("Dgtt02",999999);
}              // Close if()
// *
// *     Compute B - op(A)*X.
// *
Dlagtm.dlagtm(trans,n,nrhs,-one,dl,_dl_offset,d,_d_offset,du,_du_offset,x,_x_offset,ldx,one,b,_b_offset,ldb);
// *
{
forloop10:
for (j = 1; j <= nrhs; j++) {
bnorm = Dasum.dasum(n,b,(1)- 1+(j- 1)*ldb+ _b_offset,1);
xnorm = Dasum.dasum(n,x,(1)- 1+(j- 1)*ldx+ _x_offset,1);
if (xnorm <= zero)  {
    resid.val = one/eps;
}              // Close if()
else  {
  resid.val = Math.max(resid.val, ((bnorm/anorm)/xnorm)/eps) ;
}              //  Close else.
Dummy.label("Dgtt02",10);
}              //  Close for() loop. 
}
// *
Dummy.go_to("Dgtt02",999999);
// *
// *     End of DGTT02
// *
Dummy.label("Dgtt02",999999);
return;
   }
} // End class.
