/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: lintest.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

import java.lang.*;
import org.netlib.util.*;
import org.netlib.lapack.*;


import org.netlib.blas.*;


public class Dlaror {

// *
// *  -- LAPACK auxiliary test routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DLAROR pre- or post-multiplies an M by N matrix A by a random
// *  orthogonal matrix U, overwriting A.  A may optionally be initialized
// *  to the identity matrix before multiplying by U.  U is generated using
// *  the method of G.W. Stewart (SIAM J. Numer. Anal. 17, 1980, 403-409).
// *
// *  Arguments
// *  =========
// *
// *  SIDE    (input) CHARACTER*1
// *          Specifies whether A is multiplied on the left or right by U.
// *          = 'L':         Multiply A on the left (premultiply) by U
// *          = 'R':         Multiply A on the right (postmultiply) by U'
// *          = 'C' or 'T':  Multiply A on the left by U and the right
// *                          by U' (Here, U' means U-transpose.)
// *
// *  INIT    (input) CHARACTER*1
// *          Specifies whether or not A should be initialized to the
// *          identity matrix.
// *          = 'I':  Initialize A to (a section of) the identity matrix
// *                   before applying U.
// *          = 'N':  No initialization.  Apply U to the input matrix A.
// *
// *          INIT = 'I' may be used to generate square or rectangular
// *          orthogonal matrices:
// *
// *          For M = N and SIDE = 'L' or 'R', the rows will be orthogonal
// *          to each other, as will the columns.
// *
// *          If M < N, SIDE = 'R' produces a dense matrix whose rows are
// *          orthogonal and whose columns are not, while SIDE = 'L'
// *          produces a matrix whose rows are orthogonal, and whose first
// *          M columns are orthogonal, and whose remaining columns are
// *          zero.
// *
// *          If M > N, SIDE = 'L' produces a dense matrix whose columns
// *          are orthogonal and whose rows are not, while SIDE = 'R'
// *          produces a matrix whose columns are orthogonal, and whose
// *          first M rows are orthogonal, and whose remaining rows are
// *          zero.
// *
// *  M       (input) INTEGER
// *          The number of rows of A.
// *
// *  N       (input) INTEGER
// *          The number of columns of A.
// *
// *  A       (input/output) DOUBLE PRECISION array, dimension (LDA, N)
// *          On entry, the array A.
// *          On exit, overwritten by U A ( if SIDE = 'L' ),
// *           or by A U ( if SIDE = 'R' ),
// *           or by U A U' ( if SIDE = 'C' or 'T').
// *
// *  LDA     (input) INTEGER
// *          The leading dimension of the array A.  LDA >= max(1,M).
// *
// *  ISEED   (input/output) INTEGER array, dimension (4)
// *          On entry ISEED specifies the seed of the random number
// *          generator. The array elements should be between 0 and 4095;
// *          if not they will be reduced mod 4096.  Also, ISEED(4) must
// *          be odd.  The random number generator uses a linear
// *          congruential sequence limited to small integers, and so
// *          should produce machine independent random numbers. The
// *          values of ISEED are changed on exit, and can be used in the
// *          next call to DLAROR to continue the same random number
// *          sequence.
// *
// *  X       (workspace) DOUBLE PRECISION array, dimension (3*MAX( M, N ))
// *          Workspace of length
// *              2*M + N if SIDE = 'L',
// *              2*N + M if SIDE = 'R',
// *              3*N     if SIDE = 'C' or 'T'.
// *
// *  INFO    (output) INTEGER
// *          An error flag.  It is set to:
// *          = 0:  normal return
// *          < 0:  if INFO = -k, the k-th argument had an illegal value
// *          = 1:  if the random numbers generated by DLARND are bad.
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e+0;
static double one= 1.0e+0;
static double toosml= 1.0e-20;
// *     ..
// *     .. Local Scalars ..
static int irow= 0;
static int itype= 0;
static int ixfrm= 0;
static int j= 0;
static int jcol= 0;
static int kbeg= 0;
static int nxfrm= 0;
static double factor= 0.0;
static double xnorm= 0.0;
static double xnorms= 0.0;
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *

public static void dlaror (String side,
String init,
int m,
int n,
double [] a, int _a_offset,
int lda,
int [] iseed, int _iseed_offset,
double [] x, int _x_offset,
intW info)  {

if (n == 0 || m == 0)  
    Dummy.go_to("Dlaror",999999);
// *
itype = 0;
if ((side.toLowerCase().charAt(0) == "L".toLowerCase().charAt(0)))  {
    itype = 1;
}              // Close if()
else if ((side.toLowerCase().charAt(0) == "R".toLowerCase().charAt(0)))  {
    itype = 2;
}              // Close else if()
else if ((side.toLowerCase().charAt(0) == "C".toLowerCase().charAt(0)) || (side.toLowerCase().charAt(0) == "T".toLowerCase().charAt(0)))  {
    itype = 3;
}              // Close else if()
// *
// *     Check for argument errors.
// *
info.val = 0;
if (itype == 0)  {
    info.val = -1;
}              // Close if()
else if (m < 0)  {
    info.val = -3;
}              // Close else if()
else if (n < 0 || (itype == 3 && n != m))  {
    info.val = -4;
}              // Close else if()
else if (lda < m)  {
    info.val = -6;
}              // Close else if()
if (info.val != 0)  {
    Xerbla.xerbla("DLAROR",-info.val);
Dummy.go_to("Dlaror",999999);
}              // Close if()
// *
if (itype == 1)  {
    nxfrm = m;
}              // Close if()
else  {
  nxfrm = n;
}              //  Close else.
// *
// *     Initialize A to the identity matrix if desired
// *
if ((init.toLowerCase().charAt(0) == "I".toLowerCase().charAt(0)))  
    Dlaset.dlaset("Full",m,n,zero,one,a,_a_offset,lda);
// *
// *     If no rotation possible, multiply by random +/-1
// *
// *     Compute rotation by computing Householder transformations
// *     H(2), H(3), ..., H(nhouse)
// *
{
forloop10:
for (j = 1; j <= nxfrm; j++) {
x[(j)- 1+ _x_offset] = zero;
Dummy.label("Dlaror",10);
}              //  Close for() loop. 
}
// *
{
forloop30:
for (ixfrm = 2; ixfrm <= nxfrm; ixfrm++) {
kbeg = nxfrm-ixfrm+1;
// *
// *        Generate independent normal( 0, 1 ) random numbers
// *
{
forloop20:
for (j = kbeg; j <= nxfrm; j++) {
x[(j)- 1+ _x_offset] = Dlarnd.dlarnd(3,iseed,_iseed_offset);
Dummy.label("Dlaror",20);
}              //  Close for() loop. 
}
// *
// *        Generate a Householder transformation from the random vector X
// *
xnorm = Dnrm2.dnrm2(ixfrm,x,(kbeg)- 1+ _x_offset,1);
xnorms = ((x[(kbeg)- 1+ _x_offset]) >= 0 ? Math.abs(xnorm) : -Math.abs(xnorm));
x[(kbeg+nxfrm)- 1+ _x_offset] = ((-x[(kbeg)- 1+ _x_offset]) >= 0 ? Math.abs(one) : -Math.abs(one));
factor = xnorms*(xnorms+x[(kbeg)- 1+ _x_offset]);
if (Math.abs(factor) < toosml)  {
    info.val = 1;
Xerbla.xerbla("DLAROR",info.val);
Dummy.go_to("Dlaror",999999);
}              // Close if()
else  {
  factor = one/factor;
}              //  Close else.
x[(kbeg)- 1+ _x_offset] = x[(kbeg)- 1+ _x_offset]+xnorms;
// *
// *        Apply Householder transformation to A
// *
if (itype == 1 || itype == 3)  {
    // *
// *           Apply H(k) from the left.
// *
Dgemv.dgemv("T",ixfrm,n,one,a,(kbeg)- 1+(1- 1)*lda+ _a_offset,lda,x,(kbeg)- 1+ _x_offset,1,zero,x,(2*nxfrm+1)- 1+ _x_offset,1);
Dger.dger(ixfrm,n,-factor,x,(kbeg)- 1+ _x_offset,1,x,(2*nxfrm+1)- 1+ _x_offset,1,a,(kbeg)- 1+(1- 1)*lda+ _a_offset,lda);
// *
}              // Close if()
// *
if (itype == 2 || itype == 3)  {
    // *
// *           Apply H(k) from the right.
// *
Dgemv.dgemv("N",m,ixfrm,one,a,(1)- 1+(kbeg- 1)*lda+ _a_offset,lda,x,(kbeg)- 1+ _x_offset,1,zero,x,(2*nxfrm+1)- 1+ _x_offset,1);
Dger.dger(m,ixfrm,-factor,x,(2*nxfrm+1)- 1+ _x_offset,1,x,(kbeg)- 1+ _x_offset,1,a,(1)- 1+(kbeg- 1)*lda+ _a_offset,lda);
// *
}              // Close if()
Dummy.label("Dlaror",30);
}              //  Close for() loop. 
}
// *
x[(2*nxfrm)- 1+ _x_offset] = ((Dlarnd.dlarnd(3,iseed,_iseed_offset)) >= 0 ? Math.abs(one) : -Math.abs(one));
// *
// *     Scale the matrix A by D.
// *
if (itype == 1 || itype == 3)  {
    {
forloop40:
for (irow = 1; irow <= m; irow++) {
Dscal.dscal(n,x[(nxfrm+irow)- 1+ _x_offset],a,(irow)- 1+(1- 1)*lda+ _a_offset,lda);
Dummy.label("Dlaror",40);
}              //  Close for() loop. 
}
}              // Close if()
// *
if (itype == 2 || itype == 3)  {
    {
forloop50:
for (jcol = 1; jcol <= n; jcol++) {
Dscal.dscal(m,x[(nxfrm+jcol)- 1+ _x_offset],a,(1)- 1+(jcol- 1)*lda+ _a_offset,1);
Dummy.label("Dlaror",50);
}              //  Close for() loop. 
}
}              // Close if()
Dummy.go_to("Dlaror",999999);
// *
// *     End of DLAROR
// *
Dummy.label("Dlaror",999999);
return;
   }
} // End class.
