/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: lintest.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

import java.lang.*;
import org.netlib.util.*;
import org.netlib.lapack.*;




public class Dtzt02 {

// *
// *  -- LAPACK test routine (version 2.0) --
// *     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
// *     Courant Institute, Argonne National Lab, and Rice University
// *     September 30, 1994
// *
// *     .. Scalar Arguments ..
// *     ..
// *     .. Array Arguments ..
// *     ..
// *
// *  Purpose
// *  =======
// *
// *  DTZT02 returns
// *       || I - Q'*Q || / ( M * eps)
// *  where the matrix Q is defined by the Householder transformations
// *  generated by DTZRQF.
// *
// *  Arguments
// *  =========
// *
// *  M       (input) INTEGER
// *          The number of rows of the matrix AF.
// *
// *  N       (input) INTEGER
// *          The number of columns of the matrix AF.
// *
// *  AF      (input) DOUBLE PRECISION array, dimension (LDA,N)
// *          The output of DTZRQF.
// *
// *  LDA     (input) INTEGER
// *          The leading dimension of the array AF.
// *
// *  TAU     (input) DOUBLE PRECISION array, dimension (M)
// *          Details of the Householder transformations as returned by
// *          DTZRQF.
// *
// *  WORK    (workspace) DOUBLE PRECISION array, dimension (LWORK)
// *
// *  LWORK   (input) INTEGER
// *          length of WORK array. Must be >= N*N+N
// *
// *  =====================================================================
// *
// *     .. Parameters ..
static double zero= 0.0e0;
static double one= 1.0e0;
// *     ..
// *     .. Local Scalars ..
static int i= 0;
// *     ..
// *     .. Local Arrays ..
static double [] rwork= new double[(1)];
// *     ..
// *     .. External Functions ..
// *     ..
// *     .. External Subroutines ..
// *     ..
// *     .. Intrinsic Functions ..
// *     ..
// *     .. Executable Statements ..
// *
static double dtzt02 = 0.0;


public static double dtzt02 (int m,
int n,
double [] af, int _af_offset,
int lda,
double [] tau, int _tau_offset,
double [] work, int _work_offset,
int lwork)  {

dtzt02 = zero;
// *
if (lwork < n*n+n)  {
    Xerbla.xerbla("DTZT02",7);
Dummy.go_to("Dtzt02",999999);
}              // Close if()
// *
// *     Quick return if possible
// *
if (m <= 0 || n <= 0)  
    Dummy.go_to("Dtzt02",999999);
// *
// *     Q := I
// *
Dlaset.dlaset("Full",n,n,zero,one,work,_work_offset,n);
// *
// *     Q := P(1) * ... * P(m) * Q
// *
{
int _i_inc = -1;
forloop10:
for (i = m; (_i_inc < 0) ? i >= 1 : i <= 1; i += _i_inc) {
Dlatzm.dlatzm("Left",n-m+1,n,af,(i)- 1+(m+1- 1)*lda+ _af_offset,lda,tau[(i)- 1+ _tau_offset],work,(i)- 1+ _work_offset,work,(m+1)- 1+ _work_offset,n,work,(n*n+1)- 1+ _work_offset);
Dummy.label("Dtzt02",10);
}              //  Close for() loop. 
}
// *
// *     Q := P(m) * ... * P(1) * Q
// *
{
forloop20:
for (i = 1; i <= m; i++) {
Dlatzm.dlatzm("Left",n-m+1,n,af,(i)- 1+(m+1- 1)*lda+ _af_offset,lda,tau[(i)- 1+ _tau_offset],work,(i)- 1+ _work_offset,work,(m+1)- 1+ _work_offset,n,work,(n*n+1)- 1+ _work_offset);
Dummy.label("Dtzt02",20);
}              //  Close for() loop. 
}
// *
// *     Q := Q - I
// *
{
forloop30:
for (i = 1; i <= n; i++) {
work[((i-1)*n+i)- 1+ _work_offset] = work[((i-1)*n+i)- 1+ _work_offset]-one;
Dummy.label("Dtzt02",30);
}              //  Close for() loop. 
}
// *
dtzt02 = Dlange.dlange("One-norm",n,n,work,_work_offset,n,rwork,0)/(Dlamch.dlamch("Epsilon")*(double)(Math.max(m, n) ));
Dummy.go_to("Dtzt02",999999);
// *
// *     End of DTZT02
// *
Dummy.label("Dtzt02",999999);
return dtzt02;
   }
} // End class.
